/***************************************************************************
                          dialegfourier.h  -  description
                             -------------------
    begin                : vie nov 21 2003
    copyright            : (C) 2003 by projecte
    email                : projecte@localhost.localdomain
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DIALEGFOURIER_H
#define DIALEGFOURIER_H

#include <qdialog.h>
#include <qradiobutton.h>
#include <qpushbutton.h>
#include <qbuttongroup.h>
#include <qcheckbox.h>
#include <qlistbox.h>
#include <qlineedit.h>
#include <qlabel.h>

#include "../Forma/Fourier/fourier.h"
#include "../imatge.h"
#include "../Forma/forma.h"
#include "../caractdoc.h"
//#include "caract/pgAccess/pgacces.h"
#include "caract/pgAccess/llistaid.h"
#include <qmessagebox.h> 

#include "libpq++.h"


#define dbName "host=localhost dbname=Rec_Forma user=postgres password=postgres"

#define MAX_FIG_DIF 200



/**
  *@author projecte
  */

class DialegFourier : public QDialog  {
  Q_OBJECT
public: 
	DialegFourier(Imatge &i,  QList<CaractDoc> &pDocList, int area, char* inicial);
	~DialegFourier();
   //inicialitza els parametres quan no es crida el constructor
   void InitDialeg (Imatge &i,  QList<CaractDoc> &pDocList, int area, char *inicial);


private slots:
    void slotBotoOK();
    void slotBotoCANCEL();
    void slotValorEntrat();
    void slotUpdateEntrada(int);
    void slotUpdateFFT(int);
    void slotUpdateAfegeix(int);
    void slotUpdateComparar(int a);
    void slotRec(int a);
//    void slotSeleccionenDos(int);
    void slotSeleccionenDos(int button, QListBoxItem * item, const QPoint & pos);

private:
  bool Inicialitza();

  
  QPushButton *botoOk;
  QPushButton *botoCancel;
  
  QString AltresCaracteristiques (Imatge &im);

public:
  QButtonGroup *GrupMetode;
     QRadioButton *OpcioFourier1;
     QRadioButton *OpcioFourier2;
     

     QCheckBox *OpcioEquidistants;
     QCheckBox *OpcioFFT;
     QLineEdit *EntradaPas;
     QLabel *Etiqueta;

     
  QButtonGroup*GrupCaract;
      QCheckBox *OpcioArea;
      QCheckBox *OpcioPerimetre;
      QCheckBox *OpcioMinRectangle;
      QCheckBox *OpcioCompactnes;
      QCheckBox *OpcioLength;
      QCheckBox *OpcioBreadth;
      QCheckBox *OpcioElongation;   
      QCheckBox *OpcioCentreGravetat;


  QButtonGroup *GrupBD;
      QCheckBox *OpcioAfegeix;
      QLabel *EtiquetaNom;
      QLineEdit *nom;    //nom de la figura
                         
  QListBox *Finestres;
      QCheckBox *OpcioComparar;
      int totals;

  QButtonGroup *GrupReconeixement;
      QCheckBox *OpcioRec;
      QCheckBox *OpcioCBIR;
      QLineEdit *MesSemblants;
      QCheckBox *OpcioRecFF;
      
   QButtonGroup *GrupTipus;      //Opcions omplir BD
      QRadioButton *OpcioMamo;
      QRadioButton *OpcioSintet;
      QRadioButton *OpcioFurqui;


   QButtonGroup *GrupTipus1;   //Opcions Consultar BD
      QRadioButton *OpcioMamo1;
      QRadioButton *OpcioSintet1;
      QRadioButton *OpcioFurqui1;

   QButtonGroup *GrupTipus2;   //Opcions Consultar BD
      QRadioButton *OpcioMamo2;
      QRadioButton *OpcioSintet2;
      QRadioButton *OpcioFurqui2;

      
   bool afegir;
   Fourier *formaF;

private:
    Imatge *img;

public:
  int ObtenirMode();
  forma *f;
  bool CANCELAR, COMPARAR;
  QList<CaractDoc> *pDoc;
  double ff;
  int area;
  int tipus;      //mamo = 0, sintetica = 1, altres = 2, cap seleccionat = -1
  char *inicial;
  int conta;
  CaractDoc *docs[2];   //hi ha la referencia dels dos nous documents creats resultat d fer la comparacio
};

#endif
