/***************************************************************************
                          dialegmanauto.cpp  -  description
                             -------------------
    begin                : lun nov 10 2003
    copyright            : (C) 2003 by projecte
    email                : projecte@localhost.localdomain
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "dialegmanauto.h"


#define MAX_MODUL 1443
#define MAX_FASE 158
#define LLINDAR 1
#define MAX_FIG_DIF 200
                              //158     
DialegManAuto::DialegManAuto(Imatge &i, char *inicial, char *path):QDialog (0, 0, FALSE, WStyle_Customize | WType_Dialog | WStyle_Title | WStyle_DialogBorder){   
  bool accepta;
                                              
  //inicialitzem les variables dinamiques
  f=NULL;
  formaC=NULL;
  llistadiferents=NULL;
  this->path=NULL;
  dataCH=NULL;
  llista_dist=NULL;
  caracSelec=NULL;
  
  img=&i;
  rimg = new rmImage;
  this->inicial=inicial;
  this->path=path;


  *rimg=img->imatge;
  rimg->escalaGris();
  img->sobel(*rimg);     //genera els moduls i les fases
  img->RecorreAntihorariSobel();    //munta una llista amb els moduls, fases i coordenades del contorn

                         //490
  setFixedSize (650,350);
  setCaption("Metode de Chang");
  accepta = Inicialitza();
  if (!accepta) close();
}

DialegManAuto::DialegManAuto():QDialog (0, 0, FALSE, WStyle_Customize | WType_Dialog | WStyle_Title | WStyle_DialogBorder){
}

//Allibera l'espai reservat per si el vol operar sense alliberar el dialeg
void DialegManAuto::InitDialeg(Imatge &i, char *inicial, char *path){
  //Configuracio per defecte de l'aparena
  GrupPrincipal->setDisabled(FALSE);
   OpcioAuto->setChecked(TRUE);

  GrupBarretaSliderF->setDisabled(FALSE);
   barretaF->setValue(MAX_FASE);
   entradaF->setValue (MAX_FASE);
  

  GrupBD->setDisabled (FALSE);

  MesSemblants->setDisabled (TRUE);

  GrupReconeixement->setDisabled(FALSE);
   OpcioCBIR->setChecked(FALSE);
   OpcioRec->setChecked(FALSE);

  GrupTipus1->setDisabled(true);
   OpcioFurqui1->setChecked(false);
   OpcioMamo1->setChecked (false);
   OpcioSintet1->setChecked (false);
  GrupTipus2->setDisabled(true);
   OpcioFurqui2->setChecked(false);
   OpcioMamo2->setChecked (false);
   OpcioSintet2->setChecked (false);
  GrupTipus->setDisabled(TRUE);
   OpcioFurqui->setChecked(false);
   OpcioMamo->setChecked (false);
   OpcioSintet->setChecked (false);
   
  
  OpcioAfegeix->setChecked(FALSE);
  
  //Desactivem les altres caracteristiques
  GrupCaract->setDisabled (FALSE);
    OpcioArea->setChecked(FALSE);
    OpcioPerimetre->setChecked(FALSE);
    OpcioMinRectangle->setChecked(FALSE);
    OpcioCompactnes->setChecked(FALSE);
    OpcioLength->setChecked(FALSE);
    OpcioBreadth->setChecked(FALSE);
    OpcioElongation->setChecked(FALSE);
    OpcioCentreGravetat->setChecked(FALSE);

  if (f!=NULL){
   delete f;
   f=NULL;
  }

  if (formaC!=NULL){
   delete formaC;
   formaC=NULL;
  }

  if (this->path!=NULL){
//   delete this->path;
   this->path=NULL;
  }

  if (caracSelec!=NULL){
   delete caracSelec;
   caracSelec=NULL;
  }

  if (llistadiferents!=NULL){
   while (llistadiferents->first()!=NULL)
      llistadiferents->removeFirst();
   delete llistadiferents;
   llistadiferents=NULL;
  }

  if (dataCH!=NULL){
   delete dataCH;
   dataCH=NULL;
  }

  if (llista_dist!=NULL){
   while (llista_dist->first()!=NULL)
      llista_dist->removeFirst();
   delete llista_dist;
   llista_dist=NULL;
  }

  img=&i;
  rimg = new rmImage;
  this->inicial=inicial;
  nom->setText (inicial);
  this->path=path;

  *rimg=img->imatge;
  rimg->escalaGris();
  img->sobel(*rimg);     //genera els moduls i les fases
  img->RecorreAntihorariSobel();    //munta una llista amb els moduls, fases i coordenades del contorn

  img->dw->EsborrarLlista();
  
}

DialegManAuto::~DialegManAuto(){

  if (f!=NULL)
   delete f;

  if (formaC!=NULL)
   delete formaC;

  if (path!=NULL)
   delete path;

  if (caracSelec!=NULL)
   delete caracSelec;

  if (llistadiferents!=NULL){
   while (llistadiferents->first()!=NULL)
      llistadiferents->removeFirst();
   delete llistadiferents;
  }

  if (dataCH!=NULL)
   delete dataCH;

  if (llista_dist!=NULL){
   while (llista_dist->first()!=NULL)
      llista_dist->removeFirst();
   delete llista_dist;
  }
   
  

  delete rimg;
  delete img->InfoPunt;   //espai reservat al constructor amb tots els valors de sobel (modul + fase)
   
  delete botoOk;
  delete botoCancel;

  delete GrupPrincipal;
      delete OpcioManual;
      delete OpcioAuto;
      delete OpcioSusana;

  delete GrupMetode;
      delete OpcioChang;


//  delete GrupBarretaSliderM;
//      delete barretaM;
//      delete entradaM;

  delete GrupBarretaSliderF;
      delete barretaF;
      delete entradaF;

  delete GrupCaract;
      delete OpcioArea;
      delete OpcioPerimetre;
      delete OpcioMinRectangle;
      delete OpcioCompactnes;
      delete OpcioLength;
      delete OpcioBreadth;
      delete OpcioElongation;
      delete OpcioCentreGravetat;

   delete GrupBD;
      delete OpcioAfegeix;
      delete EtiquetaNom;
      delete nom;    //nom de la figura

   delete GrupReconeixement;
      delete OpcioRec;
      delete OpcioCBIR;
      delete MesSemblants;

   delete GrupTipus;      //Opcions omplir BD
      delete OpcioMamo;
      delete OpcioSintet;
      delete OpcioFurqui;



   delete GrupTipus1;   //Opcions Consultar BD
      delete OpcioMamo1;
      delete OpcioSintet1;
      delete OpcioFurqui1;


   delete GrupTipus2;   //Opcions Consultar BD
      delete OpcioMamo2;
      delete OpcioSintet2;
      delete OpcioFurqui2;
}

void DialegManAuto::slotUpdateOpcio(int opcio){
   if (!OpcioAfegeix->isChecked()){
      if (opcio==0){    //opcio manual
         barretaF->setDisabled(TRUE);
         entradaF->setDisabled(TRUE);
//         barretaM->setDisabled(TRUE);
//         entradaM->setDisabled(TRUE);
         img->dw->AgafoPunts=TRUE;
         img->dw->EsborrarLlista();
         QMessageBox::critical (this, tr("Selecciona el punts"), tr("Selecciona els punts a la imatge. Escull el metode i prem ACCEPTAR"));
         }
      else if (opcio==1){   //Opcio SUSAN
         int total_corners, i;
         coordenades *c;

         barretaF->setDisabled(TRUE);
         entradaF->setDisabled(TRUE);
//         barretaM->setDisabled(TRUE);
//         entradaM->setDisabled(TRUE);
         img->dw->AgafoPunts=FALSE;

         img->dw->EsborrarLlista();           //20
         img->imatge.setup_brightness_lut(LLINDAR);     //un es el treshold
         total_corners=img->imatge.susan_corners();


         c = new coordenades;
         for (i=0;i<total_corners;i++){
            c->X=img->imatge.corner_list[i].x;
            c->Y=img->imatge.corner_list[i].y;
            img->dw->llista->prepend(c);
            c = new coordenades;
            }

         c->X=-1;
         img->dw->llista->append(c);
         img->dw->update();
         }
      else if (opcio==2){  //opcio automatica
         barretaF->setDisabled(FALSE);
         entradaF->setDisabled(FALSE);
//         barretaM->setDisabled(FALSE);
//         entradaM->setDisabled(FALSE);
         img->dw->AgafoPunts=FALSE;
      }
   }
  else{
         OpcioSusana->setChecked(TRUE);
//         AfegirBd=true;
  }
  

  this->opcio=opcio;
}


void DialegManAuto::slotBotoCANCEL(){
  img->dw->mostraPunts=false;
  img->dw->EsborrarLlista();
  close();
}

void DialegManAuto::slotBotoOK(){

  img->dw->AgafoPunts=FALSE;
  QString tmp;
  

     if (OpcioRec->isChecked() || OpcioCBIR->isChecked())     //Volem consultar a la BD
        slotUpdateOpcio (1);  //passem l'algorisme SUSAN
        
     if (img->dw->llista->count()==1)     //Hem de tenir punts
           QMessageBox::critical (0, "Error !", "No hi ha cap punt seleccionat !\nO esculls els punts a la imatge original o tries fer-ho automaticament");

     else{  //calculem el k calgui      
           formaC = new Chang;

           formaC->CalcularDescriptors(*img);
           tmp=formaC->MostraPunts(*img);
           img->dw->Text.setText(tmp);

          
           tmp+=AltresCaracteristiques(*img);
           img->dw->Text.setText(tmp);          

           if (OpcioAfegeix->isChecked()){   //Afegim a la BD
              OmpleBDcaractGlobC();
              OmpleBDdescriptChang ();
           }

           else if (OpcioRec->isChecked()){  //Volem consultar i comparar
               QString a;
               Consulta();
               tmp+="<BR>S'ASSEMBLA A:<BR>";
               tmp+=ComparaAmbMitja();
               img->dw->Text.setText(tmp);
           }
           else if (OpcioCBIR->isChecked()){    //Volem consultar i mostrar imatges resultants
              ConsultaCBIR();

              DSortidaCerca *dSortida = new DSortidaCerca(this, "Dades de la cerca",WDestructiveClose,  *llista_dist);
             dSortida->setExtension(0);
             dSortida->exec();
  

           }

           close();
     }
}

bool DialegManAuto::Inicialitza(){
  opcio=0;  //Per defecte manual
  int espai=25, pos=40;

   tipus=-1;
   
  GrupPrincipal = new QButtonGroup("CHANG" , this);
  GrupPrincipal->setGeometry (QRect(28,25,274,187));
  connect(GrupPrincipal, SIGNAL(clicked(int)), this, SLOT(slotUpdateOpcio(int)));


     OpcioManual = new QRadioButton ("Manual", GrupPrincipal);
     OpcioManual->setGeometry (QRect(80,20,90,15));

     OpcioSusana = new QRadioButton ("SUSAN", GrupPrincipal);
     OpcioSusana->setGeometry (QRect(80,45,90,15));
     
  
     OpcioAuto = new QRadioButton ("Sobel", GrupPrincipal);
     OpcioAuto->setGeometry (QRect(80,70,90,15));
     OpcioAuto->setChecked(TRUE);

/*   //muntem grups spinbox + slider   MODUL
   GrupBarretaSliderM = new QGroupBox ("Modul", this);
   GrupBarretaSliderM->setGeometry (QRect(30,115,270,50));
   GrupBarretaSliderM->setLineWidth(0);
      barretaM = new QSlider(Qt::Horizontal, GrupBarretaSliderM);
      barretaM->setGeometry (QRect(5,20, 200, 20));
      barretaM->setRange (0, MAX_MODUL);
      barretaM->setValue(MAX_MODUL);
      connect (barretaM, SIGNAL(sliderMoved (int)), this, SLOT(slotVariaEntradaM(int)));
      
      entradaM = new QSpinBox (GrupBarretaSliderM);    //Modul
      entradaM->setMaxValue (MAX_MODUL); 
      entradaM->setGeometry (QRect(215, 20, 50, 20));
      entradaM->setValue(MAX_MODUL);
      connect (entradaM, SIGNAL (valueChanged (int)), this, SLOT(slotVariaSliderM(int)));
*/      
   //muntem grups spinbox + slider   FASE
   GrupBarretaSliderF = new QGroupBox ("Fase", this);
   GrupBarretaSliderF->setGeometry (QRect(30,160,270,50));
   GrupBarretaSliderF->setLineWidth(0);
      barretaF = new QSlider (Qt::Horizontal, GrupBarretaSliderF);
      barretaF->setGeometry (QRect(5, 20, 200, 20));
      barretaF->setRange (0, MAX_FASE);
      barretaF->setValue(MAX_FASE);
      connect (barretaF, SIGNAL(sliderMoved (int)), this, SLOT(slotVariaEntradaF(int)));

      entradaF = new MySpinBox (GrupBarretaSliderF);    //Fase
      entradaF->setGeometry (QRect(215, 20, 50, 20));
      entradaF->setMaxValue (MAX_FASE);
      entradaF->setMinValue (0);
      entradaF->setValue (MAX_FASE);
      connect (entradaF, SIGNAL (valueChanged (int)), this, SLOT(slotVariaSliderF(int)));



   GrupBD = new QButtonGroup(this);
   GrupBD->setGeometry (QRect(28, 225,274,71));

   EtiquetaNom = new QLabel ("Tipus:", GrupBD);
   EtiquetaNom->setGeometry (QRect(15, 35, 70, 20));

   nom = new QLineEdit (inicial, GrupBD);
   nom->setGeometry (QRect(60, 35, 100, 20));

   OpcioAfegeix = new QCheckBox ("Afegeix a la BD",GrupBD,"Afegeix a la BD");
   OpcioAfegeix->setGeometry( QRect( 15, 5, 115, 15 ) );
   connect(OpcioAfegeix, SIGNAL(stateChanged(int)), this, SLOT(slotUpdateAfegeix(int)));
 
         
   //botons acceptar i cancelar
   botoOk = new QPushButton(this,"ok");
   botoOk->setGeometry( QRect( 145, 310, 93, 26 ) );
   botoOk->setText( "Ok" );
   connect(botoOk, SIGNAL(clicked()), this, SLOT(slotBotoOK()));

   botoCancel = new QPushButton(this,"cancelar");
   botoCancel->setGeometry( QRect( 249, 310, 93, 26 ) );
   botoCancel->setText( "Cancelar");
   connect(botoCancel, SIGNAL(clicked()), this, SLOT(slotBotoCANCEL()));

   GrupCaract = new QButtonGroup("Altres dades", this);
   GrupCaract->setGeometry (QRect(330,25,130,270));  //490, 25, 130, 270)
      OpcioArea = new QCheckBox ("Area", GrupCaract);
      OpcioArea->setGeometry (QRect(10,pos,90,15));

      OpcioPerimetre = new QCheckBox ("Perimetre", GrupCaract);
      OpcioPerimetre->setGeometry (QRect(10,pos+=espai,90,15));

      OpcioMinRectangle = new QCheckBox ("Rectangle minim", GrupCaract);
      OpcioMinRectangle->setGeometry (QRect(10,pos+=espai,115,15));


      OpcioCompactnes = new QCheckBox ("Compactesa", GrupCaract);
      OpcioCompactnes->setGeometry (QRect(10,pos+=espai,110,15));

      OpcioLength = new QCheckBox ("Alcada", GrupCaract);
      OpcioLength->setGeometry (QRect(10,pos+=espai,90,15));

      OpcioBreadth = new QCheckBox ("Amplada", GrupCaract);
      OpcioBreadth->setGeometry (QRect(10,pos+=espai,90,15));

      OpcioElongation = new QCheckBox ("Elongacio", GrupCaract);
      OpcioElongation->setGeometry (QRect(10,pos+=espai,90,15));

      OpcioCentreGravetat = new QCheckBox ("Centre gravetat", GrupCaract);
      OpcioCentreGravetat->setGeometry (QRect(10,pos+=espai,110,15));

   GrupReconeixement = new QButtonGroup("Consulta", this);
   GrupReconeixement->setGeometry (QRect(490,25,130,270));
   connect(GrupReconeixement, SIGNAL(released(int)), this, SLOT(slotRec(int)));   
      OpcioRec = new QCheckBox ("Reconeixement", GrupReconeixement);
      OpcioRec->setGeometry (QRect(10,30,110,15));


      OpcioCBIR = new QCheckBox ("CBIR", GrupReconeixement);
      OpcioCBIR->setGeometry (QRect(10,140,90,15));

      MesSemblants = new QLineEdit (GrupReconeixement);
      MesSemblants->setGeometry (QRect(70, 132, 40, 20));
      MesSemblants->setDisabled (TRUE);
      
      
   GrupTipus1 = new QButtonGroup (GrupReconeixement);
   GrupTipus1->setGeometry (QRect (25,55, 95, 66));

   GrupTipus1->setLineWidth(0);
   GrupTipus1->setDisabled(true);
      OpcioMamo1 = new QRadioButton ("Mamo", GrupTipus1);     
      OpcioMamo1->setGeometry (QRect (0, 5, 90, 15));
      OpcioSintet1 = new QRadioButton ("Sintetica", GrupTipus1);
      OpcioSintet1->setGeometry (QRect (0, 26, 90, 15));
      OpcioFurqui1 = new QRadioButton ("Altres", GrupTipus1 );
      OpcioFurqui1->setGeometry (QRect (0, 47, 90, 15));
           

   GrupTipus2 = new QButtonGroup (GrupReconeixement);
   GrupTipus2->setGeometry (QRect (25,160, 95, 66));

   GrupTipus2->setLineWidth(0);
   GrupTipus2->setDisabled(true);
      OpcioMamo2 = new QRadioButton ("Mamo", GrupTipus2);
      OpcioMamo2->setGeometry (QRect (0, 5, 90, 15));
      OpcioSintet2 = new QRadioButton ("Sintetica", GrupTipus2);
      OpcioSintet2->setGeometry (QRect (0, 26, 90, 15));
      OpcioFurqui2 = new QRadioButton ("Altres", GrupTipus2 );
      OpcioFurqui2->setGeometry (QRect (0, 47, 90, 15));

   GrupTipus = new QButtonGroup (GrupBD);   
   GrupTipus->setGeometry (QRect (175,2, 95, 66));

   GrupTipus->setLineWidth(0);
   GrupTipus->setDisabled(TRUE);
      OpcioMamo = new QRadioButton ("Mamo", GrupTipus);
      OpcioMamo->setGeometry (QRect (0, 5, 90, 15));
      OpcioSintet = new QRadioButton ("Sintetica", GrupTipus);
      OpcioSintet->setGeometry (QRect (0, 26, 90, 15));
      OpcioFurqui = new QRadioButton ("Altres", GrupTipus);
      OpcioFurqui->setGeometry (QRect (0, 47, 90, 15));
  
   return (true);
}

int DialegManAuto::ObtenirMode(){
  return(opcio);
}

/*
void DialegManAuto::slotVariaEntradaM(int a){
   entradaM->setValue(a);
   img->CercaVertex(a, ((double)barretaF->value()/100.0));
}

void DialegManAuto::slotVariaSliderM (int a){
   barretaM->setValue(a);
   img->CercaVertex(a, ((double)barretaF->value()/100.0));
}
*/
void DialegManAuto::slotVariaEntradaF(int a){
   entradaF->setValue(a);
   entradaF->setSpecialValueText (   QString( "%1.%2" ) // 0.0 to 10.0
                   .arg( a / 100 ).arg(a % 100 ));
      
//   img->CercaVertex(barretaM->value(), ((double)barretaF->value()/100.0));
   img->CercaVertex(((double)barretaF->value()/100.0));
}

void DialegManAuto::slotVariaSliderF (int a){
   barretaF->setValue(a);
//   img->CercaVertex(barretaM->value(), ((double)barretaF->value()/100.0));
   img->CercaVertex(((double)barretaF->value()/100.0));
}

QString DialegManAuto::AltresCaracteristiques (Imatge &im){
   f = new forma;
   QString vector,a;

   f->extreureMinBox(im.imatge);    //Sha de fer per calcular qualsevol cosa
   
    if (OpcioArea->isChecked() || OpcioPerimetre->isChecked() || OpcioElongation->isChecked() || OpcioMinRectangle->isChecked()
   || OpcioCompactnes->isChecked() || OpcioLength->isChecked() || OpcioBreadth->isChecked() || OpcioCentreGravetat->isChecked())
      vector+="<BR>ALTRES CARACTERISTIQUES<BR>"; 

   if (OpcioArea->isChecked()){
      f->area(im.imatge);
      vector+="Area = ";
      vector+= a.setNum(f->varea) + "<BR>";      
      }
   if (OpcioPerimetre->isChecked()){
      Imatge image;
      
      image=*img;   //faig una copia de la rmImage
      

      vector+="Perimetre = ";
      image.Contorn(im);
      f->vperimetre=image.CalculaPerimetre();

      vector+= a.setNum(f->vperimetre) + "<BR>";
      }
   if (OpcioElongation->isChecked()){
      f->elongation(0, im.imatge);
      vector+= "Elongacio = ";
      vector+= a.setNum(f->velongacio) + "<BR>";
      }
   if (OpcioMinRectangle->isChecked()){
      vector+= "Coordenades del Rectangle Minim = (";
      vector+= a.setNum(f->xMin);
      vector+= ", " + a.setNum(f->yMin);
      vector+= ")   (" + a.setNum(f->xMax);
      vector+= ", " + a.setNum (f->yMax) + ")<BR>";
      }
   if (OpcioCompactnes->isChecked()){  //ens calen el perimetre i l'area per calcular la compaccitat
      if (!OpcioPerimetre->isChecked()){
         Imatge image;

         image=*img;   //faig una copia de la rmImage

         image.Contorn(im);
         f->vperimetre=image.CalculaPerimetre();
      }
      
      if (!OpcioArea->isChecked())
         f->area(im.imatge);         

      f->compactness(im.imatge);
      vector+= "Compactness = ";
      vector+= a.setNum(f->vcompactness) + "<BR>";
      }
   if (OpcioLength->isChecked()){
      f->length();
      vector+= "Length = ";
      vector+= a.setNum(f->vlength) + "<BR>";
      }
   if (OpcioBreadth->isChecked()){
      f->breath();
      vector+= "Breadth = ";
      vector+= a.setNum(f->vbreadth) + "<BR>";
      }
   if (OpcioCentreGravetat->isChecked()){
      f->centroid();
      vector+= "Centre de gravetat = (";
      vector+= a.setNum(f->vcentroidX);
      vector+= ", " + a.setNum(f->vcentroidY);
      vector+= ")<BR>";
      }
      
   return (vector);
}

//Toquen lopcio dafegir a la base de dades
void DialegManAuto::slotUpdateAfegeix(int a){
   tipus=-1;
   if (a==2){   //BOTO PITXAT
      GrupTipus->setDisabled(FALSE);
      GrupPrincipal->setDisabled(true);
      OpcioSintet->setChecked(TRUE);
//      clica2 = true;
      tipus=1;
      OpcioSusana->setChecked(TRUE);
      OpcioCentreGravetat->setChecked(TRUE);
      OpcioArea->setChecked(TRUE);              
      OpcioBreadth->setChecked(TRUE);          
      OpcioCompactnes->setChecked(TRUE);
      OpcioElongation->setChecked(TRUE);   
      OpcioMinRectangle->setChecked(TRUE);
      OpcioPerimetre->setChecked(TRUE);      
      OpcioLength->setChecked(TRUE);


      GrupCaract->setDisabled(true);
      barretaF->setDisabled(TRUE);
      entradaF->setDisabled(TRUE);
//      barretaM->setDisabled(TRUE);
//      entradaM->setDisabled(TRUE);

      GrupReconeixement->setDisabled(TRUE);

      //busquem els corners  pel metode de SUSAN
//      slotUpdateOpcio(1);
      int total_corners, i;
      coordenades *c;
      img->dw->EsborrarLlista();           //20
      img->imatge.setup_brightness_lut(1);     //un es el treshold
      total_corners=img->imatge.susan_corners();

      c = new coordenades;
      for (i=0;i<total_corners;i++){
          c->X=img->imatge.corner_list[i].x;
          c->Y=img->imatge.corner_list[i].y;
          img->dw->llista->prepend(c);
          c = new coordenades;
      }

      c->X=-1;
      img->dw->llista->append(c);
      img->dw->update();
      

   }
   else if (a==0){   //boto no pitxat
      OpcioSintet->setChecked(FALSE);
      OpcioAuto->setChecked(true);
         barretaF->setDisabled(false);
         entradaF->setDisabled(false);
//         barretaM->setDisabled(false);
//         entradaM->setDisabled(false);
      tipus=-1;
      GrupCaract->setDisabled (false);
      GrupReconeixement->setDisabled(false);
      OpcioSusana->setChecked(false);
      OpcioCentreGravetat->setChecked(false);
      OpcioArea->setChecked(false);
      OpcioBreadth->setChecked(false);
      OpcioCompactnes->setChecked(false);
      OpcioElongation->setChecked(false);
      OpcioMinRectangle->setChecked(false);
      OpcioPerimetre->setChecked(false);
      OpcioLength->setChecked(false);
      GrupPrincipal->setDisabled(false);
      }
}


//Omplim la taula amb totes les caracteristiques de la imatge menys els descriptors
void DialegManAuto::OmpleBDcaractGlobC (){
  char query[100];
  char fetch[100];
  char close[100];
  char insert[100];



   pgAcces *data = new pgAcces();
   sprintf(query,"DECLARE buscaId CURSOR FOR select * from \"CaractGlob\"");
   sprintf(fetch,"FETCH ALL in buscaId");
   sprintf(close,"CLOSE buscaId");
   IdCaract = data->cercaId(query,fetch,close);


   sprintf(insert,"INSERT INTO \"CaractGlob\" VALUES (%d,'%s',%d,%f, %f,%d,%d,%d,%d, %f, %f,%f,%f,%f,%f,-1, -1,%d,-1,-1, '%s')",
           IdCaract,
           qStrToChar(nom->text()),
           tipus,
           f->varea,
           f->vperimetre,
           f->xMin,
           f->yMin,
           f->xMax,
           f->yMax,
           f->vcompactness,
           f->vlength,
           f->vbreadth,
           f->velongacio,
           f->vcentroidX,
           f->vcentroidY,
           (formaC->llistaModuls->count()-1),
           path);

   data->insertCaract(insert);
  
}

void DialegManAuto::OmpleBDdescriptChang (){
  char query[100];
  char fetch[100];
  char close[100];
  char insert[100];
  int i, total_descriptors;
  float *apuntador;


        int idChang;
        pgAcces *data = new pgAcces();
        sprintf(query,"DECLARE buscaId CURSOR FOR select * from \"DesChang\"");
        sprintf(fetch,"FETCH ALL in buscaId");
        sprintf(close,"CLOSE buscaId");
        idChang = data->cercaId(query,fetch,close);

      
        total_descriptors=formaC->llistaModuls->count()-1;
        apuntador=formaC->llistaModuls->first();
        
         for (i=0;i<total_descriptors;i++){
            sprintf(insert,"INSERT INTO \"DesChang\" VALUES (%d,%d,%f)", i, IdCaract, *apuntador);
            data->insertCaract(insert);
            apuntador=formaC->llistaModuls->next();
         }

}

//passa un QString a un char*
char *DialegManAuto::qStrToChar(const QString &fileName){
  char *fitxer;
  QChar ch;

  fitxer = new char[255];

    for(uint i= 0;i<fileName.length();i++){
      ch = fileName.at( i );
      fitxer[i] = ch.cell();
    }
    fitxer[fileName.length()] = '\0';
    return fitxer;
}

//Gestio de les opcions de la base de dades
void DialegManAuto::slotRec(int a){
   tipus=-1;
   
   if (a==0 && OpcioRec->isChecked()){   //han pitxat Rec
      MesSemblants->setDisabled (TRUE);                                               
      OpcioMamo2->setChecked(false);     //des-xequegem CBIR
      OpcioSintet2->setChecked(false);
      OpcioFurqui2->setChecked(false);
      OpcioSintet1->setChecked(true);
//      clicat3=clicat4=clicat5=false;            //inicialitzem les variables d CBIR
      GrupTipus1->setDisabled(false);
      OpcioCBIR->setChecked(FALSE);
      GrupBD->setDisabled (TRUE);
      GrupPrincipal->setDisabled(TRUE);
      GrupBarretaSliderF->setDisabled(TRUE);
//      GrupBarretaSliderM->setDisabled(TRUE);
      OpcioSusana->setChecked(TRUE);
      GrupTipus2->setDisabled(TRUE);
      GrupTipus1->setDisabled(FALSE);
      GrupCaract->setDisabled(TRUE);
   }
   else if (a==1 && OpcioCBIR->isChecked()){
      GrupCaract->setDisabled(false);
      MesSemblants->setDisabled (FALSE);
      OpcioMamo1->setChecked(false);
      OpcioSintet1->setChecked(false);
      OpcioFurqui1->setChecked(false);
      OpcioSintet2->setChecked(true);
//      clicat1=clicat2=clicat3=false;     
      GrupTipus2->setDisabled(false);
      OpcioRec->setChecked(FALSE);
      GrupBD->setDisabled(TRUE);
      GrupPrincipal->setDisabled(TRUE);
      GrupBarretaSliderF->setDisabled(TRUE);
//      GrupBarretaSliderM->setDisabled(TRUE);
      OpcioSusana->setChecked(TRUE);
      GrupTipus1->setDisabled(TRUE);
      GrupTipus2->setDisabled(FALSE);
   }
   else if (!OpcioRec->isChecked() && !OpcioCBIR->isChecked()){   //no volem res
      MesSemblants->setDisabled (TRUE);
      GrupCaract->setDisabled (false);
      OpcioMamo1->setChecked(false);   //des-seleccionem qualsevol opcio
      OpcioSintet1->setChecked(false);
      OpcioFurqui1->setChecked(false);
      OpcioMamo2->setChecked(false);
      OpcioSintet2->setChecked(false);
      OpcioFurqui2->setChecked(false);
      GrupTipus1->setDisabled(TRUE);
      GrupTipus2->setDisabled(TRUE);
      GrupBD->setDisabled(FALSE);
      GrupPrincipal->setDisabled(FALSE);
      GrupBarretaSliderF->setDisabled(FALSE);
//      GrupBarretaSliderM->setDisabled(FALSE);
   }      
}
    
void DialegManAuto::Consulta (){
  char query[100];
  char fetch[100];
  char close[100];

  
  QString nomfig;
  char *llistanoms[MAX_FIG_DIF];
  int IdChang, area, MinX, MinY, MaxX, MaxY, Ch, nFields, nTuples, i, tmp, figdif, total_nostre, j, tipus_im;
  double perimetre, lengh, breadth, elongation, cgravetatX, cgravetatY;
  atom atm, *punter;
  
  llistadiferents = new llistaID;

  
  PgDatabase data(dbName);
	if ( data.ConnectionBad() ){
		cerr << "Connection to database '" << dbName << "' failed." << endl
		<< "Error returned: " << data.ErrorMessage() << endl;
    return -1;
	}
  else{
     sprintf(query,"DECLARE dadesPc CURSOR FOR select * from \"CaractGlob\"");
     sprintf(fetch,"FETCH ALL in dadesPc");
     sprintf(close,"CLOSE dadesPc");
  
	  if ( !data.ExecCommandOk("BEGIN") ){
		  cerr << "BEGIN command failed" << endl;
      return -1;
  	}

//   sprintf (query, "SELECT * from \"CaractGlob\"");
   if ( !data.ExecCommandOk(query) ){
    	cerr << "DECLARE CURSOR command failed" << endl;
      return -1;
  	}

  	if ( !data.ExecTuplesOk(fetch) ){
	  	cerr << "FETCH ALL command didn't return tuples properly" << endl;
      return -1;
  	}
    //guardem els resultats obtinguts a una estructura global
  	nFields = data.Fields();
    nTuples = data.Tuples();


    //contem les figures diferents k tenim per chang
    figdif=0;
    for (i=0;i<nTuples;i++){
      tmp=atoi(data.GetValue(i, 17));  //17 = Chang
      if (tmp !=-1){    //comprovem k haguem fet Chang
         tipus_im=atoi(data.GetValue(i,2));
         if (tipus_im==tipus || tipus==-1){  //si ens diuen d kin tipus es busquem unicament dakell tipus, sino busque per tota la BD
            total_nostre=formaC->llistaModuls->count()-1;
            if (tmp==total_nostre){    //comparem els de la BD am el nostres
               atm.nom=data.GetValue(i, 1);  //1 = nom
               atm.Descrip=ConsultaValorsChang(atoi(data.GetValue(i,0)), total_nostre);  //camp clau

               if (! llistadiferents->ja_hi_es(atm.nom)){ //NO ES A LA LLISTA
                  llistadiferents->Afegim(atm, total_nostre);
                  figdif++;
               }
               else{ //ja tenim el tipus a la llista
                  llistadiferents->Acumulem(atm, total_nostre);
               }
            }
         }
      }
   }
 }
  
  
/*    punter=llistadiferents->first();
    cout << "comprobem" << endl;
    for (i=0;i<total_nostre;i++){
      cout << punter->DCH[i] << "  ";
//      punter=llistadiferents->next();
    }
        cout << endl;
    
*/

  	data.Exec(close);
    data.Exec("END");
  
}


float* DialegManAuto::ConsultaValorsChang(int identificador, int mostres){
   float *espai;
   int i, k, e;
  char query[100];
  char fetch[100];
  char close[100];

  
  PgDatabase data(dbName);
	if ( data.ConnectionBad() ){
		cerr << "Connection to database '" << dbName << "' failed." << endl
		<< "Error returned: " << data.ErrorMessage() << endl;
    return -1;
	}
  else{
     sprintf(query,"DECLARE valChang CURSOR FOR select * from \"DesChang\"");
     sprintf(fetch,"FETCH ALL in valChang");
     sprintf(close,"CLOSE valChang");

	  if ( !data.ExecCommandOk("BEGIN") ){
		  cerr << "BEGIN command failed" << endl;
      return -1;
  	}

   if ( !data.ExecCommandOk(query) ){
    	cerr << "DECLARE CURSOR command failed" << endl;
      return -1;
  	}

  	if ( !data.ExecTuplesOk(fetch) ){
	  	cerr << "FETCH ALL command didn't return tuples properly" << endl;
      return -1;
  	}
   
   espai = new float[mostres];
   
   i=0;
   while (atoi(data.GetValue(i, 1)) != identificador)   //busquem el camp clau
      i++;
      
   k=i+mostres;
      
   e=0;
   for (; i<k; i++){
      espai[e]=atof(data.GetValue (i, 2));
      e++;
   }

  	data.Exec(close);
    data.Exec("END");

    return (espai);
 }
}

//Diu a quina figura s'assembla mes la imatge consultada
QString DialegManAuto::ComparaAmbMitja(){
     int i, total, total_tipus;
     atom *cursor;
     float *ch, min;
     QString etiqueta;

     
     if (llistadiferents->count() > 0){
     total_tipus=0;
     total=formaC->llistaModuls->count()-1;

     cursor=llistadiferents->first();
     while (cursor){    //fem la mitja per cada tipus
         for (i=0;i<total;i++)
            cursor->Descrip[i]/=cursor->total;
         
         cursor=llistadiferents->next();
//         total_tipus++;
     }
       
     //comencem la distancia euclidiana
     cursor=llistadiferents->first();
     ch=formaC->llistaModuls->first();
     while (cursor){    //elevem al quadrat la resta dels descriptors de chang de la mitjana i els nostres
         for (i=0;i<total;i++){
            cursor->Descrip[i]=pow (cursor->Descrip[i]-*ch, 2.0);
            ch=formaC->llistaModuls->next();
         }
                                                            
         cursor=llistadiferents->next();
         ch=formaC->llistaModuls->first();
//         total_tipus++;
     }
                  
     cursor=llistadiferents->first();     //fem l'arrel de la suma dels valors de chang anteriors
     while (cursor){    //elevem al quadrat la resta dels descriptors de chang de la mitjana i els nostres
         for (i=1;i<total;i++){
            cursor->Descrip[0]+=cursor->Descrip[i];
         }

         cursor->Descrip[0]=sqrt (cursor->Descrip[0]); //fem l'arrel

         cursor=llistadiferents->next();
//         total_tipus++;
     }

     cursor=llistadiferents->first();     //busquem el k ha sortit el valor mes petit
     min=cursor->Descrip[0];
     etiqueta=cursor->nom;
     while (cursor){                         //aixo indica k es el tipus d figura k mes s'assembla
        if (cursor->Descrip[i] < min){
           etiqueta=cursor->nom;
           
           }

         cursor=llistadiferents->next();
     }

     }
     else
      etiqueta="No hi ha semblances";
      
     return (etiqueta);
}


//Fa la consulta per CBIR      
void DialegManAuto::ConsultaCBIR (){
   char query[250];
   char fetch[100];
   char close[100];
   int i, j, nTuples, nFields;


   PgDatabase data(dbName);
   if ( data.ConnectionBad() ){
      cerr << "Connection to database '" << dbName << "' failed." << endl
      << "Error returned: " << data.ErrorMessage() << endl;
      return -1;
   }
   else{
      sprintf(query, MontaConsulta("apunta", "CaractGlob"));
//      cout << "query K MIRO" << endl << query << endl;
      sprintf(fetch,"FETCH ALL in apunta");
      sprintf(close,"CLOSE apunta");

      if ( !data.ExecCommandOk("BEGIN") ){
         cerr << "BEGIN command failed" << endl;
         return -1;
      }

      if ( !data.ExecCommandOk(query) ){
         cerr << "DECLARE CURSOR command failed" << endl;
         return -1;
      }

      if ( !data.ExecTuplesOk(fetch) ){
         cerr << "FETCH ALL command didn't return tuples properly" << endl;
         return -1;
      }



      if (!MesSemblants->text())  //tha buit
         recuperaX=0;
      else
         recuperaX=MesSemblants->text().toInt();
      
      CalcularMitjana(query);    //omple el NodeMitjaTeta amb la mitja de cada columna
      CalcularTeta (data);          //omple el NodeMitjaTeta amb la variacna de cada columna
      CalcularMitjanaCH (data);       //calcula la mitja i la desviacio de les figures k tenen tants descriptors de chang com la nostra      
      CalcularDesviacioCH ();
      CalculaDistanEucli (data);    //Calcula la distancia eunclidiana de totes les figures
     

      dataCH->Exec("CLOSE apunta2");     //aquests cursors es declaren a CalcularMitjanaCH pro calen mes endevant
      dataCH->Exec("END");  //per aixo no els mato fins ara                                
      
      data.Exec(close);
      data.Exec("END");   

   }

}

//Genera una taula amb els camps seleccionats per lusuari i la informacio que ens falta per retornar el path
char* DialegManAuto::MontaConsulta(QString cursor, QString taula){
   QString cadena;
   uint longitud;
   char bufer[6];
   
   cadena="DECLARE ";
   cadena+=cursor;
   cadena+=" CURSOR FOR select ";

   cadena+="\"IdF\", \"Nom\", \"path\", ";
   
   if (OpcioArea->isChecked())
      cadena+="\"Area\", ";
   if (OpcioPerimetre->isChecked())
      cadena+="\"Perimetre\", ";
   if (OpcioMinRectangle->isChecked())
      cadena+="\"MinX\", \"MinY\", \"MaxX\", \"MaxY\", ";
   if (OpcioCompactnes->isChecked())
      cadena+="\"Compactness\", ";
   if (OpcioLength->isChecked())
      cadena+="\"Length\", ";
   if (OpcioBreadth->isChecked())
      cadena+="\"Breadth\", ";
   if (OpcioElongation->isChecked())
      cadena+="\"Elongation\", ";
   if (OpcioCentreGravetat->isChecked())
      cadena+="\"CgravetatX\", \"CgravetatY\", ";
   
   CadenaSpecifica (); //montem un vector amb les dades escollides
      
   longitud=cadena.length();

   cadena.remove(longitud-2, 2);

   sprintf (bufer, "%d", formaC->llistaModuls->count()-1);
   
   cadena+=" from \"" + taula + "\" WHERE \"CH\"='" + bufer + "'";

   if (OpcioMamo2->isChecked())
      cadena+="AND \"Tipus\"='0' ";
   else if (OpcioSintet2->isChecked())
      cadena+="AND \"Tipus\"='1' ";
   else if (OpcioFurqui2->isChecked())
      cadena+="AND \"Tipus\"='2' ";
  
   
   return (qStrToChar(cadena));
   
}

void DialegManAuto::CalcularMitjana(char *pregunta){
   char query[250];
   char fetch[100];
   char close[100];
   int i, j, nTuples, nFields;
   char *inici, *final;


   PgDatabase data(dbName);
   if ( data.ConnectionBad() ){
      cerr << "Connection to database '" << dbName << "' failed." << endl
      << "Error returned: " << data.ErrorMessage() << endl;
      return -1;
   }
   else{
      *(pregunta+13)='1';   //canvio el nom del curosr apunta --> apunt1
      
      inici=strstr (pregunta, "\"CH\"");  //inici apunta a les primeres cometes de "CH
      final=inici;
      
      while (*final != 'T')   //busquem la lletra T del Tipus
         final++;

      final--; //per agafar les cometes del "Tipus

      *inici='\0';

      strcat (pregunta, final);  //hem borrat el tall k imposa CH=
      strcpy (query, pregunta);
//cout << "la query es " << query << endl;
      sprintf(fetch,"FETCH ALL in apunt1");
      sprintf(close,"CLOSE apunt1");

      if ( !data.ExecCommandOk("BEGIN") ){
         cerr << "BEGIN command failed" << endl;
         return -1;
      }

      if ( !data.ExecCommandOk(query) ){
         cerr << "DECLARE CURSOR command failed" << endl;
         return -1;
      }

      if ( !data.ExecTuplesOk(fetch) ){
         cerr << "FETCH ALL command didn't return tuples properly" << endl;
         return -1;
      }
                              

      nFields = data.Fields();
      nTuples = data.Tuples();

      nodeMitjaTeta.vector = new double[nFields-3+(formaC->llistaModuls->count()-1)-1]; //camps seleccionats mes un camp per descriptor de chang excepte el primer k es 1
      nodeMitjaTeta.total=nFields-3+( formaC->llistaModuls->count()-1-1);

//      cout << "totaaaal " << nodeMitjaTeta.total << endl;
      for (i=0;i<nodeMitjaTeta.total;i++)  //inicialitzem el vector a 0
         nodeMitjaTeta.vector[i]=0.0;


      for (j=3; j<nFields;j++){   //les caracteristiques comencen a partir del tercer camp
         for (i=0; i<nTuples;i++){
            nodeMitjaTeta.vector[j-3]+=(double)atof(data.GetValue(i,j));
         }
            nodeMitjaTeta.vector[j-3]/=(double)nTuples;
      }

      data.Exec(close);
      data.Exec("END");
                                                                                   /*
   cout << "vector mitjana" << endl;
   for (i=0;i<nFields-3;i++)
      cout << nodeMitjaTeta.vector[i] << "   ";  
   cout << endl;                                                    */
   }
}  

//Munta un vector amb les caracterisitques seleccionades de la imatge actual ordenades tal com estan a la BD
void DialegManAuto::CadenaSpecifica (){
   int i=0; 
//   int a;
   
   if (OpcioArea->isChecked())
      i++;
   if (OpcioPerimetre->isChecked())
      i++;
   if (OpcioMinRectangle->isChecked())
      i+=4;
   if (OpcioCompactnes->isChecked())
      i++;
   if (OpcioLength->isChecked())
      i++;
   if (OpcioBreadth->isChecked())
      i++;
   if (OpcioElongation->isChecked())
      i++;
   if (OpcioCentreGravetat->isChecked())
      i+=2;

   caracSelec = new double[i];

//   a=i;

   i=0;
   
   if (OpcioArea->isChecked()){
      caracSelec[i]=f->varea;
      i++;
   }
   if (OpcioPerimetre->isChecked()){
      caracSelec[i]=f->vperimetre;
      i++;
   }      
   if (OpcioMinRectangle->isChecked()){
      caracSelec[i]=(double)f->xMin;
      i++;
      caracSelec[i]=(double)f->yMin;
      i++;
      caracSelec[i]=(double)f->xMax;
      i++;
      caracSelec[i]=(double)f->yMax;
      i++;
   }
   if (OpcioCompactnes->isChecked()){
      caracSelec[i]=f->vcompactness;
      i++;
   }   
   if (OpcioLength->isChecked()){
      caracSelec[i]=f->vlength;
      i++;
   }
   if (OpcioBreadth->isChecked()){
      caracSelec[i]=f->vbreadth;
      i++;
   }
   if (OpcioElongation->isChecked()){
      caracSelec[i]=f->velongacio;
      i++;                    
   }
   if (OpcioCentreGravetat->isChecked()){
      caracSelec[i]=f->vcentroidX;
      i++;
      caracSelec[i]=f->vcentroidY;
   }

     /*        
   cout << endl << "VECTOR ACTUAL" << endl;
   for (i=0; i<a; i++)
      cout << caracSelec[i] << "   ";
   cout << endl;       
    */       
}

//Calculem la desvacio per l'area,... ho he de fer a la taula CaractGlob
void DialegManAuto::CalcularTeta (PgDatabase &data){
   int i, j, nFields, nTuples;
   double acumula;

   nFields = data.Fields();
   nTuples = data.Tuples();
   
   acumula=0.0;
   for (j=3; j<nFields;j++){   //les caracteristiques comencen a partir del tercer camp
      for (i=0; i<nTuples;i++){
         acumula+=pow ((double)atof(data.GetValue(i,j)) - (double)nodeMitjaTeta.vector[j-3], 2.0);
      }
      nodeMitjaTeta.vector[j-3]=acumula / (double)nTuples;
      acumula=0.0;
   }

   for (i=0;i<nFields-3;i++)
      nodeMitjaTeta.vector[i]=sqrt(nodeMitjaTeta.vector[i]);
                                                                                     /*
   cout << "vector teta" << endl;
   for (i=0;i<nFields-3;i++)
      cout << nodeMitjaTeta.vector[i] << "   ";
   cout << endl;                                                    */
}


//Hem de calcula la mitjana per els valors
void DialegManAuto::CalcularMitjanaCH (PgDatabase &data){
   char query[500];
   char fetch[100];
   char close[100];
   int longitud, tamany_taula, i, j, total_descriptors, tuples;

  dataCH = new PgDatabase(dbName);
  
   if ( data.ConnectionBad() ){
      cerr << "Connection to database '" << dbName << "' failed." << endl
      << "Error returned: " << dataCH->ErrorMessage() << endl;
      return -1;
   }
   else{    
      strcpy (query, "DECLARE apunta2 CURSOR FOR select \"IdCaract\", \"Valor\" FROM \"DesChang\" WHERE ");

      tamany_taula=data.Tuples();
      j=0; //la columna 0 te el camp IdCaract
//      strcat (query, "( ");
      for (i=0; i<tamany_taula;i++){     //consulta els valors de chang unicament pels idCaract seleccionats
         strcat (query, "\"IdCaract\"=");
         strcat (query, data.GetValue(i,j));
         strcat (query, " OR ");
      }

      longitud=strlen(query);
      *(query+longitud-3)='\0';

              
//   cout << "query chang" << endl << query << endl;
      sprintf(fetch,"FETCH ALL in apunta2");
      sprintf(close,"CLOSE apunta2");

      if ( !dataCH->ExecCommandOk("BEGIN") ){
         cerr << "BEGIN command failed" << endl;
         return -1;
      }

      if ( !dataCH->ExecCommandOk(query) ){
         cerr << "DECLARE CURSOR command failed" << endl;
         return -1;
      }

      if ( !dataCH->ExecTuplesOk(fetch) ){
         cerr << "FETCH ALL command didn't return tuples properly" << endl;
         return -1;
      }

 

      total_descriptors=formaC->llistaModuls->count()-1;
      tuples=dataCH->Tuples();
         
      for (i=0; i<tuples; i++){
         j=i%total_descriptors;
         if (j!=0){ //ho fem per tal de saltar-nos el primer descriptor k sempre es 1
            nodeMitjaTeta.vector[nodeMitjaTeta.total-total_descriptors+j]+=atof(dataCH->GetValue(i, 1));  //1 = columna dels descriptors de chang
         }
      }
      //el vector te la mitjana dels descriptors de chang
                                    
/* FAIG UN APANYO A VEURE K PASSA
      int figures_dif=tuples/total_descriptors;
      for (i=0;i<figures_dif;i++)
         nodeMitjaTeta.vector[i]/=figures_dif;
*/

   int figures_dif=tuples/total_descriptors;
      for (i=0;i<nodeMitjaTeta.total;i++)
         nodeMitjaTeta.vector[i]/=figures_dif;
         
         
/*      cout << "vector mitjana: " << endl;
      for (i=0;i<nodeMitjaTeta.total;i++)
         cout << nodeMitjaTeta.vector[i] << "   ";
      cout << endl << endl;              */              
   }
}

//Hem de calcular la desviacio per cada valor de chang k tinguem
void DialegManAuto::CalcularDesviacioCH (){
   int i, j, nFields, nTuples, N;
   int total_descriptors=formaC->llistaModuls->count()-1-1;
   double *acumula;

   acumula = new double[total_descriptors];

   
   for (i=0; i< total_descriptors; i++)   //inicialitzem a 0
      acumula[i]=0.0;
      
   nTuples = dataCH->Tuples();
   
   for (i=0; i<nTuples;i++){
      if ((j=(i % (total_descriptors+1)))!=0){
         acumula[j-1]+=pow ((double)atof(dataCH->GetValue(i,1)) - (double)nodeMitjaTeta.vector[nodeMitjaTeta.total-total_descriptors+j-1], 2.0);      
      }
   }

/*         cout << "vector desviacio: " << endl;
      for (i=0;i<nodeMitjaTeta.total;i++)
         cout << acumula[i] << "   ";
      cout << endl;
    */  
//      cout << "vector acumulador: " << acumula[0] << endl;


   N=nTuples-(nTuples/(total_descriptors+1));


   j=nodeMitjaTeta.total-total_descriptors+1;
   for (i=0;i<total_descriptors;i++){
      nodeMitjaTeta.vector[j+i]=acumula[i]/(double)N;
      nodeMitjaTeta.vector[j+i]=sqrt(nodeMitjaTeta.vector[j+i]);
   }
      
}

//Calcula la distncia euclidiana de totes les imatges k s'assemblen      
void DialegManAuto::CalculaDistanEucli (PgDatabase &data){
   int i, files;
  ID_EUC *nova_distancia;

   llista_dist = new list_ID_EUC;
   
   files=data.Tuples();

   //lista amb totes les distancies euclidianes i identificador de la figura
   for (i=0; i<files;i++){
      nova_distancia=new ID_EUC;
      *nova_distancia=calcula_distancia (data, i); //ha de comparar tota la info de data am la d la imatge actual utilitzant la desviacio
      llista_dist->append (nova_distancia);
   }

   llista_dist->sort();

      //en cas de no voler retornar tota la base de dades
   if (recuperaX!=0 && recuperaX<files){
      int borrarem=files - recuperaX;
      files=recuperaX;


      nova_distancia=llista_dist->at(recuperaX);
      while (borrarem){
         llista_dist->remove();//(llista_dist->current());
         borrarem--;
      }
   }                                                                                     /*

   //PER PRINTAR RESULTATS
   nova_distancia=llista_dist->first();
   cout << "valors calculats " << endl;
   for (i=0;i<files;i++){
      nova_distancia=llista_dist->next();
   }
   cout << endl;                                                                   */
}

//fa el calcul de la distancia euclidiana excepte pels descriptors de chang  per una fila de la BD
ID_EUC DialegManAuto::calcula_distancia (PgDatabase &data, int fila){
   ID_EUC resultat;
   int nFields, nTuples, i, j;
   PgDatabase descrip(dbName);


   nFields=data.Fields();
   nTuples=data.Tuples();
   
   resultat.distancia=0.0;

   //calculem el total sense contar-hi els descriptors de chang

      for (j=3; j<nFields;j++){
         resultat.distancia+= pow (atof(data.GetValue(fila,j)) - caracSelec[j-3], 2.0) / nodeMitjaTeta.vector[j-3];
      }
      resultat.id=atoi (data.GetValue(fila, 0));   //guardem l'identificador
      strcpy (resultat.nom, data.GetValue(fila, 2)); //agafem el nom --> columna=2

   //resultat.distancia=sqrt (resultat.distancia);
   //afegim la distancia euclidiana dels descriptors de chang
   resultat.distancia+=ConsultaCH(resultat.id);  
   resultat.distancia=sqrt(resultat.distancia);                                                        
   return (resultat);
}

//calcula la distancia euclidiana dels descriptors de chang
double DialegManAuto::ConsultaCH(int iden){
   int i, j, k;
   bool trobat=false;
   int total_descriptors=formaC->llistaModuls->count()-1-1;
   double acumula=0.0;
   float *descriptors;
   
   k=nodeMitjaTeta.total-total_descriptors;

    i=0;
   while (! (trobat  || atoi(dataCH->GetValue(i, 0))==iden)) //buskem l'identificador
      i++;

   descriptors=formaC->llistaModuls->first();
   descriptors=formaC->llistaModuls->next(); //per saltar l'1
   
//   cout << "aqui comena" << endl;
   for (j=0; j<total_descriptors; j++){
//      cout << pow (atof(dataCH->GetValue(i+j, 1))- *descriptors, 2.0) << "descript " << *descriptors << endl;
      acumula+=pow (atof(dataCH->GetValue(i+j, 1))- *descriptors, 2.0) / (double)nodeMitjaTeta.vector[k+j];
      descriptors=formaC->llistaModuls->next();
   }
//   cout << "acumula                         " << sqrt(acumula) << endl;
   return (acumula);

}

void DialegManAuto::omple_a_sac(Imatge &imat, char *inicial, char *path){
   formaC = new Chang;



   ///////////////////////////////////////////////////////////


   int total_corners, i;
   coordenades *c;

   img=&imat;
   this->inicial=inicial;
   this->path=path;
   
   img->dw->EsborrarLlista();           //20
   img->imatge.setup_brightness_lut(1);     //un es el treshold
   total_corners=img->imatge.susan_corners();

   c = new coordenades;
   for (i=0;i<total_corners;i++){
       c->X=img->imatge.corner_list[i].x;
       c->Y=img->imatge.corner_list[i].y;
       img->dw->llista->prepend(c);
       c = new coordenades;
   }

   c->X=-1;
   img->dw->llista->append(c);


   ///////////////////////////////////////////////////////////

   formaC->CalcularDescriptors(*img);

   AltresCaracteristiques_a_sac(*img);

   OmpleBDcaractGlobC_massiu(inicial);
   OmpleBDdescriptChang ();
}

void DialegManAuto::AltresCaracteristiques_a_sac (Imatge &im){
   f = new forma;


   f->extreureMinBox(im.imatge);    //Sha de fer per calcular qualsevol cosa

   f->area(im.imatge);

      Imatge image;

      image=*img;   //faig una copia de la rmImage
      image.Contorn(im);
      f->vperimetre=image.CalculaPerimetre();


      f->elongation(0, im.imatge);

      f->compactness(im.imatge);
      f->length();
      f->breath();
      f->centroid();
}

void DialegManAuto::OmpleBDcaractGlobC_massiu (char *inicial){
  char query[100];
  char fetch[100];
  char close[100];
  char insert[100];




   pgAcces *data = new pgAcces();
   sprintf(query,"DECLARE buscaId CURSOR FOR select * from \"CaractGlob\"");
   sprintf(fetch,"FETCH ALL in buscaId");
   sprintf(close,"CLOSE buscaId");
   IdCaract = data->cercaId(query,fetch,close);


   sprintf(insert,"INSERT INTO \"CaractGlob\" VALUES (%d,'%s',%d,%f, %f,%d,%d,%d,%d, %f, %f,%f,%f,%f,%f,-1, -1,%d,-1,-1, '%s')",
           IdCaract,
            inicial,
//           qStrToChar(nom->text()),
           1,
           f->varea,
           f->vperimetre,
           f->xMin,
           f->yMin,
           f->xMax,
           f->yMax,
           f->vcompactness,
           f->vlength,
           f->vbreadth,
           f->velongacio,
           f->vcentroidX,
           f->vcentroidY,
           (formaC->llistaModuls->count()-1),
           path);


   data->insertCaract(insert);

}
