/***************************************************************************
                          dialegmanauto.h  -  description
                             -------------------
    begin                : lun nov 10 2003
    copyright            : (C) 2003 by projecte
    email                : projecte@localhost.localdomain
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
 
#ifndef DIALEGMANAUTO_H
#define DIALEGMANAUTO_H

#include <qdialog.h>
#include <qradiobutton.h>
#include <qpushbutton.h>
#include <qbuttongroup.h>
#include <qvbox.h>
#include <qstring.h>
#include <qslider.h>
#include <qspinbox.h> 
#include "../imatge.h"
#include <qgroupbox.h> 
#include "myspinbox.h"
#include <qcheckbox.h>
#include <qlabel.h>
#include <qlineedit.h>

#include "../Forma/Chang/chang.h"

#include "../imatge.h"
#include "../Forma/forma.h"
#include "caract/pgAccess/pgacces.h"
#include "caract/pgAccess/llistaid.h"
#include "caract/pgAccess/list_id_euc.h"
#include "caract/CBIR/dsortidacerca.h"




/**
  *@author projecte
  */


typedef struct {
      double *vector;      //valors am la mitja d cada columna
      int total;  //tamany del vector
      }t_Node_Mitjana;
      
      

class DialegManAuto : public QDialog  {
  Q_OBJECT
public: 

      DialegManAuto(Imatge&, char *inicial, char *path);
      DialegManAuto();
	~DialegManAuto();

private slots:
    void slotBotoOK();
    void slotBotoCANCEL();
    void slotUpdateOpcio(int opcio);
//    void slotVariaEntradaM(int);
//    void slotVariaSliderM(int);
    void slotVariaEntradaF(int);
    void slotVariaSliderF(int);
    void slotUpdateAfegeix(int a);
    void slotRec(int a);

    
public:
  bool Inicialitza();  
  QPushButton *botoOk;
  QPushButton *botoCancel;

  QButtonGroup *GrupPrincipal;
      QRadioButton *OpcioManual;
      QRadioButton *OpcioAuto;
      QRadioButton *OpcioSusana;

  QButtonGroup *GrupMetode;
      QRadioButton *OpcioChang;

      
//  QGroupBox *GrupBarretaSliderM;
//      QSlider *barretaM;
//      QSpinBox *entradaM;

  QGroupBox *GrupBarretaSliderF;
      QSlider *barretaF;
      MySpinBox *entradaF;

  QButtonGroup*GrupCaract;
      QCheckBox *OpcioArea;
      QCheckBox *OpcioPerimetre;
      QCheckBox *OpcioMinRectangle;
      QCheckBox *OpcioCompactnes;
      QCheckBox *OpcioLength;
      QCheckBox *OpcioBreadth;
      QCheckBox *OpcioElongation;
      QCheckBox *OpcioCentreGravetat;

   QButtonGroup *GrupBD;
      QCheckBox *OpcioAfegeix;
      QLabel *EtiquetaNom;
      QLineEdit *nom;    //nom de la figura

   QButtonGroup *GrupReconeixement;
      QCheckBox *OpcioRec;
      QCheckBox *OpcioCBIR;
      QLineEdit *MesSemblants;

   QButtonGroup *GrupTipus;      //Opcions omplir BD
      QRadioButton *OpcioMamo;
      QRadioButton *OpcioSintet;
      QRadioButton *OpcioFurqui;



   QButtonGroup *GrupTipus1;   //Opcions Consultar BD
      QRadioButton *OpcioMamo1;
      QRadioButton *OpcioSintet1;
      QRadioButton *OpcioFurqui1;


   QButtonGroup *GrupTipus2;   //Opcions Consultar BD
      QRadioButton *OpcioMamo2;
      QRadioButton *OpcioSintet2;
      QRadioButton *OpcioFurqui2;

                  
  void InitDialeg(Imatge &i, char *inicial, char *path);   //allibera l'espai de memoria
  QString AltresCaracteristiques (Imatge &);

  //Funcions requerides per treballar amb la base de dades
  void OmpleBDcaractGlobC();
  void OmpleBDdescriptChang();
  char* qStrToChar(const QString &fileName);
  void Consulta ();
  float* ConsultaValorsChang(int identificador, int mostres);
  QString ComparaAmbMitja ();
  char* MontaConsulta(QString cursor, QString taula); //Monta la consulta en funcio de les opcions de lusuari
  void ConsultaCBIR ();
  void CalcularMitjana (char *pregunta);
  void CadenaSpecifica ();
  void CalcularTeta (PgDatabase &data);
  void CalcularDesviacioCH ();
  void CalcularMitjanaCH(PgDatabase &data);
  void CalculaDistanEucli (PgDatabase &data);
  ID_EUC calcula_distancia(PgDatabase &data, int fila);
  double ConsultaCH(int iden);
  void omple_a_sac(Imatge &imat, char *inicial, char *path);
  void AltresCaracteristiques_a_sac (Imatge &im);
  void OmpleBDcaractGlobC_massiu (char *inicial);
                                    
  Imatge *img;
  int opcio;
  rmImage *rimg;
  
  
public:
  int ObtenirMode();
  forma *f;

  Chang *formaC;
  int IdCaract;
  int tipus;      //mamo = 0, sintetica = 1, altres = 2, cap seleccionat = -1
  llistaID *llistadiferents;  //llista am els diferents tipus dimatges
  char *inicial;
  char *path;
  PgDatabase *dataCH;  //cursor amb els descriptors de chang k ens interessen
  list_ID_EUC *llista_dist;   //lista resultant amb les distancies euclidianes, path, identificador
  int recuperaX;

      
  t_Node_Mitjana nodeMitjaTeta;
  double *caracSelec;
};

#endif
