/***************************************************************************
                          caract.cpp  -  description
                             -------------------
    begin                : jue nov  6 12:49:24 CET 2003
    copyright            : (C) 2003 by projecte
    email                : projecte@localhost.localdomain
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

// Qt includes
#include <qvbox.h> 
#include <qaccel.h>

#include <qfiledialog.h> 



// application specific includes
#include "caractview.h"
#include "caractdoc.h"
#include "caract.h"
#include "caract/Dialegs/dialegobreraw.h"
//#include "caract/pgAccess/pgacces.h"

#include "libpq++.h"
#define dbName "host=localhost dbname=Rec_Forma user=postgres password=postgres"

#include "filenew.xpm"
#include "fileopen.xpm"
#include "filesave.xpm"
#include "zoomin.xpm"
#include "zoomout.xpm"
#include "punts.xpm"
#include "vista.xpm"
#include "v.xpm"
#include "binaritza.xpm"
#include "contorn.xpm"
#include "iguals.xpm"
#include "fourier.xpm"
#include "chang.xpm"

#include "docwidget.h"
#include <qcheckbox.h>
#include <qwidget.h>
#include <qdialog.h>

#include "Forma/Chang/chang.h"
#include <qstring.h>
#include "CBIR/dsortidacerca.h"
#include <dirent.h>

#define path_inici "/home/galco/BD/"

CaractApp *theApp;

CaractApp::CaractApp()
{
  setCaption(tr("Caract " VERSION ) );

  printer = new QPrinter;
  untitledCount=0;
  pDocList = new QList<CaractDoc>();
  pDocList->setAutoDelete(true);
   theApp = this;
  ///////////////////////////////////////////////////////////////////
  // call inits to invoke all other construction parts
  initView();
  initActions();
  initMenuBar();
  initToolBar();
  initZoomBar();
  initStatusBar();
  initCentralWidget();          //Afegit per tal de mostrar sortida de resultats
  resize(400,400);

  viewToolBar->setOn(true);
  viewStatusBar->setOn(true);
  viewZoomBar->setOn(true);

  //inicialitzem els dialegs
  dc=NULL;  //dialeg chang
  df=NULL;  //dialeg fourier
  dSortida=NULL;  //dialeg CBIR
  db=NULL;     //dialeg binaritza


}

CaractApp::~CaractApp()
{
  delete printer;
  //segons l'Stroustrup alliberar un punter a NULL no te cap problema
  delete dc;   //chang
  delete df;   //fourier
  delete dSortida;
  delete db;   //binaritza
}

void CaractApp::initCentralWidget(){

  //Espai per mostrar els resultats dels calculs                                   
  Text = new QTextEdit(centralWidget() , "sortida");                                                                                         
  //Text->setMaximumSize(QSize(1024,100));
  //Text->setText("hola que tal");

}
void CaractApp::initActions()
{
  QPixmap openIcon, saveIcon, /*newIcon, */zoomInIcon, zoomOutIcon, zoomVistaIcon, binaritzaIcon, contornIcon, igualsIcon, fourierIcon, changIcon, puntsIcon;
//  newIcon = QPixmap(filenew);
  openIcon = QPixmap(fileopen);
  saveIcon = QPixmap(filesave);
//  agafaPunts = QPixmap (punts);
  zoomInIcon = QPixmap(zoomin);
  zoomOutIcon = QPixmap(zoomout);
  zoomVistaIcon = QPixmap (v);
  binaritzaIcon = QPixmap (binaritza);
  contornIcon = QPixmap (contorn);
  igualsIcon = QPixmap (iguals);
  fourierIcon = QPixmap (fourier);
  changIcon = QPixmap (chang);
  puntsIcon = QPixmap (punts);

/*
  fileNew = new QAction(tr("New File"), newIcon, tr("&New"), QAccel::stringToKey(tr("Ctrl+N")), this);
  fileNew->setStatusTip(tr("Creates a new document"));
  fileNew->setWhatsThis(tr("New File\n\nCreates a new document"));
  connect(fileNew, SIGNAL(activated()), this, SLOT(slotFileNew()));        */

  fileOpen = new QAction(tr("Open File"), openIcon, tr("&Open..."), 0, this);
  fileOpen->setStatusTip(tr("Opens an existing document"));
  fileOpen->setWhatsThis(tr("Open File\n\nOpens an existing document"));
  connect(fileOpen, SIGNAL(activated()), this, SLOT(slotFileOpen()));

  fileSave = new QAction(tr("Save File"), saveIcon, tr("&Save"), QAccel::stringToKey(tr("Ctrl+S")), this);
  fileSave->setStatusTip(tr("Saves the actual document"));
  fileSave->setWhatsThis(tr("Save File.\n\nSaves the actual document"));
  connect(fileSave, SIGNAL(activated()), this, SLOT(slotFileSave()));

  zoomIn = new QAction(tr("Zoom In"), zoomInIcon, tr("&ZoomIn"), QAccel::stringToKey(tr("Ctrl++")), this);
  zoomIn->setStatusTip(tr("Augmenta el zoom"));
  zoomIn->setWhatsThis(tr("Zoom In\n\nAugmenta el zoom actual"));
  connect(zoomIn, SIGNAL(activated()), this, SLOT(slotZoomIn()));

  zoomOut = new QAction(tr("Zoom Out"), zoomOutIcon, tr("&ZoomOut"), QAccel::stringToKey(tr("Ctrl+-")), this);
  zoomOut->setStatusTip(tr("Disminueix el zoom"));
  zoomOut->setWhatsThis(tr("Zoom Out\n\nDisminueix el zoom actual"));
  connect(zoomOut, SIGNAL(activated()), this, SLOT(slotZoomOut()));

  zoomVista = new QAction(tr("Zoom Vista"), zoomVistaIcon, tr("&ZoomVista"), QAccel::stringToKey(tr("Ctrl+v")), this);
  zoomVista->setStatusTip(tr("Ajusta el zoom"));
  zoomVista->setWhatsThis(tr("Zoom Vista\n\nAjusta el zoom a la pantalla"));
  connect(zoomVista, SIGNAL(activated()), this, SLOT(slotZoomEncaixa()));

  zoom = new QActionGroup(this, 0, false);
  zoom->insert(zoomIn);
  zoom->insert(zoomOut);
  zoom->insert(zoomVista);
  
  fileSaveAs = new QAction(tr("Save File As"), tr("Save &as..."), 0, this);
  fileSaveAs->setStatusTip(tr("Saves the actual document under a new filename"));
  fileSaveAs->setWhatsThis(tr("Save As\n\nSaves the actual document under a new filename"));
  connect(fileSaveAs, SIGNAL(activated()), this, SLOT(slotFileSaveAs()));

  fileClose = new QAction(tr("Close File"), tr("&Close"), QAccel::stringToKey(tr("Ctrl+W")), this);
  fileClose->setStatusTip(tr("Closes the actual document"));
  fileClose->setWhatsThis(tr("Close File\n\nCloses the actual document"));
  connect(fileClose, SIGNAL(activated()), this, SLOT(slotFileClose()));

/*  filePrint = new QAction(tr("Print File"), tr("&Print"), QAccel::stringToKey(tr("Ctrl+P")), this);
  filePrint->setStatusTip(tr("Prints out the actual document"));
  filePrint->setWhatsThis(tr("Print File\n\nPrints out the actual document"));
  connect(filePrint, SIGNAL(activated()), this, SLOT(slotFilePrint()));         */

  fileQuit = new QAction(tr("Exit"), tr("E&xit"), QAccel::stringToKey(tr("Ctrl+Q")), this);
  fileQuit->setStatusTip(tr("Quits the application"));
  fileQuit->setWhatsThis(tr("Exit\n\nQuits the application"));
  connect(fileQuit, SIGNAL(activated()), this, SLOT(slotFileQuit()));

/*  editCut = new QAction(tr("Cut"), tr("Cu&t"), QAccel::stringToKey(tr("Ctrl+X")), this);
  editCut->setStatusTip(tr("Cuts the selected section and puts it to the clipboard"));
  editCut->setWhatsThis(tr("Cut\n\nCuts the selected section and puts it to the clipboard"));
  connect(editCut, SIGNAL(activated()), this, SLOT(slotEditCut()));

  editCopy = new QAction(tr("Copy"), tr("&Copy"), QAccel::stringToKey(tr("Ctrl+C")), this);
  editCopy->setStatusTip(tr("Copies the selected section to the clipboard"));
  editCopy->setWhatsThis(tr("Copy\n\nCopies the selected section to the clipboard"));
  connect(editCopy, SIGNAL(activated()), this, SLOT(slotEditCopy()));

  editUndo = new QAction(tr("Undo"), tr("&Undo"), QAccel::stringToKey(tr("Ctrl+Z")), this);
  editUndo->setStatusTip(tr("Reverts the last editing action"));
  editUndo->setWhatsThis(tr("Undo\n\nReverts the last editing action"));
  connect(editUndo, SIGNAL(activated()), this, SLOT(slotEditUndo()));

  editPaste = new QAction(tr("Paste"), tr("&Paste"), QAccel::stringToKey(tr("Ctrl+V")), this);
  editPaste->setStatusTip(tr("Pastes the clipboard contents to actual position"));
  editPaste->setWhatsThis(tr("Paste\n\nPastes the clipboard contents to actual position"));
  connect(editPaste, SIGNAL(activated()), this, SLOT(slotEditPaste()));        */

  viewToolBar = new QAction(tr("Toolbar"), tr("Tool&bar"), 0, this, 0, true);
  viewToolBar->setStatusTip(tr("Enables/disables the toolbar"));
  viewToolBar->setWhatsThis(tr("Toolbar\n\nEnables/disables the toolbar"));
  connect(viewToolBar, SIGNAL(toggled(bool)), this, SLOT(slotViewToolBar(bool)));

  viewStatusBar = new QAction(tr("Statusbar"), tr("&Statusbar"), 0, this, 0, true);
  viewStatusBar->setStatusTip(tr("Enables/disables the statusbar"));
  viewStatusBar->setWhatsThis(tr("Statusbar\n\nEnables/disables the statusbar"));
  connect(viewStatusBar, SIGNAL(toggled(bool)), this, SLOT(slotViewStatusBar(bool)));

  viewZoomBar = new QAction(tr("Zoombar"), tr("&Zoombar"), 0, this, 0, true);
  viewZoomBar->setStatusTip(tr("Enables/disables the zoombar"));
  viewZoomBar->setWhatsThis(tr("Statusbar\n\nEnables/disables the zoombar"));
  connect(viewZoomBar, SIGNAL(toggled(bool)), this, SLOT(slotViewZoomBar(bool)));

      
  windowNewWindow = new QAction(tr("New Window"), tr("&New Window"), 0, this);
  windowNewWindow->setStatusTip(tr("Opens a new view for the current document"));
  windowNewWindow->setWhatsThis(tr("New Window\n\nOpens a new view for the current document"));
  connect(windowNewWindow, SIGNAL(activated()), this, SLOT(slotWindowNewWindow()));

  windowCascade = new QAction(tr("Cascade"), tr("&Cascade"), 0, this);
  windowCascade->setStatusTip(tr("Cascades all windows"));
  windowCascade->setWhatsThis(tr("Cascade\n\nCascades all windows"));
  connect(windowCascade, SIGNAL(activated()), pWorkspace, SLOT(cascade()));

  windowTile = new QAction(tr("Tile"), tr("&Tile"), 0, this);
  windowTile->setStatusTip(tr("Tiles all windows"));
  windowTile->setWhatsThis(tr("Tile\n\nTiles all windows"));
  connect(windowTile, SIGNAL(activated()), pWorkspace, SLOT(tile()));


  windowAction = new QActionGroup(this, 0, false);
  windowAction->insert(windowNewWindow);
  windowAction->insert(windowCascade);
  windowAction->insert(windowTile);

  helpAboutApp = new QAction(tr("About"), tr("&Autor..."), 0, this);
  helpAboutApp->setStatusTip(tr("About the application"));
  helpAboutApp->setWhatsThis(tr("About\n\nAbout the application"));
  connect(helpAboutApp, SIGNAL(activated()), this, SLOT(slotHelpAbout()));

  tractaBinaritza = new QAction(tr("Binaritza..."), binaritzaIcon, tr("&Binaritza"), 0, this);
  tractaBinaritza->setStatusTip(tr("Binaritza la imatge"));
  tractaBinaritza->setWhatsThis(tr("About\n\nAbout the application"));
  connect(tractaBinaritza, SIGNAL(activated()), this, SLOT(slotTractaBinaritza()));

  tractaContorn = new QAction(tr("Contornejant..."), contornIcon, tr("&Contorneja"), 0, this);
  tractaContorn->setStatusTip(tr("Extreu el contorn de la imatge"));
  tractaContorn->setWhatsThis(tr("About\n\nAbout the application"));
  connect(tractaContorn, SIGNAL(activated()), this, SLOT(slotTractaContorn()));

  tractaContornCompara = new QAction(tr("Comparacio..."), tr("&Comparant"), 0, this);
  tractaContornCompara->setStatusTip(tr("Compara el contorn del que ens quedem"));
  tractaContornCompara->setWhatsThis(tr("About\n\nAbout the application"));
  connect(tractaContornCompara, SIGNAL(activated()), this, SLOT(slotTractaComparaContorn()));
  
  formaChang = new QAction(tr("Chang..."), changIcon, tr("&Chang"), 0, this);
  formaChang->setStatusTip(tr("Tractament"));
  formaChang->setWhatsThis(tr("About\n\nAbout the application"));
  connect(formaChang, SIGNAL(activated()), this, SLOT(slotFormaChang()));

  formaFourier1 = new QAction(tr("Fourier..."), fourierIcon, tr("&Fourier"), 0, this);
  formaFourier1->setStatusTip(tr("Tractament"));
  formaFourier1->setWhatsThis(tr("About\n\nAbout the application"));
  connect(formaFourier1, SIGNAL(activated()), this, SLOT(slotFormaFourier1()));

  formaAfegeixM = new QAction(tr("Afegeix..."),  tr("&Afegir per Fourier"), 0, this);
  formaAfegeixM->setStatusTip(tr("Afegint..."));
  formaAfegeixM->setWhatsThis(tr("About\n\nAbout the application"));
  connect(formaAfegeixM, SIGNAL(activated()), this, SLOT(slotAfegeixM()));
    
  formaAfegeixMC = new QAction(tr("Afegeix..."),  tr("&Afegir per Chang"), 0, this);
  formaAfegeixMC->setStatusTip(tr("Afegint..."));
  formaAfegeixMC->setWhatsThis(tr("About\n\nAbout the application"));
  connect(formaAfegeixMC, SIGNAL(activated()), this, SLOT(slotAfegeixMC()));
  
  GetPunts = new QAction(tr("Agafa els punts"), puntsIcon, tr("&Punts"), 0, this);
//  GetPunts = new QAction(tr("New File"), puntsIcon, tr("&New"), QAccel::stringToKey(tr("Ctrl+N")), this);
  GetPunts->setStatusTip(tr("Agafa punts de l'actual document"));
  GetPunts->setWhatsThis(tr("Agafa punts de l'actual document"));
   connect(GetPunts, SIGNAL(activated()), this, SLOT(slotMostraPunts()));

/*   viewZoomBar = new QAction(tr("Zoombar"), tr("Barra de &zoom"), 0, this, 0, true);
  viewZoomBar->setStatusTip(tr("Enables/disables the zoombar"));
  viewZoomBar->setWhatsThis(tr("Zoombar\n\nEnables/disables the zoombar"));
  connect(viewZoomBar, SIGNAL(toggled(bool)), this, SLOT(slotViewZoomBar(bool)));*/
}

void CaractApp::initMenuBar()
{
  ///////////////////////////////////////////////////////////////////
  // MENUBAR

  ///////////////////////////////////////////////////////////////////
  // menuBar entry pFileMenu
  pFileMenu=new QPopupMenu();
//  fileNew->addTo(pFileMenu);
  fileOpen->addTo(pFileMenu);
  fileClose->addTo(pFileMenu);
  pFileMenu->insertSeparator();
  fileSave->addTo(pFileMenu);
  fileSaveAs->addTo(pFileMenu);
  pFileMenu->insertSeparator();
//  filePrint->addTo(pFileMenu);
//  pFileMenu->insertSeparator();
  fileQuit->addTo(pFileMenu);

  ///////////////////////////////////////////////////////////////////
  // menuBar entry editMenu
/*  pEditMenu=new QPopupMenu();
  editUndo->addTo(pEditMenu);
  pEditMenu->insertSeparator();
  editCut->addTo(pEditMenu);
  editCopy->addTo(pEditMenu);
  editPaste->addTo(pEditMenu);
  */
  ///////////////////////////////////////////////////////////////////
  // menuBar entry viewMenu
  pViewMenu=new QPopupMenu();
  pViewMenu->setCheckable(true);
  viewToolBar->addTo(pViewMenu);
  viewStatusBar->addTo(pViewMenu);
  viewZoomBar->addTo(pViewMenu);
  ///////////////////////////////////////////////////////////////////
  // EDIT YOUR APPLICATION SPECIFIC MENUENTRIES HERE

  ///////////////////////////////////////////////////////////////////
  // menuBar entry windowMenu
  pWindowMenu = new QPopupMenu(this);
  pWindowMenu->setCheckable(true);
  connect(pWindowMenu, SIGNAL(aboutToShow()), this, SLOT(windowMenuAboutToShow()));

  ///////////////////////////////////////////////////////////////////
  // menuBar entry helpMenu
  pHelpMenu=new QPopupMenu();
  helpAboutApp->addTo(pHelpMenu);
//  pHelpMenu->insertSeparator();
//  pHelpMenu->insertItem(tr("What's &This"), this, SLOT(whatsThis()), SHIFT+Key_F1);


  ////////////////////////////////////////////////////////////////////
  //menuBar entry Tracta
  pTractaMenu=new QPopupMenu();
  tractaBinaritza->addTo(pTractaMenu);
  tractaContorn->addTo(pTractaMenu);
  tractaContornCompara->addTo (pTractaMenu);

    ////////////////////////////////////////////////////////////////////
  //menuBar entry Forma
  pFormaMenu=new QPopupMenu();
  formaChang->addTo(pFormaMenu);
  formaFourier1->addTo(pFormaMenu);
  formaAfegeixM->addTo (pFormaMenu);
  formaAfegeixMC->addTo (pFormaMenu);
  
    ////////////////////////////////////////////////////////////////////
  //menuBar entry Zoom
  pZoomMenu=new QPopupMenu();
  zoom->addTo(pZoomMenu);

  menuBar()->insertItem(tr("&File"), pFileMenu);
//  menuBar()->insertItem(tr("&Edit"), pEditMenu);
  menuBar()->insertItem(tr("&View"), pViewMenu);
   menuBar()->insertItem(tr("&Zoom"), pZoomMenu);  
  menuBar()->insertItem(tr("&Tracta"), pTractaMenu);
  menuBar()->insertItem(tr("&Forma"),pFormaMenu);
  menuBar()->insertItem(tr("&Window"), pWindowMenu);
  menuBar()->insertItem(tr("&Autor"), pHelpMenu);
  
}

void CaractApp::initToolBar()
{
  ///////////////////////////////////////////////////////////////////
  // TOOLBAR
  fileToolbar = new QToolBar(this, "file operations");
//  fileNew->addTo(fileToolbar);
  fileOpen->addTo(fileToolbar);
  fileSave->addTo(fileToolbar);
//  fileToolbar->addSeparator();
  GetPunts->addTo(fileToolbar);
//  QWhatsThis::whatsThisButton(fileToolbar);
  

}

void CaractApp::initStatusBar()
{
  ///////////////////////////////////////////////////////////////////
  //STATUSBAR
  statusBar()->message(tr("Ready."));
}

void CaractApp::initView()
{ 
  ////////////////////////////////////////////////////////////////////
  // set the main widget here
  QVBox* view_back = new QVBox( this );
  view_back->setFrameStyle( QFrame::StyledPanel | QFrame::Sunken );
  pWorkspace = new QWorkspace( view_back );
  setCentralWidget(view_back);
}


void CaractApp::createClient(CaractDoc* doc)
{
  CaractView* w = new CaractView(doc, pWorkspace,0,WDestructiveClose);
  w->installEventFilter(this);
  doc->addView(w);
  if ( pWorkspace->windowList().isEmpty() ) // show the very first window in maximized mode
    w->show();
  else
    w->show();

}

void CaractApp::openDocumentFile(const char* file)
{
 statusBar()->message(tr("Opening file..."));
 CaractDoc* doc;
  

  doc = new CaractDoc();
  pDocList->append(doc);
  doc->newDocument();
  // Creates an untitled window if file is 0
  if(!file)
  {
    untitledCount+=1;
    QString fileName=QString(tr("Untitled%1")).arg(untitledCount);
    doc->setPathName(fileName);
    doc->setTitle(fileName);
  }
  
  // Open the file
  else
  {
    if(!doc->openDocument(file))
    {
      QMessageBox::critical(this, tr("Error !"),tr("Could not open document !"));
      delete doc;
      return;
    }
  }                  
  // create the window                      
  createClient(doc);
  CaractView* v=doc->firstView();
//  v->visualize(doc->imatge.qImatge); /*tocat*/

  v->setFocus();

  statusBar()->message(tr("Ready."));

}

bool CaractApp::queryExit()
{
  int exit=QMessageBox::information(this, tr("Quit..."),
                                    tr("Do your really want to quit?"),
                                    QMessageBox::Ok, QMessageBox::Cancel);

  if (exit==1)
  {

  }
  else
  {

  };

  return (exit==1);
}

bool CaractApp::eventFilter(QObject* object, QEvent* event)
{
  if((event->type() == QEvent::Close) && ((CaractApp*)object!=this))
  {
    QCloseEvent* e=(QCloseEvent*)event;
    CaractView* pView=(CaractView*)object;
    CaractDoc* pDoc=pView->getDocument();
    if(pDoc->canCloseFrame(pView))
    {
      pDoc->removeView(pView);
      if(!pDoc->firstView())
        pDocList->remove(pDoc);

      Text->setText("");   //pq quant tanquem la finestra desapare
      e->accept();
    }
    else
      e->ignore();
  }
  else if((event->type() == QEvent::FocusIn)&&((CaractApp*)object!=this)){
     CaractView* pView=(CaractView*)object;
     CaractDoc* pDoc=pView->getDocument();
     Text->setText(pDoc->imatge.dw->Text.text());
     }

  return QWidget::eventFilter( object, event );

}

/////////////////////////////////////////////////////////////////////
// SLOT IMPLEMENTATION
/////////////////////////////////////////////////////////////////////


void CaractApp::slotFileNew()
{
  statusBar()->message(tr("Creating new file..."));

  openDocumentFile();		

  statusBar()->message(tr("Ready."));
}

void CaractApp::slotFileOpen()
{
   statusBar()->message(tr("Opening file..."));

  QString fileName = QFileDialog::getOpenFileName(QString::null,"Arxius suportats (*.raw;*.tif;*.dcm;*.pgm);;Imatges RAW (*.raw;*.RAW);;Imatges DICOM (*.dcm);;Imatges (*.png;*.bmp);;Imatges (*.tif;*.tiff);;Tots (*.*)",this);
  if (!fileName.isEmpty())
  {
     openDocumentFile(fileName);
  }
  statusBar()->message(tr("Ready."));
}


void CaractApp::slotFileSave()
{

  statusBar()->message(tr("Saving file..."));
	
  CaractView* m = (CaractView*)pWorkspace->activeWindow();
  if( m )
  {
    CaractDoc* doc = m->getDocument();
    if(doc->title().contains(tr("Untitled")) || doc->title().contains(tr("NOU")))
      slotFileSaveAs();
    else
      if(!doc->saveDocument(doc->pathName()))
        QMessageBox::critical (this, tr("I/O Error !"), tr("Could not save the current document !"));
  }

  statusBar()->message(tr("Ready."));
}

void CaractApp::slotFileSaveAs()
{
  statusBar()->message(tr("Saving file under new filename..."));
  QString fn = QFileDialog::getSaveFileName(0,"Arxiu PGM (*.pgm;*.PGM);;Tots (*.*)", this); //(0, 0, this);
  if (!fn.isEmpty())
  {
    CaractView* m = (CaractView*)pWorkspace->activeWindow();
    if( m )
    {
      CaractDoc* doc = m->getDocument();
      if(!doc->saveDocument(fn))
      {
         QMessageBox::critical (this, tr("I/O Error !"), tr("Could not save the current document !"));
         return;
      }
      doc->changedViewList();
    }
  }
  statusBar()->message(tr("Ready."));
}

void CaractApp::slotFileClose()
{
  statusBar()->message(tr("Closing file..."));
	
  CaractView* m = (CaractView*)pWorkspace->activeWindow();
  if( m )
  {
    CaractDoc* doc=m->getDocument();
    doc->closeDocument();
  }

  statusBar()->message(tr("Ready."));
}

void CaractApp::slotFilePrint()
{
  statusBar()->message(tr("Printing..."));
	
  CaractView* m = (CaractView*) pWorkspace->activeWindow();
  if ( m )
    m->print( printer );

  statusBar()->message(tr("Ready."));
}

void CaractApp::slotFileQuit()
{ 
  statusBar()->message(tr("Exiting application..."));
  ///////////////////////////////////////////////////////////////////
  // exits the Application
//  if(doc->isModified())
//  {
//    if(queryExit())
//    {
//      qApp->quit();
//    }
//    else
//    {
//
//    };
//  }
//  else
//  {
    qApp->quit();
//  };

  statusBar()->message(tr("Ready."));
}

void CaractApp::slotEditUndo()
{
  statusBar()->message(tr("Reverting last action..."));
	
  CaractView* m = (CaractView*) pWorkspace->activeWindow();
  if ( m )
//   m->undo();

  statusBar()->message(tr("Ready."));
}

void CaractApp::slotEditCut()
{
  statusBar()->message(tr("Cutting selection..."));
	
  CaractView* m = (CaractView*) pWorkspace->activeWindow();
  if ( m )
//  m->cut();	

  statusBar()->message(tr("Ready."));
}

void CaractApp::slotEditCopy()
{
  statusBar()->message(tr("Copying selection to clipboard..."));

  CaractView* m = (CaractView*) pWorkspace->activeWindow();
  if ( m )
//  m->copy();

  statusBar()->message(tr("Ready."));
}

void CaractApp::slotEditPaste()
{
  statusBar()->message(tr("Inserting clipboard contents..."));
	
  CaractView* m = (CaractView*) pWorkspace->activeWindow();
  if ( m )
//   m->paste();

  statusBar()->message(tr("Ready."));
}


void CaractApp::slotViewToolBar(bool toggle)
{
  statusBar()->message(tr("Toggle toolbar..."));
  ///////////////////////////////////////////////////////////////////
  // turn Toolbar on or off
   if (toggle== false)
  {
    fileToolbar->hide();
  }
  else
  {
    fileToolbar->show();
  };

 statusBar()->message(tr("Ready."));
}

void CaractApp::slotViewStatusBar(bool toggle)
{
  statusBar()->message(tr("Toggle statusbar..."));
  ///////////////////////////////////////////////////////////////////
  //turn Statusbar on or off
  
  if (toggle == false)
  {
    statusBar()->hide();
  }
  else
  {
    statusBar()->show();
  }

  statusBar()->message(tr("Ready."));
}
/*
void CaractApp::slotViewZoomBar(bool toggle)
{
  statusBar()->message(tr("Toggle zoombar..."));
  ///////////////////////////////////////////////////////////////////
  //turn Statusbar on or off

  if (toggle == false)
  {
    statusBar()->hide();
  }
  else
  {
    statusBar()->show();
  }

  statusBar()->message(tr("Ready."));
} */

void CaractApp::slotWindowNewWindow()
{
  statusBar()->message(tr("Opening new document view..."));
	
  CaractView* m = (CaractView*) pWorkspace->activeWindow();
  if ( m ){
    CaractDoc* doc = m->getDocument();
    createClient(doc);
  }

  statusBar()->message(tr("Ready."));
}

void CaractApp::slotHelpAbout()
{
  QMessageBox::about(this,tr("About..."),
                     tr("Reconeixement de Contorns (2003-2004)\n\nProjecte realitzat per:\n" 
                     "GERERD ALCORLO BOFILL (ETIS)"));
}

void CaractApp::slotStatusHelpMsg(const QString &text)
{
  ///////////////////////////////////////////////////////////////////
  // change status message of whole statusbar temporary (text, msec)
  statusBar()->message(text, 2000);
}

void CaractApp::windowMenuAboutToShow()
{
  pWindowMenu->clear();	
	windowNewWindow->addTo(pWindowMenu);
	windowCascade->addTo(pWindowMenu);
	windowTile->addTo(pWindowMenu);
	
  if ( pWorkspace->windowList().isEmpty() )
  {
    windowAction->setEnabled(false);
  }
  else
  {
    windowAction->setEnabled(true);
  }

  pWindowMenu->insertSeparator();

  QWidgetList windows = pWorkspace->windowList();
  for ( int i = 0; i < int(windows.count()); ++i )
  {
    int id = pWindowMenu->insertItem(QString("&%1 ").arg(i+1)+windows.at(i)->caption(), this, SLOT( windowMenuActivated( int ) ) );
    pWindowMenu->setItemParameter( id, i );
    pWindowMenu->setItemChecked( id, pWorkspace->activeWindow() == windows.at(i) );
  }
}

void CaractApp::windowMenuActivated( int id )
{
  QWidget* w = pWorkspace->windowList().at( id );
  if ( w )
    w->setFocus();
}

void CaractApp::slotTractaBinaritza()
{

  Imatge ientrada;  //Imatge d'entrada
               
  statusBar()->message(tr("Binaritzant..."));

  
  CaractView* vista = (CaractView*)pWorkspace->activeWindow();

  
    if( vista ){
    CaractDoc* doc=vista->getDocument();
      //fem que no es pugui binaritzar si la imatge no esta a tamany real
//       doc->imatge.dw->augments=1.0;
//       doc->imatge.zm.augments=1;

    if (db==NULL)
      db=new DialegBinaritza (*doc);
    else
      db->InitDialeg(*doc);
      
    db->show();
  }   


  statusBar()->message(tr("Ready."));
}

void CaractApp::slotFormaChang(){
  QString resultat;
  forma ftmp;

  CaractView* vista = (CaractView*)pWorkspace->activeWindow();
  
  if( vista ){
    CaractDoc* doc=vista->getDocument();

    ftmp.extreureMinBox(doc->imatge.imatge);
    doc->imatge.dw->augments=doc->imatge.zm.augments;
    doc->imatge.dw->xMin=ftmp.xMin-4;
    doc->imatge.dw->yMin=ftmp.yMin-4;
    doc->imatge.dw->mostraPunts=true;


    if (dc==NULL) //nomes reservem l'espai una vegada
      dc=new DialegManAuto(doc->imatge, GetInicial(doc), GetPath(doc));
    else
      dc->InitDialeg(doc->imatge, GetInicial(doc), GetPath(doc));


    dc->show();
  }    

}


void CaractApp::slotFormaFourier1(){

   CaractView* vista = (CaractView*)pWorkspace->activeWindow();

  
   if( vista ){
      int idCaract;
      forma ftmp;
      rmImage tmp;
     
      CaractDoc* doc= vista->getDocument();


      if (!doc->imatge.imatge.mesD2colors()){   //cal k l'imatge estigui binaritzada
         int n;
         CaractDoc *doc2 = new CaractDoc();
         doc2->imatge.zm=doc->imatge.zm;


         //nou document am nou titol
         QString fileName=QString(doc->title());
         QString s = fileName.section( '/', -1 );    //agafa unicament el nom
         fileName = ("(%) ");

         if (doc->imatge.dw->augments >= 1)
            n=doc->imatge.dw->augments*100;
         else
            n=doc->imatge.dw->augments/100;
        
         while(n>0){
            fileName.insert(1,(n%10)+48);
            n=n/10;
         }
         doc2->setPathName ("Contorn_" + s);
         doc2->setTitle (fileName + "Contorn_" + s);
        
        
         doc2->imatge.imatge=doc->imatge.imatge;

         //calculo larea pq a dins el dialeg nomes tinc el contorn
         ftmp.extreureMinBox(doc->imatge.imatge);
         ftmp.area(doc->imatge.imatge);

         
         doc2->imatge.Contorn(doc->imatge);
        
         //aplikem el zoom pq quedi igual
         if (doc2->imatge.zm.augments<=1)
            doc2->imatge.zm.augmentarIntel(doc2->imatge.imatge);
         else
            doc2->imatge.zm.disminuirIntel (doc2->imatge.imatge);
           
         doc2->imatge.dw->augments=doc2->imatge.zm.augments;
         doc2->imatge.dw->enfocat=true;
         doc2->imatge.dw->xMin=doc2->imatge.zm.xMin;
         doc2->imatge.dw->yMin=doc2->imatge.zm.yMin;
              
         doc2->imatge.zm.resImg(&tmp);
         doc2->imatge.ompleQImage(tmp);

         if (df==NULL)   //nomes el reservem una vegada
            df=new DialegFourier(doc2->imatge,*pDocList, ftmp.varea, GetInicial(doc));
         else
            df->InitDialeg(doc2->imatge,*pDocList, ftmp.varea, GetInicial(doc));

         df->exec();

         if (!df->CANCELAR && !df->COMPARAR){
            pDocList->append(doc2);
            doc2->newDocument();
            createClient(doc2);
            doc2->imatge.dw->mostraPunts=true;

            if (df->OpcioAfegeix->isChecked()){   //volem afegir a la BD
               OmpleBDcaractGlobF (df, doc2, idCaract, GetPath(doc));
               OmpleBDdescriptFourier (df, doc2, idCaract);
            }
            else if (df->OpcioRec->isChecked()){  //volem fer una consulta
               QString str;
               if (df->OpcioFourier1->isChecked()){
                  if (!df->OpcioRecFF->isChecked()){ 
                     str=doc2->imatge.dw->Text.text();
                     MontarLlistaNoms (df);
                     CalcularMitjanesNoms (df);
                     str+="\n";
                     str+=MesSemblant (df);
                     doc2->imatge.dw->Text.setText(str);            
                  }
                  else{ //volem la consulta unicament mirant matxambrat
                     str=doc2->imatge.dw->Text.text();
                     ConsultaFmatxambrat (15, df);  //15 = FF1
//                     str+=" \n ";
//                     str=str+"\n";
//                     str= str + "S'ASSEMBLA A: ";
                     str+= qStrToChar (ComparaFFx (df));
                     doc2->imatge.dw->Text.setText(str);
                  }
               }
               else if (df->OpcioFourier2->isChecked()){
                  if (!df->OpcioRecFF->isChecked()){
                     str=doc2->imatge.dw->Text.text();
                     MontarLlistaNoms (df);
                     CalcularMitjanesNoms (df);
                     str+="\n";
//                     str+="S'ASSEMBLA A ";
                     str+=MesSemblant (df);
                     doc2->imatge.dw->Text.setText(str);
                  }
                  else{ //volem la consulta unicament mirant matxambrat
                     str=doc2->imatge.dw->Text.text();                  
                     ConsultaFmatxambrat (18, df);  //18 = FF2
                     str+=" \n ";
                     str=str+"\n";
//                     str= str + "S'ASSEMBLA A: ";
                     str+= qStrToChar (ComparaFFx (df));
                     doc2->imatge.dw->Text.setText(str);
                  }
               }
            }
            else if (df->OpcioCBIR->isChecked()){   //Consulta per CBIR             
                ConsultaCBIR(df);

                if (dSortida !=NULL)
                  delete dSortida;
                  
//                if (dSortida==NULL)
                   dSortida = new DSortidaCerca(pWorkspace,"Dades de la cerca",WDestructiveClose,*llista_dist);

                dSortida->setExtension(0);
                dSortida->exec();

             
//                cout << "fem la consulta a la CBIR" << endl;
            }
       }
       else if (df->COMPARAR && !df->CANCELAR){ //ES COMPAREN DUES IMATGES ES PASSA PER AKET ELSE
            df->docs[0]->imatge.dw->mostraPunts=true;
            df->docs[1]->imatge.dw->mostraPunts=true;
            createClient(df->docs[0]);
            createClient(df->docs[1]);
       }
       else //SHA CANCELAT EL DIALEG DE FOURIER
         delete doc2;
   }
   else{//la imatge no esta binaritzada
      QMessageBox::critical(this, tr("Error !"),tr("La imatge no esta binaritzada!"));
   }   
   }
}


char *CaractApp::qStrToChar(const QString &fileName){
  char *fitxer;
  QChar ch;

  fitxer = new char[500];

    for(uint i= 0;i<fileName.length();i++){
      ch = fileName.at( i );
      fitxer[i] = ch.cell();
    }
    fitxer[fileName.length()] = '\0';
    return fitxer;
}



void CaractApp::slotAgafaPunts(){

  CaractView* vista = (CaractView*)pWorkspace->activeWindow();

  
  if( vista )  //Hi ha finestra activa
  {
   CaractDoc* doc=vista->getDocument();

   doc->imatge.dw->EsborrarLlista();

   if (vista->getDocument()->imatge.dw->AgafoPunts)
        vista->getDocument()->imatge.dw->AgafoPunts=FALSE;
   else
        vista->getDocument()->imatge.dw->AgafoPunts=TRUE;
   }
   
}

//Omplim la taula amb totes les caracteristiques de la imatge menys els descriptors
void CaractApp::OmpleBDcaractGlobF (DialegFourier *d, CaractDoc *doc, int &IdCaract, char* path){
  char query[100];
  char fetch[100];
  char close[100];
  char insert[300];

   if (d->afegir){
        pgAcces *data = new pgAcces();
        sprintf(query,"DECLARE buscaId1 CURSOR FOR select * from \"CaractGlob\"");
        sprintf(fetch,"FETCH ALL in buscaId1");
        sprintf(close,"CLOSE buscaId1");
        IdCaract = data->cercaId(query,fetch,close);


        double ff1,ff2;
        int df1,df2;
        if(d->OpcioFourier1->isChecked()){       //treballem am complexes
            ff1=d->formaF->resultat;
            ff2 = -1.0;
            if (d->OpcioEquidistants->isChecked()){
               bool bolea;
               df1 = d->EntradaPas->text().toInt(&bolea);
            }
            else{
               df1= doc->imatge.dw->llista->count()-1;            
            }
            df2 = -1;
         }
         else{                                           //treballem amb moduls
            ff2=d->formaF->resultat;
            ff1 = -1.0;
            if (d->OpcioEquidistants->isChecked()){
               bool bolea;
               df2 =  d->EntradaPas->text().toInt(&bolea) / 2;    //nomes ens quedem amb la meitat de descriptors
            }
            else{
               df2= doc->imatge.dw->llista->count()-1;               
            }
            df1 = -1;
         }

                                                                                                                                                                                                                                                                                                                                                              
        sprintf(insert,"INSERT INTO \"CaractGlob\" VALUES (%d,'%s',%d,%f, %f,%d,%d,%d,%d,%f,%f,%f,%f, %f,%f,%f,%d,-1,%f,%d,'%s')",
       
//        sprintf(insert,"INSERT INTO \"CaractGlob\" VALUES (%d,'%s',%d,%f, %f,%d,%d,%d,%d, %f, %f,%f,%f,%f,%f,-1, -1,%d,-1,-1, '%s')",
   
                IdCaract,
                qStrToChar(d->nom->text()),
                d->tipus,
                d->f->varea,
                doc->imatge.contorn->perimetre,
                d->f->xMin,
                d->f->yMin,
                d->f->xMax,
                d->f->yMax,
                d->f->vcompactness,
                d->f->vlength,
                d->f->vbreadth,
                d->f->velongacio,
                d->f->vcentroidX,
                d->f->vcentroidY,
                ff1,
                df1,
                ff2,
                df2,
                path);

//       cout << "insertaaa " << insert << endl;
        data->insertCaract(insert);

//        data.Exec(close);
//        data.Exec("END");
     }
}



void CaractApp::OmpleBDdescriptFourier (DialegFourier *d, CaractDoc *doc, int &IdCaract){
  char query[100];
  char fetch[100];
  char close[100];
  char insert[100];
  int i, total_descriptors;

   if (d->afegir){
     int idFourier=0;
     pgAcces *data = new pgAcces();
     sprintf(query,"DECLARE buscaId CURSOR FOR select * from \"DesFourier\"");
     sprintf(fetch,"FETCH ALL in buscaId");
     sprintf(close,"CLOSE buscaId");
//     idFourier = data->cercaId(query,fetch,close);

     total_descriptors=d->formaF->descriptZ.plensFD;
        for (i=0;i<total_descriptors;i++){
           sprintf(insert,"INSERT INTO \"DesFourier\" VALUES (%d,%d,%f)", IdCaract, idFourier++, d->formaF->descriptZ.FD[i]);
           data->insertCaract(insert);
        }
   }
}


void CaractApp::slotTractaContorn()
{

  Imatge ientrada;  //Imatge d'entrada

  statusBar()->message(tr("Extreiem contorn..."));


  CaractView* vista = (CaractView*)pWorkspace->activeWindow();

    if( vista ){
    CaractDoc* doc=vista->getDocument();

    CaractDoc *doc2 = new CaractDoc();
    doc2->imatge.zm=doc->imatge.zm;
/*    
    doc2->imatge.zm.w=doc->imatge.zm.w;
    doc2->imatge.zm.h=doc->imatge.zm.h;
    doc2->imatge.zm.wencaixat=doc->imatge.zm.wencaixat;
    doc2->imatge.zm.hencaixat=doc->imatge.zm.hencaixat;
  */  

     //nou document am nou titol
    QString fileName=QString(doc->title());
    QString s = fileName.section( '/', -1 );    //agafa unicament el nom
    doc2->setTitle("NOU_"+s);

    doc2->imatge.imatge=doc->imatge.imatge;
    
    doc2->imatge.Contorn(doc->imatge);
    
    rmImage tmp;
    if(doc2->imatge.zm.w!=doc2->imatge.imatge.dimX && doc2->imatge.zm.h!=doc2->imatge.imatge.dimY){
      doc2->imatge.zm.aplicarZoom(doc2->imatge.imatge,doc2->imatge.zm.w,doc2->imatge.zm.h);
      doc2->imatge.zm.resImg(&tmp);
      doc2->imatge.ompleQImage(tmp);
    }
    else doc2->imatge.ompleQImage();

    
    pDocList->append(doc2);
    doc2->newDocument();
    createClient(doc2);
    }

  statusBar()->message(tr("Ready."));

}


void CaractApp::slotTractaComparaContorn()
{

  Imatge ientrada;  //Imatge d'entrada

  statusBar()->message(tr("Extreiem contorn..."));


  CaractView* vista = (CaractView*)pWorkspace->activeWindow();

    if( vista ){
      coordenades *el;
       
      CaractDoc* doc=vista->getDocument();

      CaractDoc *doc2 = new CaractDoc();
      doc2->imatge.zm=doc->imatge.zm;
      
      //nou document am nou titol
      QString fileName=QString(doc->title());
      QString s = fileName.section( '/', -1 );    //agafa unicament el nom
      doc2->setTitle("NOU_"+s);

      doc2->imatge.imatge=doc->imatge.imatge;

      doc2->imatge.Contorn(doc->imatge);
     
      doc2->imatge.RecorreAntihorari();

      //pintem de colors gris els punts k realment ens kedem
      el=doc2->imatge.contorn->first();
      while (el->X!=-1){
         doc2->imatge.imatge.data (el->X, el->Y)=128;
         el=doc2->imatge.contorn->next();
      }


    rmImage tmp;
    if(doc2->imatge.zm.w!=doc2->imatge.imatge.dimX && doc2->imatge.zm.h!=doc2->imatge.imatge.dimY){
      doc2->imatge.zm.aplicarZoom(doc2->imatge.imatge,doc2->imatge.zm.w,doc2->imatge.zm.h);
      doc2->imatge.zm.resImg(&tmp);
      doc2->imatge.ompleQImage(tmp);
    }
    else doc2->imatge.ompleQImage();

        cout << "total  " << doc2->imatge.contorn->count () << endl;    
    doc2->imatge.dw->EsborrarLlista();


    pDocList->append(doc2);
    doc2->newDocument();
    createClient(doc2);
    }

  statusBar()->message(tr("Ready."));

}


void CaractApp::ConsultaF (int metodeF, DialegFourier *d){
  char query[100];
  char fetch[100];
  char close[100];


  QString nomfig;
  int  nFields, nTuples, i, tmp, figdif, total_nostre, tipus_im;
  atom atm;

  llistadiferents = new llistaID;


  PgDatabase data(dbName);
	if ( data.ConnectionBad() ){
		cerr << "Connection to database '" << dbName << "' failed." << endl
		<< "Error returned: " << data.ErrorMessage() << endl;
    return -1;
	}
  else{
     sprintf(query,"DECLARE dadesPc CURSOR FOR select * from \"CaractGlob\"");
     sprintf(fetch,"FETCH ALL in dadesPc");
     sprintf(close,"CLOSE dadesPc");

	  if ( !data.ExecCommandOk("BEGIN") ){
		  cerr << "BEGIN command failed" << endl;
      return -1;
  	}

   if ( !data.ExecCommandOk(query) ){
    	cerr << "DECLARE CURSOR command failed" << endl;
      return -1;
  	}

  	if ( !data.ExecTuplesOk(fetch) ){
	  	cerr << "FETCH ALL command didn't return tuples properly" << endl;
      return -1;
  	}
    //guardem els resultats obtinguts a una estructura global
  	nFields = data.Fields();
   nTuples = data.Tuples();


    //contem les figures diferents k tenim per fourier metodeF
    figdif=0;
    for (i=0;i<nTuples;i++){
      tmp=atoi(data.GetValue(i, metodeF));  //metodeF indica si F1 o F2
      if (tmp !=-1){    //comprovem k haguem fet FourierX
         tipus_im=atoi(data.GetValue(i,2));
            total_nostre=d->formaF->mostres;
               atm.nom=data.GetValue(i, 1);  //1 = nom
               atm.Descrip=ConsultaValorsFourier(atoi(data.GetValue(i,0)), total_nostre, tmp);  //camp clau

               if (! llistadiferents->ja_hi_es(atm.nom)){ //NO ES A LA LLISTA
                     llistadiferents->Afegim(atm, total_nostre);
                  figdif++;
               }
               else{ //ja tenim el tipus a la llista
                     llistadiferents->Acumulem(atm, total_nostre);
               }
      }
   }
 }


//    punter=llistadiferents->first();
//    cout << "comprobem" << endl;
//    for (i=0;i<total_nostre;i++){
//      cout << punter->DCH[i] << "  ";
//      punter=llistadiferents->next();
//    }
//        cout << endl;


	data.Exec(close);
  data.Exec("END");

}



float* CaractApp::ConsultaValorsFourier(int identificador, int mostres, int mostresBD){
   float *espai;
   int i, k, e, total_zeros; 
  char query[100];
  char fetch[100];
  char close[100];


  PgDatabase data(dbName);
	if ( data.ConnectionBad() ){
		cerr << "Connection to database '" << dbName << "' failed." << endl
		<< "Error returned: " << data.ErrorMessage() << endl;
    return -1;
	}
  else{
     sprintf(query,"DECLARE valFourier CURSOR FOR select * from \"DesFourier\"");
     sprintf(fetch,"FETCH ALL in valFourier");
     sprintf(close,"CLOSE valFourier");

	  if ( !data.ExecCommandOk("BEGIN") ){
		  cerr << "BEGIN command failed" << endl;
      return -1;
  	}

   if ( !data.ExecCommandOk(query) ){
    	cerr << "DECLARE CURSOR command failed" << endl;
      return -1;
  	}

  	if ( !data.ExecTuplesOk(fetch) ){
	  	cerr << "FETCH ALL command didn't return tuples properly" << endl;
      return -1;
  	}

   espai = new float[mostres];

   i=0;
   while (atoi(data.GetValue(i, 0)) != identificador)   //busquem el camp clau
      i++;


   if (mostres > mostresBD)   //si a la BD hi ha menys mostre d les k volem omplirem la resta amb 0's
      k=i+mostresBD;
   else                               //si a la BD hi ha mes mostres agafem unicament les k ens interessa
      k=i+mostres;


      
   e=0;
   for (; i<k; i++){
      espai[e]=atof(data.GetValue (i, 2));
      e++;
   }

   if (mostres > mostresBD){  //si a la BD hi ha menys valors inicialitzem el k falta a 0
      total_zeros= mostres-mostresBD;
      for (i=0;i<total_zeros;i++){
         espai[e]=0.0;
         e++;
      }
   }
      
/*   for (i=0;i<mostres;i++)
      cout << espai[i] << "  " << endl;

      cout << "fi d lo k sigui" << endl << endl;
  */    
  	data.Exec(close);
   data.Exec("END");

    return (espai);
 }
}


//Diu a quina figura s'assembla mes la imatge consultada
QString CaractApp::ComparaAmbMitja(DialegFourier *d){
     int i, total, total_tipus;
     atom *cursor;
     float min;
     double fou;
     QString etiqueta, diferencia, dif;


     total_tipus=0;
     total=d->formaF->descriptZ.plensFD;

     cursor=llistadiferents->first();
     while (cursor){    //fem la mitja per cada tipus
         for (i=0;i<total;i++){
            cursor->Descrip[i]/=cursor->total;
         }

         cursor=llistadiferents->next();
     }

     cursor=llistadiferents->first();     //elevem al quadrat la resta dels descriptors de chang de la mitjana i els nostres
     while (cursor){
        for (i=0;i<total;i++){
            fou=d->formaF->descriptZ.FD[i];
            cursor->Descrip[i]=pow(cursor->Descrip[i]-fou, 2.0);
        }
        cursor=llistadiferents->next();
     }



     cursor=llistadiferents->first();     //fem l'arrel de la suma dels valors de chang anteriors
     while (cursor){    //elevem al quadrat la resta dels descriptors de chang de la mitjana i els nostres
         for (i=1;i<total;i++){
            cursor->Descrip[0]+=cursor->Descrip[i];
         }

         cursor->Descrip[0]=sqrt (cursor->Descrip[0]); //fem l'arrel

         cursor=llistadiferents->next();
     }

     cursor=llistadiferents->first();     //busquem el k ha sortit el valor mes petit
     min=cursor->Descrip[0];
     etiqueta=cursor->nom;
     while (cursor){                         //aixo indica k es el tipus d figura k mes s'assembla
        if (cursor->Descrip[i] < min){
           etiqueta=cursor->nom;
           diferencia=dif.setNum(cursor->Descrip[i]);
           }

         cursor=llistadiferents->next();
     }

     dif="    ";
     etiqueta+=dif + diferencia;
     return (etiqueta);
}


void CaractApp::ConsultaFmatxambrat (int metodeF, DialegFourier *d){
  char query[100];
  char fetch[100];
  char close[100];


  QString nomfig;
  int nFields, nTuples, i, figdif, tipus_im;
  double tmp;
  atom atm;

  llistadiferents = new llistaID;


  PgDatabase data(dbName);
	if ( data.ConnectionBad() ){
		cerr << "Connection to database '" << dbName << "' failed." << endl
		<< "Error returned: " << data.ErrorMessage() << endl;
    return -1;
	}
  else{
     sprintf(query,"DECLARE dadesPc CURSOR FOR select * from \"CaractGlob\"");
     sprintf(fetch,"FETCH ALL in dadesPc");
     sprintf(close,"CLOSE dadesPc");

	  if ( !data.ExecCommandOk("BEGIN") ){
		  cerr << "BEGIN command failed" << endl;
      return -1;
  	}

   if ( !data.ExecCommandOk(query) ){
    	cerr << "DECLARE CURSOR command failed" << endl;
      return -1;
  	}

  	if ( !data.ExecTuplesOk(fetch) ){
	  	cerr << "FETCH ALL command didn't return tuples properly" << endl;
      return -1;
  	}
    //guardem els resultats obtinguts a una estructura global
  	nFields = data.Fields();
    nTuples = data.Tuples();


    //contem les figures diferents k tenim per fourier metodeF
    figdif=0;
    for (i=0;i<nTuples;i++){
      tmp=atof(data.GetValue(i, metodeF));  //metodeF indica si F1 o F2
      if (tmp !=-1){    //comprovem k haguem fet FourierX
         tipus_im=atoi(data.GetValue(i,2));  
            atm.nom=data.GetValue(i, 1);  //1 = nom
            atm.Descrip = new float;
            *(atm.Descrip) = tmp;

            if (! llistadiferents->ja_hi_es(atm.nom)){ //NO ES A LA LLISTA
               llistadiferents->Afegim(atm, 1);   //1 pq nomes tenim un valor
               figdif++;
            }
            else{ //ja tenim el tipus a la llista
                  llistadiferents->Acumulem(atm, 1);  //1 pq nomes tenim un valor
            }
      }
   }
 }

  data.Exec(close);
  data.Exec("END");

}

//Retorna la classe de figura que mes sassembla a la que tenim mirant FFx
QString CaractApp::ComparaFFx (DialegFourier *d){
   atom *a;
   float minim;
   QString cadena, tmp1, tmp2, sembla;
   
   a=llistadiferents->first();      //fem la resta entre el nostra i el k tenim a la llista k hem extret d fer la mitja a la BD
   while (a){
      a->Descrip[0]=fabs ((a->Descrip[0]/(double)a->total) - d->formaF->resultat);
      a=llistadiferents->next();
   }


   cadena="\n\n        TIPUS       DIFERENCIA\n";
   cadena+="      --------------------------------\n";
   
   
   a=llistadiferents->first();     //busquem el valor mes petit de manera que aquell sera el tipus
   minim=a->Descrip[0];
   sembla=a->nom;
   while (a){
      cadena+="\t" + a->nom + "\t" + tmp2.setNum(a->Descrip[0]) + "\n";
      if (minim > a->Descrip[0]){
         minim=a->Descrip[0];
         sembla=a->nom;
      }
      a=llistadiferents->next();
   }

   cadena+="\n\nS'ASSEMBA  A:  " + sembla;
   return (cadena);
}


char* CaractApp::GetPath(CaractDoc* doc){
   QString fileName=QString(doc->title());
   int pos;
   pos=fileName.find ( "BD", 0);

   fileName.remove (0, pos+3);   //alerta no guardo la primera barra!!
            
   return (qStrToChar(fileName));
   }

char* CaractApp::GetInicial(CaractDoc *doc){
   QString fileName=QString(doc->title());
   QString s = fileName.section( '/', -1 );    //agafa unicament el nom
   QChar c;
   
   c=s.at(0);
   s=c;
   return (qStrToChar(s));
   }


void CaractApp::ConsultaCBIR (DialegFourier *d){
   char query[250];
   char fetch[100];
   char close[100];
   int i, j;

   
   PgDatabase data(dbName);
   if ( data.ConnectionBad() ){
      cerr << "Connection to database '" << dbName << "' failed." << endl
      << "Error returned: " << data.ErrorMessage() << endl;
      return -1;
   }
   else{
      sprintf(query, MontaConsulta(d, "apunta", "CaractGlob"));
//cout << "query K MIRO" << endl << query << endl;
      sprintf(fetch,"FETCH ALL in apunta");
      sprintf(close,"CLOSE apunta");

      if ( !data.ExecCommandOk("BEGIN") ){
         cerr << "BEGIN command failed" << endl;
         return -1;
      }

      if ( !data.ExecCommandOk(query) ){
         cerr << "DECLARE CURSOR command failed" << endl;
         return -1;
      }

      if ( !data.ExecTuplesOk(fetch) ){
         cerr << "FETCH ALL command didn't return tuples properly" << endl;
         return -1;
      }

      
      if (!d->MesSemblants->text())  //tha buit
         recuperaX=0;
      else
         recuperaX=d->MesSemblants->text().toInt();
         
      if (d->OpcioRecFF->isChecked()){ //nomes hem de treballar amb CaractGlob i no cal normalitzar
         CalcularMitjana (d, data);
         CalcularTeta (data);
         CalculaDistanEucli (d, data, mitja.plens-data.Fields()+4);    //Calcula la distancia eunclidiana de totes les figures         
      }
      else{      
         CalcularMitjana(d, data);    //omple el mitja.dades amb la mitja de cada columna i la mitja d fourier
         CalcularTeta (data);          //omple el mitja.dades amb la varianca de cada columna
         CalcularMitjanaF (mitja.plens-data.Fields()+4, data);
         CalcularDesviacioF (mitja.plens-data.Fields()+4, data);
         CalculaDistanEucli (d, data, mitja.plens-data.Fields()+4);    //Calcula la distancia eunclidiana de totes les figures
      }


      data.Exec(close);
      data.Exec("END");

   }

}





//Genera una taula amb els camps seleccionats per lusuari i la informacio que ens falta per retornar el path
char* CaractApp::MontaConsulta(DialegFourier *d, QString cursor, QString taula){
   QString cadena;
   uint longitud;
   QString cua;

   cadena="DECLARE ";
   cadena+=cursor;
   cadena+=" CURSOR FOR select ";

   cadena+="\"IdF\", \"Nom\", \"path\", ";

   //Comprobem per quin metode hem de buscar
   if (d->OpcioFourier1->isChecked() && !d->OpcioRecFF->isChecked()){
      cadena+=" \"DF1\", ";
      cua=" WHERE \"DF1\" != -1";
   }
   else if (d->OpcioFourier2->isChecked()  && !d->OpcioRecFF->isChecked()){
      cadena+=" \"DF2\", ";
      cua=" WHERE \"DF2\" != '-1'";
   }
   else if (d->OpcioFourier1->isChecked() && d->OpcioRecFF->isChecked()){ //nomes interve CaractGlob
      cadena+= " \"FF1\", ";
      cua=" WHERE \"FF1\" != '-1'";
   }
   else if (d->OpcioFourier2->isChecked()  && d->OpcioRecFF->isChecked()){ //nomes interve CaractGlob
      cadena+= " \"FF2\", ";
      cua=" WHERE \"FF2\" != '-1'";
   }

   if (d->OpcioArea->isChecked())
      cadena+="\"Area\", ";
   if (d->OpcioPerimetre->isChecked())
      cadena+="\"Perimetre\", ";
   if (d->OpcioMinRectangle->isChecked())
      cadena+="\"MinX\", \"MinY\", \"MaxX\", \"MaxY\", ";
   if (d->OpcioCompactnes->isChecked())
      cadena+="\"Compactness\", ";
   if (d->OpcioLength->isChecked())
      cadena+="\"Length\", ";
   if (d->OpcioBreadth->isChecked())
      cadena+="\"Breadth\", ";
   if (d->OpcioElongation->isChecked())
      cadena+="\"Elongation\", ";
   if (d->OpcioCentreGravetat->isChecked())
      cadena+="\"CgravetatX\", \"CgravetatY\", ";

   CadenaSpecifica (d); //montem un vector amb les dades escollides

   longitud=cadena.length();

   cadena.remove(longitud-2, 2);


   cadena+=" from \"" + taula + "\"" +cua;
   
   
   if (d->OpcioMamo2->isChecked())
      cadena+=" AND \"Tipus\"='0' ";
   else if (d->OpcioSintet2->isChecked())
      cadena+=" AND \"Tipus\"='1' ";
   else if (d->OpcioFurqui2->isChecked())
      cadena+=" AND \"Tipus\"='2' ";


   return (qStrToChar(cadena));

}

//sha de mirar de tota la taula. el filtres es k han de ser del mateix tipus i ja ho he imposat
void CaractApp::CalcularMitjana(DialegFourier *d, PgDatabase &data){
   int i, j, nTuples, nFields;


   nFields = data.Fields();
   nTuples = data.Tuples();

   if (d->OpcioRecFF->isChecked()){ //nomes hem de treballar amb CaractGlob
      mitja.dades = new t_node[nFields-3];
      mitja.plens=nFields-3;


      for (i=0;i<mitja.plens;i++){  //inicialitzem el vector a 0
         mitja.dades[i].val=0.0;
      }

      //acumulem la mitjana de les caracteristiques sense els descriptors
      for (j=3; j<nFields;j++){   //les caracteristiques comencen a partir del tercer camp
         for (i=0; i<nTuples;i++){
            mitja.dades[j-3].val+=(double)atof(data.GetValue(i,j));
         }
            mitja.dades[j-3].val/=(double)nTuples;
      }
   

   /*cout << "vector mitjana" << endl;
   for (i=0;i<nFields-3;i++)
      cout << mitja.dades[i].val << "   ";
   cout << endl;                        */
   }
   else{  //hem d'agafar els descriptors de fourier
      mitja.dades = new t_node[nFields-4+d->formaF->descriptZ.plensFD];  //tenim el camp DFx k no caonta
      mitja.plens=nFields-4+d->formaF->descriptZ.plensFD;

      for (i=0;i<mitja.plens;i++){
         mitja.dades[i].val=0.0;
         mitja.dades[i].total=0;
      }

      //acumulem la mitjana de les caracteristiques sense els descriptors
      for (j=4; j<nFields;j++){   //les caracteristiques comencen a partir del tercer camp
         for (i=0; i<nTuples;i++){
            mitja.dades[j-4].val+=(double)atof(data.GetValue(i,j));
         }
            mitja.dades[j-4].val/=(double)nTuples;
      }


/*      cout << "a fora " << endl;
      for (i=0; i<mitja.plens;i++)
         cout << mitja.dades[i].val << "   ";
      cout << endl; */
   }    

}

//Munta un vector amb les caracterisitques seleccionades de la imatge actual ordenades tal com estan a la BD
void CaractApp::CadenaSpecifica (DialegFourier *d){
   int i=0;
//   int a;

   if (d->OpcioRecFF->isChecked())
      i++;
   if (d->OpcioArea->isChecked())
      i++;
   if (d->OpcioPerimetre->isChecked())
      i++;
   if (d->OpcioMinRectangle->isChecked())
      i+=4;
   if (d->OpcioCompactnes->isChecked())
      i++;
   if (d->OpcioLength->isChecked())
      i++;
   if (d->OpcioBreadth->isChecked())
      i++;
   if (d->OpcioElongation->isChecked())
      i++;
   if (d->OpcioCentreGravetat->isChecked())
      i+=2;

   caracSelec = new double[i];

//   a=i;

   i=0;

   if (d->OpcioRecFF->isChecked())
      caracSelec[i]=d->formaF->resultat;
      
   if (d->OpcioArea->isChecked()){
      caracSelec[i]=d->f->varea;
      i++;
   }
   if (d->OpcioPerimetre->isChecked()){
      caracSelec[i]=d->f->vperimetre;
      i++;
   }
   if (d->OpcioMinRectangle->isChecked()){
      caracSelec[i]=(double)d->f->xMin;
      i++;
      caracSelec[i]=(double)d->f->yMin;
      i++;
      caracSelec[i]=(double)d->f->xMax;
      i++;
      caracSelec[i]=(double)d->f->yMax;
      i++;
   }
   if (d->OpcioCompactnes->isChecked()){
      caracSelec[i]=d->f->vcompactness;
      i++;
   }
   if (d->OpcioLength->isChecked()){
      caracSelec[i]=d->f->vlength;
      i++;
   }
   if (d->OpcioBreadth->isChecked()){
      caracSelec[i]=d->f->vbreadth;
      i++;
   }
   if (d->OpcioElongation->isChecked()){
      caracSelec[i]=d->f->velongacio;
      i++;
   }
   if (d->OpcioCentreGravetat->isChecked()){
      caracSelec[i]=d->f->vcentroidX;
      i++;
      caracSelec[i]=d->f->vcentroidY;
   }

     /*
   cout << endl << "VECTOR ACTUAL" << endl;
   for (i=0; i<a; i++)
      cout << caracSelec[i] << "   ";
   cout << endl;
    */
}

//Calculem la desvacio per l'area,... ho he de fer a la taula CaractGlob
void CaractApp::CalcularTeta (PgDatabase &data){
   int i, j, nFields, nTuples;
   double acumula;

   nFields = data.Fields();
   nTuples = data.Tuples();

   
   acumula=0.0;
   for (j=4; j<nFields;j++){   //les caracteristiques comencen a partir del tercer camp
      for (i=0; i<nTuples;i++){                                     
         acumula+=pow ((double)atof(data.GetValue(i,j)) - (double)mitja.dades[j-4].val, 2.0);
      }
      mitja.dades[j-4].val=acumula / (double)nTuples;
      acumula=0.0;
   }

   for (i=4; i<nFields;i++)
      mitja.dades[i-4].val=sqrt (mitja.dades[i-4].val);
      
/*   cout << "vector teta" << endl;
   for (i=0;i<nFields-4;i++)
      cout << mitja.dades[i].val << "   ";
   cout << endl;         */
}


//Hem de calcular la mitja per cada valor de fourier k tinguem per tal de calcular la desviacio          
void CaractApp::CalcularMitjanaF (int total_descriptors, PgDatabase &data){
   int i, nTuples, k;
   int  conta, total_dif;
   char query[100];
   char fetch[100];
   char close[100];

   total_dif=data.Tuples();
   
   PgDatabase datades(dbName);
   if ( datades.ConnectionBad() ){
      cerr << "Connection to database '" << dbName << "' failed." << endl
      << "Error returned: " << datades.ErrorMessage() << endl;
      return -1;
   }
   else{
      sprintf(fetch,"FETCH ALL in apuntaDES");
      sprintf(close,"CLOSE apuntaDES");
      acumula = new t_node[total_descriptors];

      for (i=0; i<total_descriptors; i++){
         acumula[i].val=0.0;
         acumula[i].total=0;
      }
      
      for (k=0; k < total_dif; k++){
         sprintf(query, "DECLARE apuntaDES CURSOR FOR select * FROM \"DesFourier\" WHERE \"IdCaract\"=");
         strcat (query,data.GetValue(k, 0));
         if ( !datades.ExecCommandOk("BEGIN") ){
            cerr << "BEGIN command failed" << endl;
            return -1;
         }

         if ( !datades.ExecCommandOk(query) ){
            cerr << "DECLARE CURSOR command failed" << endl;
            return -1;
         }

         if ( !datades.ExecTuplesOk(fetch) ){
            cerr << "FETCH ALL command didn't return tuples properly" << endl;
            return -1;
         }


         nTuples = datades.Tuples();

         i=0;
         conta=0;
         while ((i < nTuples) && (conta < total_descriptors)){
            acumula[conta].val+=atof (datades.GetValue(i, 2));  //acumula els valors d fourier
            acumula[conta].total++;
            i++;
            conta++;
         }

         datades.Exec(close);
         datades.Exec("END");
      }


      for (i=0; i< total_descriptors;i++) //en cas de tenir mes FD k a la BD inicialitzem total
         if (acumula[i].total==0)
            acumula[i].total=1; 

      for (i=0; i< total_descriptors;i++){
         acumula[i].val/=(double)acumula[i].total;
         acumula[i].val=sqrt(acumula[i].val);
      }
                                             
      
  
         
      //ho colloquem on tenim totes les mitjanes
      int inici;
      inici=mitja.plens-total_descriptors;
      for (i=0; i< total_descriptors;i++)
         mitja.dades[inici+i].val=acumula[i].val;

   }
}



//Calcula la desviacio pels descriptors de fourier
void CaractApp::CalcularDesviacioF (int total_descriptors, PgDatabase &data){
   int i, nTuples, k;
   int conta, total_dif;
   char query[100];
   char fetch[100];
   char close[100];
   double *teta;

   total_dif=data.Tuples();

   PgDatabase datades(dbName);
   if ( datades.ConnectionBad() ){
      cerr << "Connection to database '" << dbName << "' failed." << endl
      << "Error returned: " << datades.ErrorMessage() << endl;
      return -1;
   }
   else{
      sprintf(fetch,"FETCH ALL in apuntaDES");
      sprintf(close,"CLOSE apuntaDES");

      total_dif=data.Tuples();
      
      teta = new double[total_descriptors];


      for (i=0; i<total_descriptors; i++)
         teta[i]=0.0;
         

      for (k=0; k < total_dif; k++){
         sprintf(query, "DECLARE apuntaDES CURSOR FOR select * FROM \"DesFourier\" WHERE \"IdCaract\"=");
         strcat (query,data.GetValue(k, 0));

         if ( !datades.ExecCommandOk("BEGIN") ){
            cerr << "BEGIN command failed" << endl;
            return -1;
         }

         if ( !datades.ExecCommandOk(query) ){
            cerr << "DECLARE CURSOR command failed" << endl;
            return -1;
         }

         if ( !datades.ExecTuplesOk(fetch) ){
            cerr << "FETCH ALL command didn't return tuples properly" << endl;
            return -1;
         }


         nTuples = datades.Tuples();

         i=0;
         conta=0;
         while ((i < nTuples) && (conta < total_descriptors)){
            teta[conta]+=pow (atof (datades.GetValue(i, 2))-acumula[conta].val, 2.0);
            i++;
            conta++;
         }

         datades.Exec(close);
         datades.Exec("END");
      }



      for (i=0; i< total_descriptors;i++){
         teta[i]/=(double)acumula[i].total;
         teta[i]=sqrt(teta[i]);
      }

      for (i=0; i< total_descriptors;i++) //en cas de ser 0 la desviacio hi posem un 1 pq no peti
         if (teta[i]==0)
            teta[i]=1;

      //ho colloquem on tenim totes les mitjanes
      int inici;
      inici=mitja.plens-total_descriptors;
      for (i=0; i< total_descriptors;i++)
         mitja.dades[inici+i].val=teta[i];


/*      cout << "tetaaaaaa   ";
      for (i=0; i< mitja.plens;i++)
         cout << mitja.dades[i].val << "   ";
      cout << endl;               */
   }             
}                                   

//Calcula la distncia euclidiana de totes les imatges k s'assemblen
void CaractApp::CalculaDistanEucli (DialegFourier *d, PgDatabase &data, int total_descriptors){
   int i, files;
  ID_EUC *nova_distancia;

   llista_dist = new list_ID_EUC;

   files=data.Tuples();

       
   //lista amb totes les distancies euclidianes i identificador de la figura
   for (i=0; i<files;i++){
      nova_distancia=new ID_EUC;
      *nova_distancia=calcula_distancia (d, data, i, total_descriptors); //ha de comparar tota la info de data am la d la imatge actual utilitzant la desviacio
      llista_dist->append (nova_distancia);
   }

   llista_dist->sort();
  
   //en cas de no voler retornar tota la base de dades
   if (recuperaX!=0 && recuperaX<files){
      int borrarem=files - recuperaX;
      files=recuperaX;

      
      nova_distancia=llista_dist->at(recuperaX);
      while (borrarem){
         llista_dist->remove();//(llista_dist->current());
         borrarem--;
      }
   }
         


   //PER PRINTAR RESULTATS
/*   nova_distancia=llista_dist->first();
   cout << "valors calculats " << endl;
   for (i=0;i<files;i++){
      cout << nova_distancia->id << endl;
      nova_distancia=llista_dist->next();
   }
   cout << endl;*/
}

//fa el calcul de la distancia euclidiana per una fila de la BD
ID_EUC CaractApp::calcula_distancia (DialegFourier *d, PgDatabase &data, int fila, int total_descriptors){
   ID_EUC resultat;
   int nFields, nTuples, j;
   PgDatabase descrip(dbName);


   nFields=data.Fields();
   nTuples=data.Tuples();

   resultat.distancia=0.0;
   
   //calculem el total sense contar-hi els descriptors de fourier

   for (j=4; j<nFields;j++){
      resultat.distancia+= pow (atof(data.GetValue(fila,j)) - caracSelec[j-4], 2.0) / pow(mitja.dades[j-4].val, 2.0);
   }

   resultat.id=atoi (data.GetValue(fila, 0));   //guardem l'identificador
   strcpy (resultat.nom, data.GetValue(fila, 2)); //agafem el nom --> columna=2

   
            
   //afegim la distancia euclidiana dels descriptors de fourier
   if (d->OpcioRecFF->isChecked()) //nomes hem de treballar amb CaractGlob
      resultat.distancia=ConsultaFF(d, resultat.id, total_descriptors, data);
   else
      resultat.distancia+=ConsultaFD(d, resultat.id, total_descriptors, data);


   resultat.distancia=sqrt (resultat.distancia);
   
   return (resultat);
}

//Calcula la distancia euclidiana pel matxambrat dels descriptors de fourier
double CaractApp::ConsultaFF(DialegFourier *d, int iden, int total_descriptors, PgDatabase &data){
   int i, nTuples;
   double acumula;
   
   acumula=0.0;
   nTuples=data.Tuples();
         
   i=0;
   while (iden!=atoi(data.GetValue(i, 0)))   //busquem l'identificador
      i++;
      
   acumula=pow ((atof(data.GetValue(i, 3)) - d->formaF->resultat), 2.0);  //3 es la columna k te FFx

   return (acumula);
}

//calcula la distancia euclidiana dels descriptors de fourier
double CaractApp::ConsultaFD(DialegFourier *d, int iden, int total_descriptors, PgDatabase &data){
   int i, k, nTuples;

   double acumula=0.0;
   char tmp[8];
   char query[100];
   char fetch[100];
   char close[100];
     
   k=mitja.plens-total_descriptors;


   PgDatabase datades(dbName);
   if ( datades.ConnectionBad() ){
      cerr << "Connection to database '" << dbName << "' failed." << endl
      << "Error returned: " << datades.ErrorMessage() << endl;
      return -1;
   }
   else{
      sprintf(fetch,"FETCH ALL in apuntaDES");
      sprintf(close,"CLOSE apuntaDES");
      //acumula = new double[total_descriptors];


      sprintf(query, "DECLARE apuntaDES CURSOR FOR select * FROM \"DesFourier\" WHERE \"IdCaract\"=");
      sprintf (tmp, "%d", iden);
      strcat (query, tmp);
      if ( !datades.ExecCommandOk("BEGIN") ){
         cerr << "BEGIN command failed" << endl;
         return -1;
      }

      if ( !datades.ExecCommandOk(query) ){
         cerr << "DECLARE CURSOR command failed" << endl;
         return -1;
      }

      if ( !datades.ExecTuplesOk(fetch) ){
         cerr << "FETCH ALL command didn't return tuples properly" << endl;
         return -1;
      }


      nTuples = datades.Tuples();

      i=0;
      while ((i < nTuples) && (i < total_descriptors)){
         acumula+=pow (atof(datades.GetValue(i, 2))- d->formaF->descriptZ.FD[i], 2.0) / pow ((double)mitja.dades[k+i].val,2.0);
         i++;
      }


      while (i < total_descriptors){ //la nostra figura te mes descriptors k la k consultem
         acumula+=pow (d->formaF->descriptZ.FD[i], 2.0) / pow ((double)mitja.dades[k+i].val, 2.0);
         i++;
      }

      datades.Exec(close);
      datades.Exec("END");


   }
   return (acumula);

}

void CaractApp::slotZoomIn(){
  statusBar()->message(tr("Augmentant el zoom..."));

  rmImage tmp;
  QString titol("(%) ");
  float k;
  int n;

    CaractView* vista = (CaractView*)pWorkspace->activeWindow();
    if( vista ){
      CaractDoc* doc=vista->getDocument();

      doc->imatge.zm.augmentarIntel(doc->imatge.imatge);
      doc->imatge.dw->augments=doc->imatge.zm.augments;
      doc->imatge.zm.resImg(&tmp);
      doc->imatge.ompleQImage(tmp);
      doc->imatge.dw->enfocat=true;

      // Actualiza el titol de la finestra posant-hi la nova escala
      k=((float)doc->imatge.zm.w/doc->imatge.zm.dimH)*100;
      n=(int)k;
      while(n>0){
        titol.insert(1,(n%10)+48);
        n=n/10;
      }
      doc->setTitle(titol+doc->pathName());
      doc->changedViewList();
      vista->visualize(doc->imatge.qImatge); /*tocat*/

  }
  else{
      QMessageBox::critical(0,"error","no hi ha cap imatge activa");
  }
  statusBar()->message(tr("Ready."));
}

void CaractApp::slotZoomOut(){
  statusBar()->message(tr("Disminuint el zoom..."));
  rmImage tmp;
  QString titol("(%) ");
  float k;
  int n;

    CaractView* vista = (CaractView*)pWorkspace->activeWindow();
    if( vista ){
      CaractDoc* doc=vista->getDocument();

      doc->imatge.zm.disminuirIntel(doc->imatge.imatge);
      doc->imatge.dw->augments=doc->imatge.zm.augments;
      doc->imatge.zm.resImg(&tmp);
      doc->imatge.ompleQImage(tmp);
      doc->imatge.dw->enfocat=true;

      // Actualiza el titol de la finestra posant-hi la nova escala
      k=((float)doc->imatge.zm.w/doc->imatge.zm.dimH)*100;
      n=(int)k;
      while(n>0){
        titol.insert(1,(n%10)+48);
        n=n/10;
      }
      doc->setTitle(titol+doc->pathName());
      doc->changedViewList();
      vista->visualize(doc->imatge.qImatge); /*tocat*/

  }
  else{
      QMessageBox::critical(0,"error","no hi ha cap imatge activa");
  }

  statusBar()->message(tr("Ready."));
}

void CaractApp::slotZoomEncaixa(){
  statusBar()->message(tr("Encaixant la imate a la pantalla..."));
  rmImage tmp;
  QString titol("(%) ");
  float k;
  int n;

    CaractView* vista = (CaractView*)pWorkspace->activeWindow();
    if( vista ){
      CaractDoc* doc=vista->getDocument();

       if (doc->imatge.zm.w==doc->imatge.imatge.dimX && doc->imatge.zm.h==doc->imatge.imatge.dimY){   //si la tenim a tamany real
         doc->imatge.zm.aplicarZoom(doc->imatge.imatge, doc->imatge.zm.wencaixat,doc->imatge.zm.hencaixat);
         k=((float)doc->imatge.zm.wencaixat/doc->imatge.imatge.dimX)*100;
         doc->imatge.dw->augments=doc->imatge.zm.augments=doc->imatge.zm.augmentsEncaixats;
         doc->imatge.zm.xMin=-1;
       }
       else{// (doc->imatge.zm.w==doc->imatge.zm.wencaixat && doc->imatge.zm.h==doc->imatge.zm.hencaixat){  //si la tenim encaixada
         doc->imatge.zm.aplicarZoom(doc->imatge.imatge, doc->imatge.imatge.dimX,doc->imatge.imatge.dimY);
         doc->imatge.dw->augments=doc->imatge.zm.augments=1;
         doc->imatge.zm.w=doc->imatge.imatge.dimX;
         doc->imatge.zm.h=doc->imatge.imatge.dimY;
         k=100;
         doc->imatge.zm.xMin=-1;
       }

       doc->imatge.zm.nomesRetalla=true;
       doc->imatge.dw->enfocat=false;
         

      doc->imatge. zm.resImg(&tmp);
        
      doc->imatge.ompleQImage(tmp);
      // Actualiza el titol de la finestra posant-hi la nova escala
      
      n=(int)k;
      while(n>0){
        titol.insert(1,(n%10)+48);
        n=n/10;
      }
      doc->setTitle(titol+doc->pathName());
      doc->changedViewList();
      vista->visualize(doc->imatge.qImatge); /*tocat*/

  }
  else{
      QMessageBox::critical(0,"error","no hi ha cap imatge activa");
  }

  statusBar()->message(tr("Ready."));
}

void CaractApp::initZoomBar(){

  zoomToolbar = new QToolBar(this, "zoom operations");
  zoomIn->addTo(zoomToolbar);
  zoomOut->addTo(zoomToolbar);
  zoomVista->addTo(zoomToolbar);

}

void CaractApp::slotViewZoomBar(bool toggle){
  statusBar()->message(tr("Toggle toolbar..."));
  ///////////////////////////////////////////////////////////////////
  // turn Toolbar on or off
   if (toggle== false)
  {
    zoomToolbar->hide();
  }
  else
  {
    zoomToolbar->show();
  };

 statusBar()->message(tr("Ready."));
}

//Consulta totes les imatges d'un mateix tipus i el mateix descriptor de fourier
char* CaractApp::MontaConsultaTipusDescriptor (DialegFourier *d, QString cursor, QString taula){
   QString cadena;
   uint longitud;
   QString cua;

   cadena="DECLARE ";
   cadena+=cursor;
   cadena+=" CURSOR FOR select \"IdF\"  ";


   //Comprobem per quin metode hem de buscar
   if (d->OpcioFourier1->isChecked() && !d->OpcioRecFF->isChecked()){
      cua=" WHERE \"DF1\" != -1";
   }
   else if (d->OpcioFourier2->isChecked()  && !d->OpcioRecFF->isChecked()){
      cua=" WHERE \"DF2\" != '-1'";
   }
   else if (d->OpcioFourier1->isChecked() && d->OpcioRecFF->isChecked()){ //nomes interve CaractGlob
      cua=" WHERE \"FF1\" != '-1'";
   }
   else if (d->OpcioFourier2->isChecked()  && d->OpcioRecFF->isChecked()){ //nomes interve CaractGlob
      cua=" WHERE \"FF2\" != '-1'";
   }


   longitud=cadena.length();

   cadena.remove(longitud-2, 2);


   cadena+=" from \"" + taula + "\"" +cua;


   if (d->OpcioMamo2->isChecked())
      cadena+=" AND \"Tipus\"='0' ";
   else if (d->OpcioSintet2->isChecked())
      cadena+=" AND \"Tipus\"='1' ";
   else if (d->OpcioFurqui2->isChecked())
      cadena+=" AND \"Tipus\"='2' ";


   return (qStrToChar(cadena));

}

//Consulta els diferents noms que tenim
char* CaractApp::MontaConsultaDifNoms (DialegFourier *d, QString cursor, QString taula){
   QString cadena;
   uint longitud;
   QString cua;

   cadena="DECLARE ";
   cadena+=cursor;
   cadena+=" CURSOR FOR select distinct \"Nom\"  ";


   //Comprobem per quin metode hem de buscar
   if (d->OpcioFourier1->isChecked() && !d->OpcioRecFF->isChecked()){
      cua=" WHERE \"DF1\" != -1";
   }
   else if (d->OpcioFourier2->isChecked()  && !d->OpcioRecFF->isChecked()){
      cua=" WHERE \"DF2\" != '-1'";
   }
   else if (d->OpcioFourier1->isChecked() && d->OpcioRecFF->isChecked()){ //nomes interve CaractGlob
      cua=" WHERE \"FF1\" != '-1'";
   }
   else if (d->OpcioFourier2->isChecked()  && d->OpcioRecFF->isChecked()){ //nomes interve CaractGlob
      cua=" WHERE \"FF2\" != '-1'";
   }


   longitud=cadena.length();

   cadena.remove(longitud-2, 2);


   cadena+=" from \"" + taula + "\"" +cua;


   if (d->OpcioMamo2->isChecked())
      cadena+=" AND \"Tipus\"='0' ";
   else if (d->OpcioSintet2->isChecked())
      cadena+=" AND \"Tipus\"='1' ";
   else if (d->OpcioFurqui2->isChecked())
      cadena+=" AND \"Tipus\"='2' ";

    
   return (qStrToChar(cadena));

}

//Monta la llista amb les diferents classes de imatges que podem tenir
void CaractApp::MontarLlistaNoms(DialegFourier *d){
  char query[100];
  char fetch[100];
  char close[100];
  QString *s;

   int nTuples, i;

   PgDatabase datanoms(dbName);
   if ( datanoms.ConnectionBad() ){
      cerr << "Connection to database '" << dbName << "' failed." << endl
      << "Error returned: " << datanoms.ErrorMessage() << endl;
      return -1;
   }
   else{
      QString t("CaractGlob");
     
      sprintf(query, MontaConsultaDifNoms(d,"dadesPc", t));
//cout << "laaa query " << query << endl;
      sprintf(fetch,"FETCH ALL in dadesPc");
      sprintf(close,"CLOSE dadesPc");

	   if ( !datanoms.ExecCommandOk("BEGIN") ){
         cerr << "BEGIN command failed" << endl;
         return -1;
      }

      if ( !datanoms.ExecCommandOk(query) ){
    	   cerr << "DECLARE CURSOR command failed" << endl;
         return -1;
      }

      if ( !datanoms.ExecTuplesOk(fetch) ){
         cerr << "FETCH ALL command didn't return tuples properly" << endl;
         return -1;
      }
   
      nTuples=datanoms.Tuples();

      //Per tal d'esborrar la llista si ja estava plena
      int plens;
      plens=noms.count();      
      s=noms.first();
      while (plens){
         noms.remove();
         plens--;
      }

         
      for (i=0;i<nTuples;i++){
         s = new QString;
         *s=datanoms.GetValue(i,0);
         noms.append(s);
      }

/*      cout << "llista grups noms "<< endl;
      s=noms.first();
      while (s){
         cout << *s << endl;
         s=noms.next();
      }
*/

      datanoms.Exec(close);
      datanoms.Exec("END");
   }
}

//Calcula les mitjanes per cada nom (tipus) d'images
void CaractApp::CalcularMitjanesNoms (DialegFourier *d){
   char query[100];
   char fetch[100];
   char close[100];
   lis *n;   

   QString *s, cursor("cursorID"), taula("CaractGlob");

   PgDatabase dataID(dbName);
   if ( dataID.ConnectionBad() ){
      cerr << "Connection to database '" << dbName << "' failed." << endl
      << "Error returned: " << dataID.ErrorMessage() << endl;
      return -1;
   }
   else{
      sprintf(fetch, "FETCH ALL in cursorID");
      sprintf(close, "CLOSE cursorID");

      //Per tal d'esborrar la llista si ja estava plena
      int plens;
      plens=lmitges.count();
      n=lmitges.first();
      while (plens){
         lmitges.remove();
         plens--;
      }
///////////////////////////////////////         
      s=noms.first();
      while (s){
         //fem la consulta pel primer tipus de la llista
         sprintf(query, MontaConsultaTipusDescriptor (d, cursor, taula));
         strcat (query, " AND \"Nom\"='");
         strcat (query, qStrToChar(*s));
         strcat (query, "'");
//         cout << "xuxuxa  " << query << endl;
         if ( !dataID.ExecCommandOk("BEGIN") ){
            cerr << "BEGIN command failed" << endl;
            return -1;
         }

         if ( !dataID.ExecCommandOk(query) ){
            cerr << "DECLARE CURSOR command failed" << endl;
            return -1;
         }

         if ( !dataID.ExecTuplesOk(fetch) ){
            cerr << "FETCH ALL command didn't return tuples properly" << endl;
            return -1;
         }
      
         //Guardem en una llista els conjuts de mitges per cada tipus(nom) de figura
         lmitges.append (CalcularMitjanaF_Rec (d->formaF->descriptZ.plensFD, dataID));

         s=noms.next();
         dataID.Exec(close);
         dataID.Exec("END");
      }
   }

                                                  /*
      cout << "Comena la llista" << endl;
      n=lmitges.first();
      while (n){
         for (i=0; i< 6; i++)
            cout << "valor  " << n->dades[i].val << endl;
         cout << endl;
         n=lmitges.next();
      }                                            */
}


//Calula la Mitjana dels descriptors de fourier quan fem Reconeixement
lis* CaractApp::CalcularMitjanaF_Rec (int total_descriptors, PgDatabase &data){
   int i, nTuples, k;
   int conta, total_dif;
   char query[100];
   char fetch[100];
   char close[100];
   mitjaRec = new lis;

   total_dif=data.Tuples();

   PgDatabase datades(dbName);
   if ( datades.ConnectionBad() ){
      cerr << "Connection to database '" << dbName << "' failed." << endl
      << "Error returned: " << datades.ErrorMessage() << endl;
      return -1;
   }
   else{
      sprintf(fetch,"FETCH ALL in apuntaDES");
      sprintf(close,"CLOSE apuntaDES");
      
      mitjaRec->dades = new t_node[total_descriptors];
      mitjaRec->plens = total_descriptors;

      for (i=0; i<total_descriptors; i++){
         mitjaRec->dades[i].val=0.0;
         mitjaRec->dades[i].total=0;
      }

      for (k=0; k < total_dif; k++){
         sprintf(query, "DECLARE apuntaDES CURSOR FOR select * FROM \"DesFourier\" WHERE \"IdCaract\"=");
         strcat (query,data.GetValue(k, 0));
         if ( !datades.ExecCommandOk("BEGIN") ){
            cerr << "BEGIN command failed" << endl;
            return -1;
         }

         if ( !datades.ExecCommandOk(query) ){
            cerr << "DECLARE CURSOR command failed" << endl;
            return -1;
         }

         if ( !datades.ExecTuplesOk(fetch) ){
            cerr << "FETCH ALL command didn't return tuples properly" << endl;
            return -1;
         }


         nTuples = datades.Tuples();

         i=0;
         conta=0;

         while ((i < nTuples) && (conta < total_descriptors)){
//            cout << "veig    " << datades.GetValue (i,2) << endl;
            mitjaRec->dades[conta].val+=atof (datades.GetValue(i, 2));  //acumula els valors d fourier
            mitjaRec->dades[conta].total++;
            i++;
            conta++;
         }

         datades.Exec(close);
         datades.Exec("END");
      }

      
      
      for (i=0; i< total_descriptors;i++) //en cas de tenir mes FD k a la BD inicialitzem total
         if (mitjaRec->dades[i].total==0)
            mitjaRec->dades[i].total=1;

      for (i=0; i< total_descriptors;i++)
         mitjaRec->dades[i].val/=(double)mitjaRec->dades[i].total;

      return (mitjaRec);
   }
}

char* CaractApp::MesSemblant (DialegFourier *d){
   int i, pos, miren;
   long double acumula=0.0;
   lis *n;
   long double minim=9999999999.0;
   QString etiqueta, *s, cadena("\n\n         TIPUS                 SEMBLANCA\n          -----------------------------------\n"), tmp;

   n=lmitges.first();
   s=noms.first();
   pos=0;
   while (n){       
      acumula=0.0;
      if (mitjaRec->plens < d->formaF->descriptZ.plensFD)
         miren=mitjaRec->plens;
      else
         miren=d->formaF->descriptZ.plensFD;
         
      for (i=0; i < miren; i++){
//         cout << "meu " << d->formaF->descriptZ.FD[i] << "      comparo " << n->dades[i].val << "   resta   " << d->formaF->descriptZ.FD[i] - n->dades[i].val << "  pow  " <<pow((d->formaF->descriptZ.FD[i] - n->dades[i].val), 2.0) << endl;
         acumula+=pow((d->formaF->descriptZ.FD[i] - n->dades[i].val), 2.0);
      }


      acumula=sqrt(acumula);
      
      cadena+="\t"  + *s + "\t=\t" + tmp.setNum((double)acumula) + "\n";

      if (minim > acumula){
         minim=acumula;
         etiqueta=*noms.at(pos);
      }    

      n=lmitges.next();
      s=noms.next();
      pos++;
   }

  cadena+=+"\nS'ASSEMBLA MES A:   " + etiqueta;

   return (qStrToChar (cadena));
}

void CaractApp::slotMostraPunts(){
  CaractView* vista = (CaractView*)pWorkspace->activeWindow();

  if( vista ){
    CaractDoc* doc=vista->getDocument();

   if (doc->imatge.dw->mostraPunts)
      doc->imatge.dw->mostraPunts=false;
   else
      doc->imatge.dw->mostraPunts=true;

   doc->imatge.dw->update();
   }
}

#define directoris 4
void CaractApp::slotAfegeixM(){
   QString a(path_inici);
   QString *b[directoris];
   int total_fitxers, i, e;
   char *pos;
/*
   b[0]=new QString ("altres/anecs/");
   b[1]= new QString ("altres/brick/");
   b[2]= new QString ("altres/classic/");
   b[3]= new QString ("altres/claus/");
   b[4]= new QString ("altres/cotxes/");
   b[5]= new QString ("altres/creus/");
   b[6]= new QString ("altres/elefants/");
   b[7]= new QString ("altres/fork/");
   b[8]= new QString ("altres/martell/");
   b[9]= new QString ("altres/planes/");
   b[10]= new QString ("altres/rabbits/");
   b[11]= new QString ("altres/ralles/");
   b[12]= new QString ("altres/tools/");
   b[13]= new QString ("altres/tortugues/");


   b[0]=new QString ("sintet/cercles/");
   b[1]=new QString ("sintet/rectangles/");
   b[2]=new QString ("sintet/triangles/");
   b[3]=new QString ("sintet/y_grega/");

*/

   b[0]=new QString ("masses/espicular/");
   b[1]=new QString ("masses/lobulated/");
   b[2]=new QString ("masses/microlobulated/");
   b[3]=new QString ("masses/oval/");



   
   for (e=0; e< directoris; e++){   
       DIR *dir_p;
       struct dirent *dir_entry_p;

       dir_p = opendir(qStrToChar(a+*b[e]));

       total_fitxers=0;
       while( NULL != (dir_entry_p = readdir(dir_p)))
       {
          total_fitxers++;
       }

       rewinddir (dir_p);

       statusBar()->message(tr("Omplint BD..."));

       for (i=0; i<total_fitxers; i++){
          dir_entry_p = readdir(dir_p);
          if (i>1){
             pos=dir_entry_p->d_name + strlen (dir_entry_p->d_name)-6;
             if (strcmp ("P1.tif", pos)   &&  strcmp ("P2.tif", pos)  &&  strcmp ("P3.tif", pos) && strcmp (".db", pos+3)){
               Afegeix_massivament (2, *b[e]+dir_entry_p->d_name, 1024);
               //primer parametre 1-> Fourier 1     2-> Fourier 2
               //segon parametre ruta a partir de BD
               //tercer parametre numero de mostres a agafar               
             }
          }
       }

       closedir(dir_p);
   }

    statusBar()->message(tr("Dades entrades correctament"));
}

void CaractApp::Afegeix_massivament ( int metode, QString s, int total_mostres){

   Imatge img, img2;
   forma ftmp;
   
  QString a(path_inici);
   img.openImatge (a+s);

   ftmp.extreureMinBox(img.imatge);
   ftmp.area(img.imatge);
   img2=img;                       
   img2.Contorn(img);
          
   img2.RecorreAntihorari();
   ftmp.vcompactness=((double)pow(img2.contorn->perimetre,2)) / (4.0*PI*ftmp.varea);
                                                  
   OmpleBDcaractGlobFMassivament (total_mostres, metode, img2, ftmp, s);

}


//Omplim la taula amb totes les caracteristiques de la imatge menys els descriptors
void CaractApp::OmpleBDcaractGlobFMassivament (int total_mostres, int metode, Imatge &img, forma &ftmp, QString nom){ // (DialegFourier *d, CaractDoc *doc, int &IdCaract, char* path){
  char query[100];
  char fetch[100];
  char close[100];
  char insert[300];
  forma altres, *f;
  Fourier *formaF;
  int IdCaract;
  double ff1,ff2;
  int df1,df2;

  formaF = new Fourier(img,total_mostres);
                
         if (metode==1){      //Retorna complexes
              formaF->Fourier1Equi(img, true);
            }
         else{ //retorn modul
               formaF->Fourier2Equi(img, true);
         }
         
         f=AltresCaracteristiques(img);
                                                                                          
         

////////////////////////////////////////7  


        pgAcces *data = new pgAcces();
        sprintf(query,"DECLARE buscaId1 CURSOR FOR select * from \"CaractGlob\"");
        sprintf(fetch,"FETCH ALL in buscaId1");
        sprintf(close,"CLOSE buscaId1");
        IdCaract = data->cercaId(query,fetch,close);



        if(metode==1){       //treballem am complexes
            ff1=formaF->resultat;
            ff2 = -1.0;
               bool bolea;
               df1 = total_mostres;
            df2 = -1;
         }
         else{                                           //treballem amb moduls
            ff2=formaF->resultat;
            ff1 = -1.0;
               bool bolea;
               df2 =  total_mostres / 2;    //nomes ens quedem amb la meitat de descriptors
            df1 = -1;
         }

        QString s = nom.section( '/', -1 );    //agafa unicament el nom
        s=s.left(1);
        
        
        sprintf(insert,"INSERT INTO \"CaractGlob\" VALUES (%d,'%s',1,%f, %f,%d,%d,%d,%d,%f,%f,%f,%f, %f,%f,%f,%d,-1,%f,%d,'%s')",
                IdCaract,
                qStrToChar(s),
                ftmp.varea,
                img.contorn->perimetre,
                f->xMin,
                f->yMin,
                f->xMax,
                f->yMax,
                ftmp.vcompactness,
                f->vlength,
                f->vbreadth,
                f->velongacio,
                f->vcentroidX,
                f->vcentroidY,
//                img.dw->centreX,
//                img.dw->centreY,
                ff1,
                df1,
                ff2,
                df2,
               qStrToChar(nom));

        data->insertCaract(insert);

        OmpleBDdescriptFourierM (formaF, IdCaract);

        delete (f);
        delete (formaF);
        delete (data);                            

//////////////////////////////////////////////////////// aixo estava comentat        
//        data.Exec(close);
//        data.Exec("END");

}
      
   
forma* CaractApp::AltresCaracteristiques (Imatge &im){
   forma *f = new forma;

   f->extreureMinBox(im.imatge);    //Sha de fer per calcular qualsevol cosa
   f->vperimetre=im.contorn->perimetre;
   f->elongation(0, im.imatge);
   f->compactness(im.imatge);
   f->length();
   f->breath();
   f->centroid();
                                                    
   return (f);
}


void CaractApp::OmpleBDdescriptFourierM (Fourier *formaF, int &IdCaract){
  char insert[100];
  int i, total_descriptors;


  int idFourier=0;
  pgAcces *data = new pgAcces();



  total_descriptors=formaF->descriptZ.plensFD;
  for (i=0;i<total_descriptors;i++){
     sprintf(insert,"INSERT INTO \"DesFourier\" VALUES (%d,%d,%f)", IdCaract, idFourier++, formaF->descriptZ.FD[i]);
     data->insertCaract(insert);
  }
  
  delete (data);
}


#define directorisCH 4

void CaractApp::slotAfegeixMC(){
   QString a(path_inici), s;
   QString *b[directorisCH];
   int total_fitxers, i, e;
   char *pos;
   Imatge imat;
   char inicial[2];
  /*
   b[0]=new QString ("altres/anecs/");
   b[1]= new QString ("altres/brick/");
   b[2]= new QString ("altres/classic/");
   b[3]= new QString ("altres/claus/");
   b[4]= new QString ("altres/cotxes/");
   b[5]= new QString ("altres/creus/");
   b[6]= new QString ("altres/elefants/");
   b[7]= new QString ("altres/fork/");
   b[8]= new QString ("altres/martell/");
   b[9]= new QString ("altres/planes/");
   b[10]= new QString ("altres/rabbits/");
   b[11]= new QString ("altres/ralles/");
   b[12]= new QString ("altres/tools/");
   b[13]= new QString ("altres/tortugues/");


   b[0]=new QString ("sintet/cercles/");
   b[1]=new QString ("sintet/rectangles/");
   b[2]=new QString ("sintet/triangles/");
   b[3]=new QString ("sintet/y_grega/");
*/
   

   b[0]=new QString ("masses/espicular/");
   b[1]=new QString ("masses/lobulated/");
   b[2]=new QString ("masses/microlobulated/");
   b[3]=new QString ("masses/oval/");


   DialegManAuto *dc = new DialegManAuto ();



   for (e=0; e< directorisCH; e++){
       DIR *dir_p;
       struct dirent *dir_entry_p;

       dir_p = opendir(qStrToChar(a+*b[e]));

       total_fitxers=0;
       while( NULL != (dir_entry_p = readdir(dir_p)))
       {
          total_fitxers++;
       }

       rewinddir (dir_p);

       statusBar()->message(tr("Omplint BD..."));

       for (i=0; i<total_fitxers; i++){
          dir_entry_p = readdir(dir_p);
          if (i>1){
             pos=dir_entry_p->d_name + strlen (dir_entry_p->d_name)-6;
             if (strcmp ("P1.tif", pos)   &&  strcmp ("P2.tif", pos)  &&  strcmp ("P3.tif", pos) && strcmp (".db", pos+3)){
                  inicial[0]=*qStrToChar (dir_entry_p->d_name);
                  inicial[1]='\0';
                  s=path_inici + *b[e] + dir_entry_p->d_name;
                  imat.openImatge (s);                  
                  dc->omple_a_sac (imat, inicial, qStrToChar(*b[e]+dir_entry_p->d_name));
             }
          }
       }

       closedir(dir_p);
   }

    statusBar()->message(tr("Dades entrades correctament"));   

}

   