/***************************************************************************
                          caract.h  -  description
                             -------------------
    begin                : jue nov  6 12:49:24 CET 2003
    copyright            : (C) 2003 by projecte
    email                : projecte@localhost.localdomain
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CARACT_H
#define CARACT_H

// include files for QT
#include <qapp.h>
#include <qmainwindow.h>
#include <qaction.h>
#include <qworkspace.h>
#include <qmenubar.h>
#include <qtoolbar.h>
#include <qstatusbar.h>
#include <qwhatsthis.h>
#include <qpopupmenu.h>
#include <qaccel.h>
#include <qtoolbutton.h>
#include <qmsgbox.h>
#include <qfiledialog.h>
#include <qprinter.h>
#include <qstring.h>
#include <qpixmap.h>

#include <qtextedit.h>

#include "Dialegs/dialegfourier.h"
#include "Dialegs/dialegmanauto.h"
#include "Dialegs/dialegbinaritza.h"
#include "Forma/Fourier/fourier.h"



// forward declaration of the Caract classes
class CaractDoc;
class CaractView;

/**
  * This Class is the base class for your application. It sets up the main
  * window and providing a menubar, toolbar
  * and statusbar. For the main view, an instance of class CaractView is
  * created which creates your view.
  * 	
  * @author Source Framework Automatically Generated by KDevelop, (c) The KDevelop Team.
  * @version KDevelop version 1.3 code generation
  */
  
   typedef struct{
      long double val;
      int total;
      }t_node;    //acumula els valors de fourier per fer-ne la mitjana
      
   typedef  struct{
      t_node* dades;
      int plens;
   }lis;
   
class CaractApp : public QMainWindow
{
  Q_OBJECT
  
  public:
    /** construtor */
    CaractApp();
    /** destructor */
    ~CaractApp();

    /** opens a file specified by commandline option
     */
    void openDocumentFile(const char *file=0);
    QTextEdit *Text;  //Per tal de mostrar els resultats

    
  protected:
    /** overloaded for Message box on last window exit */
    bool queryExit();
    /** event filter to catch close events for MDI child windows and is installed in createClient() on every child window.
      * Closing a window calls the eventFilter first which removes the view from the connected documents' view list. If the
      * last view is going to be closed, the eventFilter() tests if the document is modified; if yes, it asks the user to
      * save the document. If the document title contains "Untitled", slotFileSaveAs() gets called to get a save name and path.
      */
    virtual bool eventFilter(QObject* object, QEvent* event);
    /** creates a new child window. The document that will be connected to it
     * has to be created before and the instances filled, with e.g. openDocument().
     * Then call createClient() to get a new MDI child window.
     * @see CaractDoc#addView
     * @see CaractDoc#openDocument
     * @param doc pointer to the document instance that the view will
     * be connected to.
     */
    void createClient(CaractDoc* doc);

  private slots:

    /** generate a new document in the actual view */
    void slotFileNew();
    /** open a document */
    void slotFileOpen();
    /** save a document */
    void slotFileSave();
    /** save a document under a different filename*/
    void slotFileSaveAs();
    /** close the actual file */
    void slotFileClose();
    /** print the actual file */
    void slotFilePrint();
    /** exits the application */
    void slotFileQuit();

    /** reverts the last editing action */
    void slotEditUndo();
    /** put the marked text/object into the clipboard and remove
     * it from the document */
    void slotEditCut();
    /** put the marked text/object into the clipboard*/
    void slotEditCopy();
    /** paste the clipboard into the document*/
    void slotEditPaste();

    /** toggle the toolbar*/
    void slotViewToolBar(bool toggle);
    /** toggle the statusbar*/
    void slotViewStatusBar(bool toggle);    
    /** creates a new view for the current document */
    void slotWindowNewWindow();
    /** shows an about dlg*/
    void slotHelpAbout();
    /** change the status message of the whole statusbar temporary */
    void slotStatusHelpMsg(const QString &text);
    /** gets called when the window menu is activated; recreates the window menu with all opened window titles. */
    void windowMenuAboutToShow();
    /** activates the MDI child widget when it gets selected from the window menu. */
    void windowMenuActivated( int id );

    /*Binaritza la imatge*/
    void slotTractaBinaritza();
    void slotTractaContorn();
    void slotTractaComparaContorn();

    //ZOOM
    void slotZoomIn();
    void slotZoomOut ();
    void slotZoomEncaixa ();

    void slotViewZoomBar(bool toggle);

 public slots:
    void slotFormaChang();
    void slotFormaFourier1();
    void slotAgafaPunts();
    void slotMostraPunts();
    void slotAfegeixM();
    void slotAfegeixMC();
    

  private:
     char *qStrToChar(const QString &fileName);
    /** initializes all QActions of the application */
    void initActions();
    /** initMenuBar creates the menu_bar and inserts the menuitems */
    void initMenuBar();
    /** this creates the toolbars. Change the toobar look and add new toolbars in this
     * function */
    void initToolBar();
    /** setup the statusbar */
    void initStatusBar();
    /** setup the mainview*/
    void initView();

    void initCentralWidget();

    /** file_menu contains all items of the menubar entry "File" */
    QPopupMenu *pFileMenu;
    /** edit_menu contains all items of the menubar entry "Edit" */
//    QPopupMenu *pEditMenu;
    /** view_menu contains all items of the menubar entry "View" */
    QPopupMenu *pViewMenu;
    /** view_menu contains all items of the menubar entry "Help" */
    QPopupMenu *pHelpMenu;
    /** the window menu */
    QPopupMenu *pWindowMenu;

    /** el menu de Tracta */
    QPopupMenu *pTractaMenu;

    /**el menu Forma*/
    QPopupMenu *pFormaMenu;
    QPopupMenu *pZoomMenu;

    QToolBar *fileToolbar;
    QToolBar *zoomToolbar;

    /** pWorkspace is the MDI frame widget that handles MDI child widgets. Inititalized in
      * initView()
      */
    QWorkspace *pWorkspace;
    /** the printer instance */
    QPrinter *printer;
    /** a counter that gets increased each time the user creates a new document with "File"->"New" */
    int untitledCount;
    /** a list of all open documents. If the last window of a document gets closed, the installed eventFilter
     * removes this document from the list. The document list is checked for modified documents when the user
     * is about to close the application. */
    QList<CaractDoc> *pDocList;

//    QAction *fileNew;
    QAction *fileOpen;
    QAction *fileSave;
    QAction *fileSaveAs;
    QAction *fileClose;
//    QAction *filePrint;
    QAction *fileQuit;

/*    QAction *editUndo;
    QAction *editCut;
    QAction *editCopy;
    QAction *editPaste;
*/

    QAction *viewToolBar;
    QAction *viewZoomBar;
    QAction *viewStatusBar;


    QActionGroup *windowAction;
    QAction *windowNewWindow;
    QAction *windowTile;
    QAction *windowCascade;

    QAction *helpAboutApp;

    QAction *tractaBinaritza;
    QAction *tractaContorn;
    QAction *tractaContornCompara;
    

    QAction *formaChang;
    QAction *formaFourier1;
    QAction *formaAfegeixM;
    QAction *formaAfegeixMC;
    
    QActionGroup *zoom;
    QAction *zoomIn;
    QAction *zoomOut;
    QAction *zoomVista;




    QAction *GetPunts;


    void OmpleBDdescriptFourier (DialegFourier *d, CaractDoc *doc, int &IdCaract);
    void OmpleBDcaractGlobF (DialegFourier *d, CaractDoc *doc, int &IdCaract, char* path);
    float* ConsultaValorsFourier(int identificador, int mostres, int);
    void ConsultaF (int metodeF, DialegFourier *d);
    llistaID *llistadiferents;
    QString ComparaAmbMitja(DialegFourier *d);
    void ConsultaFmatxambrat (int metodeF, DialegFourier *d);
    QString ComparaFFx (DialegFourier *d);
    char* GetPath(CaractDoc* doc);
    char* GetInicial(CaractDoc *doc);
    void initZoomBar();

   //Referent a la part de CBIR
   char* MontaConsulta(DialegFourier *d, QString cursor, QString taula); //Monta la consulta en funcio de les opcions de lusuari
   void ConsultaCBIR (DialegFourier *d);
   void CalcularMitjana (DialegFourier *d, PgDatabase &data);
   void CadenaSpecifica (DialegFourier *d);
   void CalcularTeta (PgDatabase &data);

   void CalculaDistanEucli (DialegFourier *d, PgDatabase &data, int);
   ID_EUC calcula_distancia(DialegFourier *d, PgDatabase &data, int fila, int total_descriptors);

   void CalcularMitjanaF (int, PgDatabase &data);
   void CalcularDesviacioF (int total_descriptors, PgDatabase &data);
   double ConsultaFD(DialegFourier *d, int iden, int, PgDatabase &data);
   double ConsultaFF(DialegFourier *d, int iden, int total_descriptors, PgDatabase &data);
   void MontarLlistaNoms(DialegFourier *d);
//   void ConsultaNoms (DialegFourier *d);
   char* MontaConsultaDifNoms (DialegFourier *d, QString cursor, QString taula);
   lis* CalcularMitjanaF_Rec (int total_descriptors, PgDatabase &data);
   void OmpleBDcaractGlobFMassivament (int toal_mostres, int metode, Imatge &img, forma &ftmp, QString nom);
   forma* AltresCaracteristiques (Imatge &im);
   void OmpleBDdescriptFourierM (Fourier *formaF, int &IdCaract);

   //Consulta totes les imatges d'un mateix tipus i el mateix descriptor de fourier
   char* MontaConsultaTipusDescriptor (DialegFourier *d, QString cursor, QString taula);
   void CalcularMitjanesNoms (DialegFourier *d);
   char* MesSemblant (DialegFourier *d);

   //Permet afegir totes les imatges d'un directori a la BD
   void Afegeix_massivament ( int metode, QString s, int);


   int recuperaX; //total d'imatges k es volen recuperar
   char *inicial;
   char *path;
   PgDatabase *dataCH;  //cursor amb els descriptors de chang k ens interessen
   list_ID_EUC *llista_dist;   //lista resultant amb les distancies euclidianes, path, identificador

   
   double *caracSelec;
   lis mitja;
   t_node *acumula;
   QPtrList <QString>noms;  //llista utilitzada per fer el Reconeixement
   QPtrList <lis>lmitges;  //llista q conte vectors amb les mitges de cada descriptor de fourei
   lis *mitjaRec;

   DialegManAuto *dc;         //Dialeg de Chang
   DialegFourier *df;         //Dialeg de Fourier
   DSortidaCerca *dSortida;   //Dialeg de CBIR
   DialegBinaritza *db;       //Dialeg de binaritza
   
};
#endif

