/***************************************************************************
                          imatge.cpp  -  description
                             -------------------
    begin                : mar oct 15 2002
    copyright            : (C) 2002 by root
    email                : root@localhost.localdomain
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "imatge.h"
#include  <math.h>
#include "caract.h"

#define MARCAT 128

Imatge::Imatge(){
   // inicialitza el widget que mostrara
   dw = new DocWidget(0);
   contornejada=false;

   InfoPunt=NULL;
   contorn=NULL;              //llista encadenada amb els punts del contorn
   contornPolar=NULL;      // contorn polar
}
Imatge::~Imatge(){
}
  
/** tanca una imatge */
void Imatge::closeImatge(){
}
/** obre una imatge */
void Imatge::openImatge(const QString &fileName){
  char *fitxer;
  rmImage tmp;

  fitxer = qStrToChar(fileName);


  imatge.read(fitxer);

  if(imatge.format == RM_NO_FORMAT){
      QMessageBox::critical(0,fileName,"Format desconegut");
  }
  else{
      zm.w=imatge.dimX;
      zm.h=imatge.dimY;
      while(zm.w>VIEW_IMAGE_ON_LOAD_X){
        zm.w=zm.w/2;
        zm.h=zm.h/2;
        zm.augments/=2;
      }
      while(zm.h>VIEW_IMAGE_ON_LOAD_Y){
        zm.w=zm.w/2;
        zm.h=zm.h/2;
        zm.augments/=2;
      }
//      cout << " ZM x: " << zm.w << " y: " << zm.h << endl;
//      cout << " RL x: " << imatge.dimX << " y: " << imatge.dimY << endl;
      zm.wencaixat=zm.w;   //guardem les dimensions que fan possible
      zm.hencaixat=zm.h;   //encaixar la imatge a la pantall
      zm.augmentsEncaixats=zm.augments;
      
      if(zm.w!=imatge.dimX&&zm.h!=imatge.dimY){
        zm.aplicarZoom(imatge,zm.w,zm.h);
        zm.resImg(&tmp);
        if(!ompleQImage(tmp)){
          QMessageBox::critical(0,fileName,"No puc omplir QImage");
        }
      }
      else{
        if (!ompleQImage())
        {
          QMessageBox::critical(0,fileName,"No puc omplir QImage");
        }
      }

  }
}
int Imatge::ompleQImage(){
  qImatge.create ( imatge.dimX,imatge.dimY,8,256);
  short valor;


  for (int j=0;j<imatge.dimY;j++){
    for(int i=0;i<imatge.dimX;i++) {
      valor = imatge.data(i,j);
      /*if(valor>255) valor = 255;
      if(valor<0) valor = 0;
      */
      if(imatge.format == RM_RAW) valor = (byte) ((double)valor * (255.0 / 65535.0));
      else{
        if(valor>255) valor = 255;
        else if(valor<0) valor = 0;
      }
      qImatge.setPixel(i,j,valor);
    }
  }

  for(int c=0;c<256;c++)
     qImatge.setColor( c,qRgb(c,c,c));

  // canvia la imatge del widget i el seu tamany
  dw->canviaImatge(qImatge);
  dw->setGeometry(0,0,qImatge.width(),qImatge.height());

return 1;
}



int Imatge::ompleQImage(rmImage nimg){

  qImatge.create ( nimg.dimX,nimg.dimY,8,256);
  short valor;


  for (int j=0;j<nimg.dimY;j++){
    for(int i=0;i<nimg.dimX;i++) {
      valor = nimg.data(i,j);
      /*if(valor>255) valor = 255;
      if(valor<0) valor = 0;
      */
      if(nimg.format == RM_RAW) valor = (byte) ((double)valor * (255.0 / 65535.0));
      else{
        if(valor>255) valor = 255;
        else if(valor<0) valor = 0;
      }
      qImatge.setPixel(i,j,valor);
    }
  }

  for(int c=0;c<256;c++)
     qImatge.setColor( c,qRgb(c,c,c));

  // canvia la imatge del widget que mostra i el seu tamany
  dw->canviaImatge(qImatge);
  dw->setGeometry(0,0,qImatge.width(),qImatge.height());

return 1;


}
int Imatge::ompleQImage(QImage &desti){
  desti.create ( imatge.dimX,imatge.dimY,8,256);
  short valor;


  for (int j=0;j<imatge.dimY;j++){
    for(int i=0;i<imatge.dimX;i++) {
      valor = imatge.data(i,j);
      /*if(valor>255) valor = 255;
      if(valor<0) valor = 0;
      */
      if(imatge.format == RM_RAW) valor = (byte) ((double)valor * (255.0 / 65535.0));
      else{
        if(valor>255) valor = 255;
        else if(valor<0) valor = 0;
      }
      desti.setPixel(i,j,valor);
    }
  }

  for(int c=0;c<256;c++)
     desti.setColor( c,qRgb(c,c,c));

return 1;


}

QImage Imatge::getImatgeQt(){
  return qImatge;
}


char *Imatge::qStrToChar(const QString &fileName){
  char *fitxer;
  QChar ch;
  
  fitxer = new char[255];
    
    for(uint i= 0;i<fileName.length();i++){
      ch = fileName.at( i );
      fitxer[i] = ch.cell();
    }
    fitxer[fileName.length()] = '\0';
    return fitxer;
}


// Conversio a 8bpp 
void Imatge::escalaGris(){
  for(int i=0;i<imatge.dimX;i++){
   for(int j=0;j<imatge.dimY;j++){
       imatge.data(i,j) = (uint8) imatge.data(i,j);
   }
  }
}


void Imatge::binaritza(int llindar){
  for(int i=0;i<imatge.dimX;i++){
   for(int j=0;j<imatge.dimY;j++){
       if(imatge.data(i,j)<llindar) imatge.data(i,j) = 0;
       else imatge.data(i,j) = 255;
   }
  }  
}

//Deixa els valors del modul, la fase i les coordenades del contorn en una llista
void Imatge::MontaLlistaSobel (){

}

//Retorna els moduls calculats
ModulFase* Imatge::sobel(rmImage &im){
   int sx, sy, i, j, total;
   double angle;
   
   
//   FILE *f;
//   f = fopen("/home/galco/fase.txt", "w");
   
  InfoPunt = new ModulFase[im.dimX*im.dimY];

  total=im.dimX*im.dimY;  
  for (i=0;i<total;i++){
      InfoPunt[i].fase=0.0;
      InfoPunt[i].modul=0.0;
  }  
   for(j=1;j<im.dimY-1;j++){
      for(i=1;i<im.dimX-1;i++){
         if (im.data(i,j)==0){//si el pixel k mirem pertany a la figura pot ser maxima curbatura
            sx= ( -im.data(i-1,j+1)) - (2 * im.data(i-1,j)) - (im.data(i-1,j-1)) + (im.data(i+1,j+1)) + (2 * im.data(i+1,j)) + im.data(i+1,j-1);

            sy= (-im.data(i-1,j+1)) - 2 * im.data(i,j+1) - im.data(i+1,j+1) + im.data(i-1,j-1) + 2 * im.data(i,j-1) + im.data(i+1,j-1);

            InfoPunt[im.dimX*j+i].modul = sqrt (pow(sx,2.0)+ pow(sy,2.0));

            InfoPunt[im.dimX*j+i].fase=atan2((double)sy, (double)sx);
            if (InfoPunt[im.dimX*j+i].fase<0)
               InfoPunt[im.dimX*j+i].fase+=2*M_PI;
         }      

//         fprintf (f, "%-15.2f", InfoPunt[imatge.dimX*j+i].modul);   //imprimir modul
//     fprintf (f, "%-7.2f", InfoPunt[imatge.dimX*j+i].fase);
      }
//   fprintf (f, "\n");
   }

//      fclose (f);
      
  //Em carrego les unions de pixels passant de conectivitat a 4 a conectivitat a 8
      for (j=1;j<im.dimY-1;j++){
         for (i=1;i<im.dimX-1;i++){
            if (InfoPunt[im.dimX*j+i].modul<361){   //he observat k el modul d les unions val 360.62.
               InfoPunt[im.dimX*j+i].fase=0.0;
               InfoPunt[im.dimX*j+i].modul=0.0;
            }
//            fprintf (f, "%-11.2f", InfoPunt[imatge.dimX*j+i].modul);
//            fprintf (f, "%-7.2f", InfoPunt[imatge.dimX*j+i].fase);
         }
//         fprintf (f,"\n");
      }
//  fclose (f);
  
   //Omplo el contorn de la imatge de color negre (inicialitzo els pixels per tal k tinguin valor)
  for (i=0;i<im.dimX;i++){
      InfoPunt[i].modul=0.0;
      InfoPunt[im.dimX*(im.dimY-1)+i].modul=0.0;
      InfoPunt[i].fase=0.0;
      InfoPunt[im.dimX*(im.dimY-1)+i].fase=0.0;
      }

  for (j=0;j<im.dimY;j++){
      InfoPunt[im.dimX*j].modul=0.0;
      InfoPunt[im.dimX*j-1].modul=0.0;
      InfoPunt[im.dimX*j].fase=0.0;
      InfoPunt[im.dimX*j-1].fase=0.0;
      }
                                       

  return (InfoPunt);
}   
                          

//Omple la llista del DocWidget amb els punts k son vertex i els pinta a la imatge
//Nomes consulta la llista del contorn i nomes ens fixem amb la fase, amb el modul ja ens hi hem fixat
void Imatge::CercaVertex(double fase){
   ModulFasePos *anterior2, *anterior1, *actual;
   coordenades *c;
   double resta;
   
   dw->EsborrarLlista();

   if (contornSobel->count() > 3){
      anterior2=contornSobel->first();
      actual=contornSobel->next();

      do{
         resta=actual->fase - anterior2->fase;

         
         if (resta >M_PI || resta < -M_PI)  //la diferencia d'angle no pot ser mes gran de 180
            resta=2*M_PI - fabs(resta);
               
         if (resta >= fase){
            c = new coordenades();
            c->X=actual->x;
            c->Y=actual->y;
            dw->llista->prepend (c);
            actual=contornSobel->next();
         }
         
         
         anterior2=actual;
         if (actual)
            actual=contornSobel->next();
      }while (actual);

      dw->update();
   }
//   else
//      QMessageBox::critical(this, "Error !","El contorn ha de tenir mes de 3 punts per trobar-hi arestes !");
}


//La propia imatge es la k modifiquem. im es la imatge d'entrada
void Imatge::Contorn (Imatge &im){
   int i, j;   
   short actual;
   bool interior=TRUE;    //Controla k el pixel k pintem sigui el d dins la figura
   contornejada=true;
                                            
                                            
   for(i=0;i<im.imatge.dimX;i++){     //inicialitzem la imatge tota blanca
      for(j=0;j<im.imatge.dimY;j++){
         imatge.data(i,j) = 255;
      }
   }

                            
   for(j=0;j<im.imatge.dimY;j++){        //Fa el recorregut horitzontal
      actual=im.imatge.data(0,j);                   //se suposa k guarda el color del fons
      interior=TRUE;
      for(i=0;i<im.imatge.dimX;i++){
         if((im.imatge.data(i,j) != actual && (interior))){
            imatge.data(i,j) = 0;
            actual=im.imatge.data(i,j);
            interior=FALSE;
            }
         else if ((im.imatge.data(i,j) != actual) && (!interior)){
               imatge.data(i-1,j) = 0;
               actual=im.imatge.data(i,j);
               interior=TRUE;
         }
      }
   }
                          
                          
   for(i=0;i<im.imatge.dimX;i++){             //Fa el recorregut vertical
      actual=im.imatge.data(i,0);
      interior=TRUE;
      for(j=0;j<im.imatge.dimY;j++){
         if((im.imatge.data(i,j) != actual) && (interior)){
            imatge.data(i,j) = 0;
            actual=im.imatge.data(i,j);
            interior=FALSE;
            }
         else{
            if ((im.imatge.data(i,j) != actual) && (!interior)){
            imatge.data(i,j-1) = 0;
            actual=im.imatge.data(i,j);
            interior=TRUE;
            }
         }
      }
   }
                        
   ompleQImage(imatge);

}            
            
void Imatge::CercaDesti(short &actX, short &actY, short &color_contorn, short &outX, short &outY, short &primerX, short &primerY){
   bool trobat=false;
   //  8  7   6
   //  1  X  5
   //  2  3   4   ordre amb ke els hem d'agafar  el primer element

   //busca el seguent pixel de color negre
   Busca (actX, actY, outX, outY, color_contorn, trobat);

//   if (trobat && contorn->count() > 1)         //el primer no el marquem si no no acabariem
   if (contorn->count()>1)
      imatge.data(actX,actY)=MARCAT;
            
   if (!trobat){  //per tal de plegar i trobar el primer
      Busca (actX, actY, outX, outY, 1, trobat);   // 1 pq es el color del primer pixel
      if (trobat)
         return(0);
   }

   if ((actX==outX) && (actY==outY)){  //ens hem fotut en un cami sense sortida (!trobat)
      while (imatge.data(outX, outY)!=0){
            imatge.data (actX, actY)=255; //esborrem el cami dolent

           coordenades *c;

           contorn->removeLast();  //l'element afegit a la llista tambe sha d borrar
           c = contorn->getLast();
           outX=c->X;
           outY=c->Y;

            if ((abs(actX-outX) + abs(actY-outY))==1){ //estem a la creu
               contorn->perimetre-=1;
            }
            else{ //estem a les cantonades
               contorn->perimetre-=sqrt(2.0);
            }

           actX=outX;  //aixo es fa a fora la funcio pro com k hem d recular
           actY=outY;

           trobat=FALSE;
           Busca (actX, actY, outX, outY, color_contorn, trobat);

//         if (trobat){
            //per restar-ho del perimetre
//         }

      }
   }
}

                    
void Imatge::Busca (short &actX, short &actY, short &outX, short &outY, int buscat, bool &trobat){
      
      if (!trobat){
            if (imatge.data(actX-1,actY)==buscat){    //8
                     outY=actY;
                     outX=actX-1;
                     trobat=TRUE;
            }
         }
         if (!trobat){
            if (imatge.data(actX-1,actY+1)==buscat){         //1
                     outY=actY+1;
                     outX=actX-1;
                     trobat=TRUE;
            }
         }
         if (!trobat){
            if (imatge.data(actX,actY+1)==buscat){   //2
                     outY=actY+1;
                     outX=actX;
                     trobat=TRUE;
            }
         }
         if (!trobat){
            if (imatge.data(actX+1,actY+1)==buscat){   //3
                     outY=actY+1;
                     outX=actX+1;
                     trobat=TRUE;
            }
         }
         if (!trobat){
            if (imatge.data(actX+1,actY)==buscat){    //4
                     outY=actY;
                     outX=actX+1;
                     trobat=TRUE;
            }
         }
         if (!trobat){
            if (imatge.data(actX+1,actY-1)==buscat){   //5
                     outY=actY-1;
                     outX=actX+1;
                     trobat=TRUE;
            }
         }
         if (!trobat){
            if (imatge.data(actX,actY-1)==buscat){     //6
                     outY=actY-1;
                     outX=actX;
                     trobat=TRUE;
            }
         }
         if (!trobat){
            if (imatge.data(actX-1,actY-1)==buscat){   //7
                     outY=actY-1;
                     outX=actX-1;
                     trobat=TRUE;
            }
         }
} 
   
//Munta una llista anomenada contorn amb tots els punts del contorn de la figura
//i una llista anomenada contornPolar amb els vectors de cada punt respecte l'anterior
void Imatge::RecorreAntihorari(){
   int i=0, j=0, total;
   bool trobat=FALSE;
   short inicial, actX, actY, color_contorn, outX, outY, antX, antY, primerX, primerY;
   coordenades *c, *cseguent;
   ModulFase *d;
   rmImage treball;

   treball=imatge;   //guardem la imatge contornejada


   inicial=imatge.data(0,0);
   while ((j<imatge.dimY) && (!trobat)){     //Busquem el punt que te la y mes petita el de + amunt
      i=0;
      while ((i<imatge.dimX) && (!trobat)){
         if((color_contorn=imatge.data(i,j)) != inicial){
            trobat=TRUE;
            actX=primerX=i;
            actY=primerY=j;
         }
         i++;
      }
      j++;
   }

   imatge.data(actX, actY)=1; //inicialitzo el pixel inicial a 1
   
   antX=-1; //pq la primera vegada no es pensi k ja esta
   antY=-1;

   contorn = new ContornL;                            //llista de punts (x,y)
   contornPolar = new QPtrList<ModulFase>;      //llista de coordenades polars MODUL | fase

   contorn->perimetre=0;
   double arrel2=sqrt(2.0);

   if (trobat){

      do{              //montem la llista amb els punts del contorn
         c = new coordenades;
         c->X=actX;
         c->Y=actY;
         contorn->append(c);


         CercaDesti (actX, actY, color_contorn, outX, outY, primerX, primerY);

         if ((abs(actX-outX) + abs(actY-outY))==1){  //estem a la creu
            contorn->perimetre+=1;
         }
         else{ //estem a les cantonades
            contorn->perimetre+=arrel2;
         }
//         cout << "perimetre " << contorn->perimetre << endl;
         actX=outX;
         actY=outY;
      }while (imatge.data(outX, outY)!=1);
      //pinto el pixel inicial de color 1

      //posem la marca d fi a cada llista

      c= new coordenades;
      c->X=-1;
      contorn->append(c);


      total=contorn->count();
      c=contorn->first();
      cseguent=contorn->next();
                                cout << endl << total << endl;
      for (i=0; i<total-2; i++){
         d=new ModulFase;
         if ((abs(c->X-cseguent->X) + abs(c->Y-cseguent->Y))==1){  //estem a la creu
            d->modul=1;
         }
         else{ //estem a les cantonades
            d->modul=arrel2;
         }

         d->fase = atan2(-(cseguent->Y - c->Y), cseguent->X - c->X);   //Estem al 4 quadrant les Y son negatives
//         cout << "(" << cseguent->X << ", " << cseguent->Y << ")       (" <<  c->X << ", " << c->Y << ")       " << d->modul << "    " << d->fase << endl;
         contornPolar->append(d);
	   c=cseguent;
	   cseguent=contorn->next();
     }
                                                            
     c=contorn->at(total-2);
     cseguent=contorn->first();
     d=new ModulFase;
     if ((abs(c->X-cseguent->X) + abs(c->Y-cseguent->Y))==1){  //estem a la creu
        d->modul=1;
    }
    else{ //estem a les cantonades
       d->modul=arrel2;
    }

    d->fase = atan2(-(cseguent->Y - c->Y), cseguent->X - c->X);   //Estem al 4 quadrant les Y son negatives
//             cout << "(" << cseguent->X << ", " << cseguent->Y << ")       (" <<  c->X << ", " << c->Y << ")       " << d->modul << "    " << d->fase << endl;
    contornPolar->append(d);
                                                          
   
      d=new ModulFase;
      d->modul=-1;
      d->fase=-1;
      contornPolar->append(d);


      dw->llista=contorn;     //Copiem la llista "contorn" a "llista" que es amb la que treballarem
      contorn->CalculaMostreOK();   //inicialitzem la variable k conte les mostres k calen per calcular fourier
   }

}


//Els punts seleccionats del contorn son ordenats en sentit antihorari
//Els punts obtinguts mitjanant el filtre de sobel son ordenats en sentit antihorari
//No es fa servir perque aquesta opcio no es possible. O tots els punts o res (amb fourier)
void Imatge::OrdenaLlistaVertex(){
   coordenades  *c,*d, *e;
   ContornL *contornOrdenat;
   int tmp, total=0;

   contornOrdenat = new ContornL;

   if (dw->llista->count()>1){                  
      c=contorn->first();
      d=dw->llista->first();
      while ((c->X != -1) && (total < dw->llista->count()-1)){

         tmp=dw->llista->find(c);
         if (tmp != -1){ //trobat
            total++;
            e= new coordenades;
            e->X=dw->llista->current()->X;
            e->Y=dw->llista->current()->Y;
            contornOrdenat->append(e);
         }
         c=contorn->next();
      }
         
         
         
      e = new coordenades; //posem el centinella tot i k no caldria em penso
      e->X=-1;
      contornOrdenat->append(e);

      total=contorn->count(); //dw->llista->count();
      e=contorn->first();
      for (int i=0; i < total ;i++){    //borrem la llista
          delete e;
          e=contorn->next();
      }

      contorn=contornOrdenat;

   total=dw->llista->count();
   c=dw->llista->first();
   for(int i=0 ;i<total ;i++)
      c=dw->llista->next();
                          
   }                      
}
  

void Imatge::operator =(const Imatge &im){
  imatge=im.imatge;
}


//Munta una llista anomenada contorn amb tots els punts del contorn de la figura
//i una llista anomenada contornPolar amb els vectors de cada punt respecte l'anterior
double Imatge::CalculaPerimetre(){
   int i=0, j=0, totals;
   bool trobat=FALSE;
   short inicial, actX, actY, color_contorn, outX, outY, antX, antY, primerX, primerY;
   coordenades *c;
   double perimetre;



   inicial=imatge.data(0,0);
   while ((j<imatge.dimY) && (!trobat)){     //Busquem el punt que te la y mes petita el de + amunt
      i=0;
      while ((i<imatge.dimX) && (!trobat)){
         if((color_contorn=imatge.data(i,j)) != inicial){
            trobat=TRUE;
            actX=primerX=i;
            actY=primerY=j;
         }
         i++;
      }
      j++;
   }


   antX=-1; //pq la primera vegada no es pensi k ja esta
   antY=-1;

   contorn = new ContornL;                            //llista de punts (x,y)

   contorn->perimetre=0;
   double arrel2=sqrt(2.0);

   if (trobat){

      do{              //montem la llista amb els punts del contorn
         c = new coordenades;
         c->X=actX;
         c->Y=actY;
         contorn->append(c);

         CercaDesti (actX, actY, color_contorn, outX, outY, primerX, primerY);



         if ((abs(actX-outX) + abs(actY-outY))==1){//(abs(outX-outY)==1){  //estem a la creu
            contorn->perimetre+=1;
         }
         else{ //if (abs(outX-outY)==0 || abs(outX-outY)==2)    //estem a les cantonades
            contorn->perimetre+=arrel2;
         }


         actX=outX;
         actY=outY;
      }while ((primerX != outX) || (primerY != outY));


      //posem la marca d fi a cada llista

      perimetre=contorn->perimetre;

      //esborrem la llista
      totals=contorn->count();
      c=contorn->first();
      for (i=0; i<totals; i++){
         delete (c);
         c=contorn->next();
      }
      
     cout << "Perimetre val " << perimetre << endl;
      return(perimetre);
   }

}

int Imatge::carrega(){
    // canvia la imatge del widget i el seu tamany
    dw->canviaImatge(qImatge);
    dw->setGeometry(0,0,qImatge.width(),qImatge.height());
    return 1;
}



void Imatge::BuscaSobel (short &actX, short &actY, short &outX, short &outY, bool &trobat){

      if (!trobat){
            if (InfoPunt[actY*imatge.dimX+actX-1].modul !=0.0){ // imatge.data(actX-1,actY)!=0.0){    //8
                     outY=actY;
                     outX=actX-1;
                     trobat=TRUE;
            }
         }
         if (!trobat){
            if (InfoPunt[(actY+1)*imatge.dimX+actX-1].modul  !=0.0){         //1
                     outY=actY+1;
                     outX=actX-1;
                     trobat=TRUE;
            }
         }
         if (!trobat){
            if (InfoPunt[(actY+1)*imatge.dimX+actX].modul  !=0.0){   //2
                     outY=actY+1;
                     outX=actX;
                     trobat=TRUE;
            }
         }
         if (!trobat){
            if (InfoPunt[(actY+1)*imatge.dimX+actX+1].modul  !=0.0){   //3
                     outY=actY+1;
                     outX=actX+1;
                     trobat=TRUE;
            }
         }
         if (!trobat){
            if (InfoPunt[actY*imatge.dimX+actX+1].modul  !=0.0){    //4
                     outY=actY;
                     outX=actX+1;
                     trobat=TRUE;
            }
         }
         if (!trobat){
            if (InfoPunt[(actY-1)*imatge.dimX+actX+1].modul  !=0.0){   //5
                     outY=actY-1;
                     outX=actX+1;
                     trobat=TRUE;
            }
         }
         if (!trobat){
            if (InfoPunt[(actY-1)*imatge.dimX+actX].modul  !=0.0){     //6
                     outY=actY-1;
                     outX=actX;
                     trobat=TRUE;
            }
         }
         if (!trobat){
            if (InfoPunt[(actY-1)*imatge.dimX+actX-1].modul  !=0.0){   //7
                     outY=actY-1;
                     outX=actX-1;
                     trobat=TRUE;
            }
         }
}

//Munta una llista anomenada contornSobel amb tots els punts del contorn de la figura
//i el modul i la fase de sobel
void Imatge::RecorreAntihorariSobel(){
   int i=0, j=0, totals;
   bool trobat=FALSE;
   short actX, actY, color_contorn, outX, outY, antX, antY, primerX, primerY;
   ModulFasePos *c;
   rmImage treball;

   
   while ((j<imatge.dimY) && (!trobat)){     //Busquem el punt que te la y mes petita el de + amunt
      i=0;
      while ((i<imatge.dimX) && (!trobat)){
         if(InfoPunt[j*imatge.dimX+i].modul != 0.0){
            trobat=TRUE;
            actX=primerX=i;
            actY=primerY=j;
         }
         i++;
      }
      j++;
   }


   antX=-1; //pq la primera vegada no es pensi k ja esta
   antY=-1;

   if (trobat){
      contornSobel = new QPtrList<ModulFasePos>;

      do{              //montem la llista amb els punts del contorn
         trobat=false;
         c = new ModulFasePos;
         c->x=actX;
         c->y=actY;
         c->modul=InfoPunt[actY*imatge.dimX+actX].modul;
         c->fase=InfoPunt[actY*imatge.dimX+actX].fase;
         contornSobel->append (c);
         
         InfoPunt[actY*imatge.dimX+actX].modul=0.0;   //vaig borrant les fases pq no reculi

         BuscaSobel (actX, actY, outX, outY, trobat);

         actX=outX;
         actY=outY;
         
      }while (trobat); 



//   for (c=contornSobel->first(); c; c=contornSobel->next()){
//      cout <<  c->x << ", " << c->y << "    " << c->modul << "   "  << c->fase << endl;
//   }
   }
}
