/***************************************************************************
                          imatge.h  -  description
                             -------------------
    begin                : mar oct 15 2002
    copyright            : (C) 2002 by root

 ***************************************************************************/

#ifndef IMATGE_H
#define IMATGE_H
//#define VISUAL

#define VIEW_IMAGE_ON_LOAD_X  800
#define VIEW_IMAGE_ON_LOAD_Y  600

//#include <imatgeinfo.h>
#include <qstring.h>
#include <qimage.h>
#include "caract/rmlib/rmimage/rmimage.h"
#include <qmsgbox.h>
#include "caract/Zoom/zoom.h"

#include "docwidget.h"
#include "contornl.h"


typedef struct{
                           double modul;
                           double fase;
                           }ModulFase;

typedef struct{
                           double modul;
                           double fase;
                           int x;
                           int y;
                           }ModulFasePos;

class Imatge{
public: 

  Imatge();
  ~Imatge();
  /** obre una imatge */
  void openImatge(const QString &fileName);
  /** tanca una imatge */
  void closeImatge();
  QImage getImatgeQt();
  char * qStrToChar(const QString &fileName);
  int ompleQImage(rmImage nimg);
  int ompleQImage();
  int ompleQImage(QImage &desti);
  int height() { return imatge.dimY;};
  int width() { return imatge.dimX;};
  void escalaGris();
  void binaritza(int llindar);
  ModulFase* sobel(rmImage &im);
  void operator =(const Imatge &im);
  double CalculaPerimetre();
  int carrega();
  
  void MontaLlistaSobel ();
  void RecorreAntihorariSobel();
  void BuscaSobel (short &actX, short &actY, short &outX, short &outY,  bool &trobat);   //busca al voltant del pixel



  void CercaVertex (double);      //busca els vertex de la figura
  void Contorn (Imatge &);                           //retorna una Imatge amb el contorn duna figura
  void RecorreAntihorari();               //obte tot el contorn de la figura

  void OrdenaLlistaVertex();           //ordenas el subconjunt de punts del contorn de manera antihorari
  void Busca (short &actX, short &actY, short &outX, short &outY, int buscat, bool &trobat);   //busca al voltant del pixel



  
public:
  QImage qImatge;
  rmImage imatge;
  Zoom zm;
  DocWidget *dw;

  ModulFase *InfoPunt;
  ContornL *contorn;                                       //llista encadenada amb els punts del contorn
  QPtrList <ModulFase> *contornPolar;            //llista dels punts del contorn en forma polar
  QPtrList <ModulFasePos> *contornSobel;     //llista amb els valors de sobel unicament del contorn
  short estat;                                                    // indica els processos que s'han aplicat a aquesta imatge
  bool contornejada;                                         //per saber si ja hem extret el contorn de la imatge  

private:
   void CercaDesti(short &actX, short &actY, short &color_contorn, short &outX, short &outY, short &PrimerX, short &PrimerY);

};

#endif
