/***************************************************************************
                          rmmatrix3d.h  -  description
                             -------------------
    begin                : Wed Jun 12 2002
    copyright            : (C) 2002 by Robert Marti
    email                : robert@localhost.localdomain
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef RMMATRIX3D_H
#define RMMATRIX3D_H

/**
	Generic 3D Matrix class
  *@author Robert Marti
  */


template<class T>
class rmMatrix3d{
private:
	T *data;
public:
	int dimX,dimY,dimZ;
	int orgX, orgY, orgZ;

public:
	rmMatrix3d();
	/** Matrix of dimensions 0..x-1, 0..y-1, 0..z-1 */
	rmMatrix3d(int x,int y,int z);
	/** Matrix of dimensions ox..x-1, oy..y-1, oz..z-1 */
	rmMatrix3d(int ox,int oy,int oz,int nx,int ny,int nz);
	/** Copy constructor */
	rmMatrix3d(const rmMatrix3d<T> &);

	~rmMatrix3d();
	T & operator() (int x, int y, int z);
	const T & operator() (int x, int y, int z) const;
	void operator=(const rmMatrix3d<T> &);
	void resize(int,int,int);
	void resize(int,int,int,int,int,int);
	void resize(int *);
	void printInfo();

private:

 	void allocateMatrix();
	void deleteMatrix();
	
};

// done this for compilation using makefiles...
#include "rmmatrix3d.cpp"
#endif 
