/***************************************************************************
                          rmvector.h  -  description
                             -------------------
    begin                : Wed Jun 12 2002
    copyright            : (C) 2002 by Robert Marti
    email                : robert@localhost.localdomain
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef RMVECTOR_H
#define RMVECTOR_H

/**
	Generic vector class
  *@author Robert Marti
  */


template<class T>
class rmVector{
private:
	T *data;
public:
	int dimX;

public:
	/** Creates an empty vector */
	rmVector();
	/** Creates a vector of size n (0..n-1) */
	rmVector(int n);
 	/** Copy constructor */
	rmVector(const rmVector<T> &);

	~rmVector();
	T & operator() (int x);
	const T & operator() (int x) const;
	void operator=(const rmVector<T> &);
  void resize(int);
	void printInfo();

	friend rmVector<T> operator* <>(const rmVector<T> &,const rmVector<T> &);
	friend rmVector<T> operator+ <>(const rmVector<T> &,const rmVector<T> &);
	friend rmVector<T> operator- <>(const rmVector<T> &,const rmVector<T> &);

	friend rmVector<T> operator* <>(double,const rmVector<T> &);
	friend rmVector<T> operator+ <>(double,const rmVector<T> &);
	friend rmVector<T> operator- <>(double,const rmVector<T> &);
	friend rmVector<T> operator* <>(const rmVector<T> &,double);
	friend rmVector<T> operator+ <>(const rmVector<T> &,double);
	friend rmVector<T> operator- <>(const rmVector<T> &,double);

private:

 	void allocateVector();
	void deleteVector();
	
};

// done this for compilation using makefiles...
#include "rmvector.cpp"
#endif
