/***************************************************************************
                          rmcomat.h  -  description
                             -------------------
    begin                : Thu Jul 4 2002
    copyright            : (C) 2002 by Robert Marti
    email                : robertmarti@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef RMCOMAT_H
#define RMCOMAT_H


/**Class for the computation of grey-level co-occurence matrices (GLCM) between images.
  *@author Robert Marti
  */
#include "caract/rmlib/rmimage/rmimage.h"

class rmComat{
private:
	int N,trans,div;
	double angle,NP;
public:
	double ****c,**ca,**cb;

public:
	/** Constructor using a int grey levels */
	rmComat(int);
	rmComat();
	~rmComat();
	/** Compute the GLCM between two images at distance int and
	angle double (in radiands)
	 */

	void calc(const rmImage &,const rmImage &,int,double);
	/** Memmory assigment for the GLCM matrix, used by constructor */
	void init(int);
	/** Reset the GLCM structure */
	void reset();
	/** Normalise positions of the GLCM */	
	void normalise();
	/** Calculate marginal distributions*/
	void calcMarginal();
	/** Add a value to the GLCM matrix */
	void add(int,int,int,int,double);
};

#endif
