/***************************************************************************
                          rmentropy.cpp  -  description
                             -------------------
    begin                : Fri Jul 5 2002
    copyright            : (C) 2002 by Robert Marti
    email                : robertmarti@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "rmentropy.h"
#include "caract/rmlib/rmimage/rmhistogram.h"
#include <math.h>

rmEntropy::rmEntropy()
{
}

rmEntropy::~rmEntropy()
{
}

double rmEntropy::h(double s,  rmImage & A, rmImage &B)
{
	rmHistogram p(256);
	double res=0.0;
        int i;

	A.subtract(s,B);
	p.create(A);
	for (i=0;i<256;i++)
	{
		if (p.readNorm(i)!=0)
			res += p.readNorm(i)*log10(p.readNorm(i));
	}
	return -res;
}
double rmEntropy::eval(rmImage &A, rmImage &B)
{
	double s,step,Hmin,smin;
	rmImage Ak;

	Ak=A;
	s=0.0;	
	step = 1.0/100.0;
	smin=1.0;
	Hmin=h(smin,Ak,B);
	/* Commented, just doing once smin = 1...
	for (i=0;i<=100;i++)
	{
		if (H(s,Ak,B) < Hmin)
		{
			Hmin=H(s,Ak,B);
			smin=s;
		}
		s+=step;
		Ak=A;
	}	
	cout << "smin " <<smin<<endl;
	*/
	return Hmin;
}

