/***************************************************************************
                          rmmutual.h  -  description
                             -------------------
    begin                : Thu Jul 4 2002
    copyright            : (C) 2002 by Robert Marti
    email                : robertmarti@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef RMMI_H
#define RMMIIH

#include "caract/rmlib/rmimage/rmimage.h"
#include "caract/rmlib/rmimage/rmhistogram2d.h"
#include "caract/rmlib/rmsimilarity/rmcomat.h"

/**Compute Mutual Information between two images, using 2d histograms or
	*GLCM
  *@author Robert Marti
  */
class rmMI
{

private:
	int N;
public:
	rmMI(int);
	~rmMI();
	/** Compute mutual information between two images */
	double eval(const rmImage &, const rmImage &);
	/** Compute mutual information between two 3d images */
	double eval(const rmImage3d &A, const rmImage3d &B);
	/** Compute mutual information from a 2d histogram */
	double eval_H(rmHistogram2d &);

	/** Compute mutual information from a GLCM*/
	double evalCM_H(rmComat &);
	/** Compute mutual information from images using a GLCM*/
	double evalCM(const rmImage &,const rmImage &,int,int);
	double evalCM2(const rmImage &,const rmImage &);
	double evalCM3(const rmImage &,const rmImage &);
	double evalCM4A(const rmImage &,const rmImage &);
	double evalCM4B(const rmImage &,const rmImage &);
	double evalCMS5(const rmImage &,const rmImage &);
};
#endif
