#ifndef UTILS_H
#define UTILS_H

#include <iostream.h>
#include <stdlib.h>
#include "caract/rmlib/rmmatrix/rmvector.h"
//#include "Rad/Vector.h"
//#include "Rad/List.h"

#define TRUE 1
#define FALSE 0
void error (char *str);

class rmUtils {

rmUtils() {};
~rmUtils() {};
public:
static double sign(double a, double b);
static double fmax(double maxarg1, double maxarg2);
static double sqr(double x) { return x*x; }

};

/** Linear correlation of set of 2d points*/
template <class T>
void pearsn (rmVector<T> x, rmVector<T> y, unsigned long n,
	float &r,float &prob,float &z);

/** Given an array returns its mean ave, average deviation adev, standard
  deviation sdev, variance var, skewness skew and kurtosis curt.*/
template <class T>
void moment ( rmVector<T> data, int n, float &ave, float &adev, float &sdev,
	float &var, float &skew, float &curt); 

void moment ( long * data, int n, float &ave, float &adev, float &sdev,
	float &var, float &skew, float &curt); 

//void moment ( RD_List<int> data, int n, double &ave, double &sdev);
template <class T>
void moment ( rmVector<T> data, int n, double &ave, double &sdev);

/** Euclidean distance between two points */
double dist(double,double,double,double, double &, double&);
double dist3d(double,double,double,double,double,double,
			 double &, double&, double&);

/** Maximum and minimum value*/
int MaxVal(int x,int y);
int MinVal(int,int);
#endif
